/*
Programma maakt input-variabelen mimosis aan 
    op basis van diverse bronnen
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\ConstructPastLabInfo_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\ConstructPastLabInfo.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

DM 'Log; CLEAR; Output; Clear; ';

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
/*Voeg geobserveerde daglonen en arbeidsmarktstatus samen*/
%MACRO ForEach(EEJJ);


    /*Data RSZ*/
    PROC SORT DATA=LIB.mim2008_rszyear_&EEJJ._code;
        BY GECODEERD_INSZ;
    RUN;        
    PROC SORT DATA=LIB.mim2008_labmstatrsz_&EEJJ._code;
        BY GECODEERD_INSZ;
    RUN;        
    /*Test of een individu nog meer dan 1 keer voorkomt in het bestand arbeidsmarktstatus*/
    PROC SQL;
        CREATE TABLE COUNT_Indiv AS
        SELECT COUNT(*) AS NUM_Indiv
        FROM LIB.mim2008_labmstatrsz_&EEJJ._code
        GROUP BY GECODEERD_INSZ
        ;
    QUIT;
    PROC FREQ DATA=COUNT_Indiv;
        TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand AbmStatRSZ &EEJJ.";
        TABLES NUM_Indiv;
    RUN;

    DATA RSZ_&EEJJ.;

        MERGE LIB.mim2008_rszyear_&EEJJ._code LIB.mim2008_labmstatrsz_&EEJJ._code;
        BY GECODEERD_INSZ;
        
        LENGTH SOURCE $8;
        
        IF RSZ_LABMSTAT_PRIV_&EEJJ. EQ . THEN RSZ_LABMSTAT_PRIV_&EEJJ. = 0;
        IF RSZ_LABMSTAT_PUB_&EEJJ.  EQ . THEN RSZ_LABMSTAT_PUB_&EEJJ. = 0;  
        IF RSZ_Full_&EEJJ.          EQ . THEN RSZ_Full_&EEJJ. = 0;  
        IF RSZ_Part_&EEJJ.          EQ . THEN RSZ_Part_&EEJJ. = 0;  
        IF saljrs_&EEJJ.            EQ . THEN saljrs_&EEJJ. = 0;
        IF jrsrem_f_&EEJJ.          EQ . THEN jrsrem_f_&EEJJ. = 0;
        IF jrsrem_p_&EEJJ.          EQ . THEN jrsrem_p_&EEJJ. = 0;
        IF jrsasm_&EEJJ.            EQ . THEN jrsasm_&EEJJ. = 0; 
        IF SumSal_&EEJJ.            EQ . THEN SumSal_&EEJJ. = 0; 

        /*aan te maken variabelen*/
        ANNEE_PREST             = %eval(&EEJJ.);
        SOURCE                  = "RSZ";
        LABMSTAT_PRIV           = RSZ_LABMSTAT_PRIV_&EEJJ.;
        LABMSTAT_PUB            = RSZ_LABMSTAT_PUB_&EEJJ.;
        DAYS_FULL               = RSZ_Full_&EEJJ.;
        DAYS_PART               = RSZ_Part_&EEJJ.;
        SALJRS                  = saljrs_&EEJJ.;
        REMDAYS                 = jrsrem_f_&EEJJ. + jrsrem_p_&EEJJ.;
        ASSIMDAYS               = jrsasm_&EEJJ.;
        REMUN                   = SumSal_&EEJJ.;
        %IF &EEJJ. LT 2003 %THEN %DO;
            IF jrsrem_f_&EEJJ. EQ . THEN jrsrem_f_&EEJJ. = 0; 
            IF jrsrem_p_&EEJJ. EQ . THEN jrsrem_p_&EEJJ. = 0; 
            REMHOURS    = (jrsrem_f_&EEJJ.)*7.6 + (jrsrem_p_&EEJJ.)*3.8;
        %END;
        %ELSE %DO;
            IF jrsrem_f_&EEJJ. EQ . THEN jrsrem_f_&EEJJ. = 0; 
            IF heurpt_&EEJJ.   EQ . THEN heurpt_&EEJJ. = 0; 
            REMHOURS    = (jrsrem_f_&EEJJ.)*7.6 + heurpt_&EEJJ.;
        %END;

        KEEP GECODEERD_INSZ ANNEE_PREST SOURCE DAYS_FULL DAYS_PART LABMSTAT_PRIV LABMSTAT_PUB SALJRS REMDAYS ASSIMDAYS REMUN REMHOURS;
        
    RUN;

    /*Data RSZPPO*/
    PROC SORT DATA=LIB.mim2008_rszppoyear_&EEJJ._code;
        BY GECODEERD_INSZ;
    RUN;        
    PROC SORT DATA=LIB.mim2008_labmstatrszppo_&EEJJ._code;
        BY GECODEERD_INSZ;
    RUN;        
    /*Test of een individu nog meer dan 1 keer voorkomt in het bestand arbeidsmarktstatus*/
    PROC SQL;
        CREATE TABLE COUNT_Indiv AS
        SELECT COUNT(*) AS NUM_Indiv
        FROM LIB.mim2008_labmstatrszppo_&EEJJ._code
        GROUP BY GECODEERD_INSZ
        ;
    QUIT;
    PROC FREQ DATA=COUNT_Indiv;
        TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand AbmStatRSZPPO &EEJJ.";
        TABLES NUM_Indiv;
    RUN;

    DATA RSZPPO_&EEJJ.;

        SET LIB.mim2008_rszppoyear_&EEJJ._code LIB.mim2008_labmstatrszppo_&EEJJ._code;
        BY GECODEERD_INSZ;

        IF RSZPPO_LABMSTAT_PUB_&EEJJ.   EQ . THEN RSZPPO_LABMSTAT_PUB_&EEJJ. = 0;
        IF RSZPPO_Full_&EEJJ.           EQ . THEN RSZPPO_Full_&EEJJ. = 0;  
        IF RSZPPO_Part_&EEJJ.           EQ . THEN RSZPPO_Part_&EEJJ. = 0;  
        IF saljrs_&EEJJ.                EQ . THEN saljrs_&EEJJ. = 0;  
        IF RemunDay_&EEJJ.              EQ . THEN RemunDay_&EEJJ. = 0;
        IF AssimDay_&EEJJ.              EQ . THEN AssimDay_&EEJJ. = 0;
        IF SumSal_&EEJJ.                EQ . THEN SumSal_&EEJJ. = 0;   
        IF RemunHour_&EEJJ.             EQ . THEN RemunHour_&EEJJ. = 0;
        
        /*aan te maken variabelen*/
        ANNEE_PREST             = %eval(&EEJJ.);
        SOURCE                  = "PPO";
        LABMSTAT_PRIV           = 0;
        LABMSTAT_PUB            = RSZPPO_LABMSTAT_PUB_&EEJJ.;
        DAYS_FULL               = RSZPPO_Full_&EEJJ.;
        DAYS_PART               = RSZPPO_Part_&EEJJ.;
        SALJRS                  = saljrs_&EEJJ.;
        REMDAYS                 = RemunDay_&EEJJ.;
        ASSIMDAYS               = AssimDay_&EEJJ.;
        REMUN                   = SumSal_&EEJJ.;
        REMHOURS                = RemunHour_&EEJJ.; 

        KEEP GECODEERD_INSZ ANNEE_PREST SOURCE DAYS_FULL DAYS_PART LABMSTAT_PRIV LABMSTAT_PUB SALJRS REMDAYS ASSIMDAYS REMUN REMHOURS;

    RUN;

%MEND ForEach;
/*Voer macro uit voor alle observatiejaren RSZ en RSZPPO*/
%ForEach(2002);
%ForEach(2003);
%ForEach(2004);
%ForEach(2005);
%ForEach(2006);
%ForEach(2007);
%ForEach(2008);
/*Maak bestand met loopbaangegevens CIMIRe*/
DATA CIMIRe;
    SET LIBW.careerinfo;

    SOURCE                  = "CIMIRe";
    LABMSTAT_PRIV           = 0;
    LABMSTAT_PUB            = 0;
    DAYS_FULL               = 0;
    DAYS_PART               = 0;
    SALJRS                  = 0;    

    KEEP GECODEERD_INSZ ANNEE_PREST SOURCE DAYS_FULL DAYS_PART LABMSTAT_PRIV LABMSTAT_PUB SALJRS REMDAYS ASSIMDAYS REMUN REMHOURS;

RUN;
/*Voeg verschillende jaarbestanden samen tot n geheel dat complement vormt met andere cimire-gegevens*/
%MACRO COMBIN;
DATA WageInfo_Basis;
    
    SET
    %DO I = 2002 %to 2008;
        RSZ_&I.
        RSZPPO_&I.
    %END;
    CIMIRe
    ;
    
RUN;
/*Bereken gemiddelde waarde en standaardafwijking van gepresteerde dagen en uren*/
/*bereken hier op basis van alle beschikbare gevallen*/
PROC MEANS DATA=WageInfo_Basis(WHERE=(SALJRS<>0));
    TITLE "Gemiddeld geobserveerde dagen en uren";
    VAR     REMDAYS REMHOURS;
    OUTPUT  OUT=OutMean_Tot
            MEAN(REMDAYS)      = Mean_REMDAYS
            STD(REMDAYS)       = STD_REMDAYS
            MEAN(REMHOURS)     = Mean_REMHOURS
            STD(REMHOURS)      = STD_REMHOURS
    ;            
RUN;
/*bereken bijkomende saljrs concepten voor bepaalde gevallen*/
DATA WageInfo_Basis;
    
    SET WageInfo_Basis;
    IF _N_ EQ 1 THEN SET OutMean_Tot;

    IF REMDAYS                EQ .  THEN REMDAYS                 = 0; 
    IF REMHOURS               EQ .  THEN REMHOURS                = 0; 

    /*Construeer bijkomende SALJRS concepten*/
    /*Concept 1*/
    SALJRS_CONCEPT1 = 0;
    IF SALJRS NE .                                                                                      THEN SALJRS_CONCEPT1 = SALJRS;
    /*Concept 2: op basis van dagen maar enkel voor gevallen met waarde binnen bepaalde grenzen*/
    SALJRS_CONCEPT2 = 0;
    IF REMDAYS LT (52*6) AND REMDAYS GT (Mean_REMDAYS-2*STD_REMDAYS) AND REMDAYS GT (4*6)               THEN SALJRS_CONCEPT2 = REMUN/REMDAYS;
    /*Concept 3: op basis van uren maar enkel voor gevallen met waarde binnen bepaalde grenzen*/
    SALJRS_CONCEPT3 = 0;
    IF REMHOURS LT (52*6*7.6) AND REMHOURS GT (Mean_REMHOURS-2*STD_REMHOURS) AND REMHOURS GT (4*6*7.6)  THEN SALJRS_CONCEPT3 = (REMUN*7.6)/REMHOURS;

RUN;
%MEND COMBIN;
%COMBIN;
/*Lees herwaarderingscofficinten in*/
/*prijsindexen*/
DATA Index;
    INPUT @1 ANNEE_PREST 4. @11 WAGE_INDEX 10.6;
    DATALINES;
1940      6.405881
1941      6.405881
1942      6.405881
1943      6.405881
1944      6.405881
1945      6.405881
1946      6.405881
1947      6.405881
1948      6.405881
1949      6.405881
1950      6.405881
1951      6.405881
1952      6.405881
1953      6.405881
1954      6.405881
1955      6.255990
1956      6.111607
1957      5.923573
1958      5.848569
1959      5.777393
1960      5.760077
1961      5.703567
1962      5.624690
1963      5.506432
1964      5.286357
1965      5.079292
1966      4.876030
1967      4.741017
1968      4.612922
1969      4.446323
1970      4.279467
1971      4.101257
1972      3.889245
1973      3.636347
1974      3.227094
1975      2.861783
1976      2.621545
1977      2.447630
1978      2.342965
1979      2.242618
1980      2.102809
1981      1.953805
1982      1.796984
1983      1.669099
1984      1.600875
1985      1.557084
1986      1.537166
1987      1.543957
1988      1.526233
1989      1.480237
1990      1.430892
1991      1.386377
1992      1.353496
1993      1.317196
1994      1.306018
1995      1.285983
1996      1.265062
1997      1.248598
1998      1.232904
1999      1.221376
2000      1.198833
2001      1.166827
2002      1.152043
2003      1.132669
2004      1.111100
2005      1.081046
2006      1.059012
2007      1.027111
2008      1.000000
   ;
RUN;
PROC SORT DATA=Index;
    BY ANNEE_PREST;
RUN;    
PROC PRINT DATA=Index;
RUN;
/*Voeg index toe aan bestand met loon-info en druk concepten uit in gelijke prijzen*/
PROC SORT DATA=WageInfo_Basis;
    BY ANNEE_PREST;
RUN;
DATA WageInfo_Basis;
    MERGE WageInfo_Basis Index;
    BY ANNEE_PREST;
    
    SALJRS_CONCEPT1 = SALJRS_CONCEPT1*WAGE_INDEX;
    SALJRS_CONCEPT2 = SALJRS_CONCEPT2*WAGE_INDEX;
    SALJRS_CONCEPT3 = SALJRS_CONCEPT3*WAGE_INDEX;

RUN;
PROC SORT DATA=WageInfo_Basis;
    BY GECODEERD_INSZ ANNEE_PREST SOURCE;
RUN;
/*Selecteer voor ieder individu laatst geobserveerde arbeidsmarkt-gegevens in functie van jaar en bron*/
DATA WageInfo;
    SET WageInfo_Basis;
    BY GECODEERD_INSZ ANNEE_PREST SOURCE;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC FREQ DATA=WageInfo;
    TITLE "Verdeling herkomstbron en observatiejaar basisgegevens";
    TABLES ANNEE_PREST SOURCE;
RUN;    
/*Maak bijkomende dagloon-variabele aan die observaties bevat indien laatst geobserveerde dagloon nul is*/
DATA WageInfo_SALJRS1;
    SET WageInfo_Basis(KEEP=GECODEERD_INSZ ANNEE_PREST SOURCE SALJRS_CONCEPT1 WHERE=(SALJRS_CONCEPT1<>0));
    BY GECODEERD_INSZ ANNEE_PREST SOURCE;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
DATA WageInfo_SALJRS2;
    SET WageInfo_Basis(KEEP=GECODEERD_INSZ ANNEE_PREST SOURCE SALJRS_CONCEPT2 WHERE=(SALJRS_CONCEPT2<>0));
    BY GECODEERD_INSZ ANNEE_PREST SOURCE;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
DATA WageInfo_SALJRS3;
    SET WageInfo_Basis(KEEP=GECODEERD_INSZ ANNEE_PREST SOURCE SALJRS_CONCEPT3 WHERE=(SALJRS_CONCEPT3<>0));
    BY GECODEERD_INSZ ANNEE_PREST SOURCE;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
/*selecteer laatst geobserveerde dagloon*/
DATA DAYWAGE;
    MERGE
    WageInfo(KEEP=GECODEERD_INSZ ANNEE_PREST SOURCE SALJRS in=InA RENAME=(ANNEE_PREST=ANNEE_PREST_B SOURCE = SOURCE_B SALJRS = SALJRS_CONCEPTB))
    WageInfo_SALJRS1(RENAME=(ANNEE_PREST=ANNEE_PREST_1 SOURCE = SOURCE_1))
    WageInfo_SALJRS2(RENAME=(ANNEE_PREST=ANNEE_PREST_2 SOURCE = SOURCE_2))
    WageInfo_SALJRS3(RENAME=(ANNEE_PREST=ANNEE_PREST_3 SOURCE = SOURCE_3))
    ;
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*initialiseer aan te maken variabelen en zet missings op nul*/
    LENGTH SOURCE_LAST $8;
    SALJRS_LAST         = 0;
    ANNEE_PREST_LAST    = 0;
    SOURCE_LAST         = "Onbekend";
    
    /*initialiseer ontbrekende waarden*/
    IF SALJRS_CONCEPTB  EQ .    THEN SALJRS_CONCEPTB    = 0;
    IF SALJRS_CONCEPT1  EQ .    THEN SALJRS_CONCEPT1    = 0;
    IF SALJRS_CONCEPT2  EQ .    THEN SALJRS_CONCEPT2    = 0;
    IF SALJRS_CONCEPT3  EQ .    THEN SALJRS_CONCEPT3    = 0;
    IF ANNEE_PREST_B    EQ .    THEN ANNEE_PREST_B      = 0;
    IF ANNEE_PREST_1    EQ .    THEN ANNEE_PREST_1      = 0;
    IF ANNEE_PREST_2    EQ .    THEN ANNEE_PREST_2      = 0;
    IF ANNEE_PREST_3    EQ .    THEN ANNEE_PREST_3      = 0;
    IF SOURCE_B         EQ ""   THEN SOURCE_B           = "Onbekend";
    IF SOURCE_1         EQ ""   THEN SOURCE_1           = "Onbekend";
    IF SOURCE_2         EQ ""   THEN SOURCE_2           = "Onbekend";
    IF SOURCE_3         EQ ""   THEN SOURCE_3           = "Onbekend";
    
    /*indien beschikbaar concept 1*/
    SALJRS_LAST         = SALJRS_CONCEPT1;
    ANNEE_PREST_LAST    = ANNEE_PREST_1;
    SOURCE_LAST         = SOURCE_1;
    /*indien niet beschikbaar concept 2*/
    IF SALJRS_LAST EQ 0 THEN DO;
        SALJRS_LAST         = SALJRS_CONCEPT2;
        ANNEE_PREST_LAST    = ANNEE_PREST_2;
        SOURCE_LAST         = SOURCE_2;
    END;        
    /*indien niet beschikbaar concept 3*/
    IF SALJRS_LAST EQ 0 THEN DO;
        SALJRS_LAST         = SALJRS_CONCEPT3;
        ANNEE_PREST_LAST    = ANNEE_PREST_3;
        SOURCE_LAST         = SOURCE_3;
    END;        
    /*indien niet beschikbaar concept uit basisfile: vermoedelijk ook een nulwaarde maar met aanduiding bron*/
    IF SALJRS_LAST EQ 0 THEN DO;
        SALJRS_LAST         = SALJRS_CONCEPTB;
        ANNEE_PREST_LAST    = ANNEE_PREST_B;
        SOURCE_LAST         = SOURCE_B;
    END;        
    
RUN;
PROC FREQ DATA=DAYWAGE;
    TITLE "Verdeling herkomstbron en observatiejaar laatste dagloon voor correctie outliers";
    TABLES ANNEE_PREST_LAST SOURCE_LAST;
RUN;    
/*Bereken gemiddelde waarde en standaardafwijking laatste dagloon*/
PROC MEANS DATA=DAYWAGE(WHERE=(SALJRS_CONCEPT1<>0));
    TITLE "Gemiddeld geobserveerd daginkomen";
    VAR     SALJRS_CONCEPT1;
    OUTPUT  OUT=OutMean_Tot
            MEAN(SALJRS_CONCEPT1)     = Mean_SALJRS_CONCEPT1
            STD(SALJRS_CONCEPT1)      = STD_SALJRS_CONCEPT1
    ;            
RUN;
/*corrigeer outliers*/
DATA DAYWAGE;
    SET DAYWAGE;
    IF _N_ EQ 1 THEN SET OutMean_Tot;

    /*initialiseer aan te maken variabelen en zet missings op nul*/
    LENGTH SOURCE_LAST_CORR $8;
    SALJRS_LAST_CORR         = 0;
    ANNEE_PREST_LAST_CORR    = 0;
    SOURCE_LAST_CORR         = "Missing";
    
    /*initialiseer ontbrekende waarden*/
    IF SALJRS_LAST         EQ .     THEN SALJRS_LAST       = 0;
    IF ANNEE_PREST_LAST    EQ .     THEN ANNEE_PREST_LAST  = 0;
    IF SOURCE_LAST         EQ ""    THEN SOURCE_LAST       = "Onbekend";

    /*correctie is in regel gelijk aan reeds beschikbaar concept*/
    SALJRS_LAST_CORR         = SALJRS_LAST;
    ANNEE_PREST_LAST_CORR    = ANNEE_PREST_LAST;
    SOURCE_LAST_CORR         = SOURCE_LAST;
    /*tenzij het een outlier is en concept 2 geen outlier is*/
    IF SALJRS_LAST_CORR GT (Mean_SALJRS_CONCEPT1+2*STD_SALJRS_CONCEPT1) AND SALJRS_CONCEPT2 LT (Mean_SALJRS_CONCEPT1+2*STD_SALJRS_CONCEPT1) AND SALJRS_CONCEPT2 GT 0 THEN DO;
        SALJRS_LAST_CORR         = SALJRS_CONCEPT2;
        ANNEE_PREST_LAST_CORR    = ANNEE_PREST_2;
        SOURCE_LAST_CORR         = SOURCE_2;
    END;        
    /*tenzij het nog een outlier is en concept 3 geen outlier is*/
    IF SALJRS_LAST_CORR GT (Mean_SALJRS_CONCEPT1+2*STD_SALJRS_CONCEPT1) AND SALJRS_CONCEPT3 LT (Mean_SALJRS_CONCEPT1+2*STD_SALJRS_CONCEPT1) AND SALJRS_CONCEPT3 GT 0 THEN DO;
        SALJRS_LAST_CORR         = SALJRS_CONCEPT3;
        ANNEE_PREST_LAST_CORR    = ANNEE_PREST_3;
        SOURCE_LAST_CORR         = SOURCE_3;
    END;        
    /*tenzij het nog een outlier is en het concept in basisfile geen outlier is*/
    IF SALJRS_LAST_CORR GT (Mean_SALJRS_CONCEPT1+2*STD_SALJRS_CONCEPT1) AND SALJRS_CONCEPTB LT (Mean_SALJRS_CONCEPT1+2*STD_SALJRS_CONCEPT1) AND SALJRS_CONCEPTB GT 0 THEN DO;
        SALJRS_LAST_CORR         = SALJRS_CONCEPTB;
        ANNEE_PREST_LAST_CORR    = ANNEE_PREST_B;
        SOURCE_LAST_CORR         = SOURCE_B;
    END;        
    /*indien nu nog steeds outlier dan aftoppen*/
    IF SALJRS_LAST_CORR GT (Mean_SALJRS_CONCEPT1+2*STD_SALJRS_CONCEPT1) THEN DO;
        SALJRS_LAST_CORR         = Mean_SALJRS_CONCEPT1+2*STD_SALJRS_CONCEPT1;
        ANNEE_PREST_LAST_CORR    = 0;
        SOURCE_LAST_CORR         = "Aftop";
    END;     
    
    KEEP GECODEERD_INSZ SALJRS_LAST ANNEE_PREST_LAST SOURCE_LAST SALJRS_LAST_CORR ANNEE_PREST_LAST_CORR SOURCE_LAST_CORR;

RUN;    
PROC FREQ DATA=DAYWAGE;
    TITLE "Verdeling herkomstbron en observatiejaar laatste dagloon na correctie outliers";
    TABLES ANNEE_PREST_LAST_CORR SOURCE_LAST_CORR;
RUN;    
/*Breng gegevens op niveau totale populatie*/
DATA LIBW.MIM2008_PastLabInfo;
    MERGE TOTPOP(in=InA) WageInfo(in=InB) DAYWAGE;
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InPastLabInfo = 0;
    IF InB EQ 1 THEN InPastLabInfo = 1;
    LABEL InPastLabInfo = "Individu aanwezig in bestand met historische arbeidsmarktinfo";

    /*Vul ontbrekende labels in voor te weerhouden variabelen*/
    LABEL ANNEE_PREST                 = "Prestatiejaar van basisgegevens";                                                                    
    LABEL ANNEE_PREST_LAST            = "Prestatiejaar van laatste jaar met positieve waarde dagloon";                                                                    
    LABEL ANNEE_PREST_LAST_CORR       = "Prestatiejaar van laatste jaar met positieve waarde gecorrigeerd dagloon";                                                                    
    LABEL DAYS_FULL                   = "Aantal dagen voltijds in basisbestand";                                                                    
    LABEL DAYS_PART                   = "Aantal dagen deeltijds in basisbestand";                                                                    
    LABEL LABMSTAT_PRIV               = "Arbeidsmarkt-statuut private sector";                                                                    
    LABEL LABMSTAT_PUB                = "Arbeidsmarkt-statuut publieke sector";                                                                    
    LABEL SALJRS                      = "Dagloon in basisgegevens (in prijzen van 2008)";                                                                    
    LABEL SALJRS_LAST                 = "Dagloon in laatste jaar met positieve waarde dagloon (in prijzen van 2008)";                                                                    
    LABEL SALJRS_LAST_CORR            = "Dagloon in laatste jaar met positieve waarde gecorrigeerd dagloon (in prijzen van 2008)";                                                                    
    LABEL SOURCE                      = "Bron basisgegevens";                                                                    
    LABEL SOURCE_LAST                 = "Bron laatste positieve waarde dagloon";                                                                    
    LABEL SOURCE_LAST_CORR            = "Bron laatste positieve waarde gecorrigeerd dagloon";                                                                    
    LABEL REMUN                       = "Totaal inkomen uit arbeid (in prijzen van 2008)"; 
    
    /*Vul missing values in*/
    IF WAGE_INDEX             EQ .  THEN WAGE_INDEX              = 1; 
    IF ANNEE_PREST            EQ .  THEN ANNEE_PREST             = 0; 
    IF ANNEE_PREST_LAST       EQ .  THEN ANNEE_PREST_LAST        = 0; 
    IF ANNEE_PREST_LAST_CORR  EQ .  THEN ANNEE_PREST_LAST_CORR   = 0; 
    IF ASSIMDAYS              EQ .  THEN ASSIMDAYS               = 0; 
    IF DAYS_FULL              EQ .  THEN DAYS_FULL               = 0; 
    IF DAYS_PART              EQ .  THEN DAYS_PART               = 0; 
    IF LABMSTAT_PRIV          EQ .  THEN LABMSTAT_PRIV           = 0; 
    IF LABMSTAT_PUB           EQ .  THEN LABMSTAT_PUB            = 0; 
    IF REMDAYS                EQ .  THEN REMDAYS                 = 0; 
    IF REMHOURS               EQ .  THEN REMHOURS                = 0; 
    IF REMUN                  EQ .  THEN REMUN                   = 0;                    
    IF SALJRS                 EQ .  THEN SALJRS                  = 0; 
    IF SALJRS_LAST            EQ .  THEN SALJRS_LAST             = 0; 
    IF SALJRS_LAST_CORR       EQ .  THEN SALJRS_LAST_CORR        = 0; 
    IF SOURCE                 EQ "" THEN SOURCE                  = "Onbekend";
    IF SOURCE_LAST            EQ "" THEN SOURCE_LAST             = "Onbekend";
    IF SOURCE_LAST_CORR       EQ "" THEN SOURCE_LAST_CORR        = "Onbekend";

    /*Druk niet genfleerde gegevens uit in prijzen van 2008*/
    SALJRS = SALJRS*WAGE_INDEX;
    REMUN  = REMUN*WAGE_INDEX;

    KEEP
    GECODEERD_INSZ
    ANNEE_PREST                 
    ANNEE_PREST_LAST            
    ANNEE_PREST_LAST_CORR       
    ASSIMDAYS                   
    DAYS_FULL                   
    DAYS_PART                   
    InPastLabInfo               
    LABMSTAT_PRIV               
    LABMSTAT_PUB                
    REMDAYS                     
    REMHOURS                    
    REMUN                                               
    SALJRS                      
    SALJRS_LAST                 
    SALJRS_LAST_CORR            
    SOURCE                      
    SOURCE_LAST                 
    SOURCE_LAST_CORR            
    ;

RUN;    
PROC CONTENTS DATA=LIBW.MIM2008_PastLabInfo;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
