/*Bepaal log-file en maak file leeg voor volgende run*/
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateCareerInfoCESO_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateCareerInfoCESO.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

DM 'Log; CLEAR; Output; Clear; ';

/*Define library with latest version of CIMIRe data*/
LIBNAME CIMIRE 'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBCAR 'C:\My\teksten\MIMS2009\DataFS\MANIP\';
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                        STAP 1.
Reductie van het aantal arbeidsdagen en gelijkgestelde dagen
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/************Constructie GEPRESTEERDE DAGEN*****************/
DATA Prest_Dagen;
    SET 
    CIMIRE.mim2008_cimire_t22_2001_code(RENAME=(remun_eur_class=remun_eur))
    CIMIRE.mim2008_cimire_t25_2001_code(RENAME=(remun_eur_class=remun_eur))
    LIBCAR.Final_FILE23
    LIBCAR.Final_FILE24
    ;
    /*Initialiseer aan te maken variabelen*/
    VTEarbeid = .; /*gepresteerde dagen omgezet in voltijdse equivalenten*/
    LABEL VTEarbeid = "Gepresteerde dagen omgezet in voltijdse equivalenten";
    /*--------------------------------------------------------GROEP 1.------------------------------*/
    /*Groep 1: Vr 1978: overname AD/Vanaf 1978 tot en met 1991: overname AD na toets/Vanaf 1990 met uren en maatman: uren omzetten in dagen/Vanaf 1992 zonder uren: overname AD (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("000" "003" "019" "022" "028" "030" "035" "036" "150" "166" "167" "171" "172" "178" "179" "184" "185" "189" "302" "402" "448" "453") THEN DO;
        /*1)We nemen aan dat het aantal arbeidsdagen vermeld op een lijn vr 1978 in voltijdse dagequivalenten is uitgedrukt.*/
        IF annee_prest LT 1978 THEN DO; 
            VTEarbeid = jour_remun;
        END;
        /*2)Maatman en uren: Het aantal arbeidsdagen vermeld op een lijn na 1989 wordt, bij aanwezigheid van arbeidsuren 
        en temps_part_hr gegevens, vastgesteld aan de hand van de gepresteerde uren en de verhouding ten opzichte 
        van de voltijdse temps_part_hr.*/
        IF annee_prest GT 1989 AND temps_part_hr GT 0 THEN DO;
            IF temps_part GT 0 THEN DO;
                temps_part_hrjaar = temps_part_hr*52;
                VTEarbeid = (temps_part/temps_part_hrjaar)*312;
            END;
            ELSE DO;
                temps_part_hrjaar = temps_part_hr*52;
                temps_part = jour_remun*(temps_part_hr/5);
                VTEarbeid = (temps_part/temps_part_hrjaar)*312;
            END;
        END;
        /*3)Voor de periode 1978 tot en met 1991 wordt loontoets gebruikt in geval van niet deeltijdse arbeid*/
        IF annee_prest GE 1978 and annee_prest LE 1991 and temps_part_hr EQ 0 THEN DO;
            /* Voor arbeiders*/
            IF Code_carriere IN ("000" "003" "019" "022" "028" "030" "035" "036" "302") THEN DO;
                IF annee_prest EQ 1978 THEN DO;
                    VTE = (remun_eur/5964.6156)*312;
                END;
                IF annee_prest EQ 1979 THEN DO;
                    VTE = (remun_eur/6085.6868)*312;
                END;
                IF annee_prest EQ 1980 THEN DO;
                    VTE = (remun_eur/6456.0398)*312;
                END;
                IF annee_prest EQ 1981 THEN DO;
                    VTE = (remun_eur/6988.5151)*312;
                END;
                IF annee_prest EQ 1982 THEN DO;
                    VTE = (remun_eur/7978.5027)*312;
                END;
                IF annee_prest EQ 1983 THEN DO;
                    VTE = (remun_eur/8809.0451)*312;
                END;
                IF annee_prest EQ 1984 THEN DO;
                    VTE = (remun_eur/9348.3623)*312;
                END;
                IF annee_prest EQ 1985 THEN DO;
                    VTE = (remun_eur/9535.1749)*312;
                END;
                IF annee_prest IN (1986 1987 1988) THEN DO;
                    VTE = (remun_eur/9920.4014)*312;
                END;
                IF annee_prest EQ 1989 THEN DO;
                    VTE = (remun_eur/10331.5080)*312 ;
                END;
                IF annee_prest EQ 1990 THEN DO;
                    VTE = (remun_eur/10538.2512)*312;
                END;
                IF annee_prest EQ 1991 THEN DO;
                    VTE = (remun_eur/10936.6365)*312;
                END;
            END;
            /*Voor bedienden*/
            IF Code_carriere IN ("150" "166" "167" "171" "172" "178" "179" "184" "185" "189" "402" "448" "453") THEN DO;
                IF annee_prest EQ 1978 THEN DO;
                    VTE = (remun_eur/5964.6156)*300;
                END;
                IF annee_prest EQ 1979 THEN DO;
                    VTE = (remun_eur/6085.6868)*300;
                END;
                IF annee_prest EQ 1980 THEN DO;
                    VTE = (remun_eur/6456.0398)*300;
                END;
                IF annee_prest EQ 1981 THEN DO;
                    VTE = (remun_eur/6988.5151)*300;
                END;
                IF annee_prest EQ 1982 THEN DO;
                    VTE = (remun_eur/7978.5027)*300;
                END;
                IF annee_prest EQ 1983 THEN DO;
                    VTE = (remun_eur/8809.0451)*312;
                END;
                IF annee_prest EQ 1984 THEN DO;
                    VTE = (remun_eur/9348.3623)*312;
                END;
                IF annee_prest EQ 1985 THEN DO;
                    VTE = (remun_eur/9535.1749)*312;
                END;
                IF annee_prest IN (1986 1987 1988) THEN DO;
                    VTE = (remun_eur/9920.4014)*312;
                END;
                IF annee_prest EQ 1989 THEN DO;
                    VTE = (remun_eur/10331.5080)*312 ;
                END;
                IF annee_prest EQ 1990 THEN DO;
                    VTE = (remun_eur/10538.2512)*312;
                END;
                IF annee_prest EQ 1991 THEN DO;
                    VTE = (remun_eur/10936.6365)*312;
                END;
            END;
            /*Opgelet: De toepassing van de VTE regel mag er niet toe leiden dat het 
            aantal VTE groter is dan het op de loopbaan ingeschreven aantal arbeidsdagen*/
            IF VTE LE jour_remun and VTE NE . THEN DO;
                VTEarbeid = VTE;
            END;
            IF VTE GT jour_remun and VTE NE . THEN DO;
                VTEarbeid = jour_remun;
            END;
        END;
        /*Indien na 1991 geen uren en maatman, de arbeidsdagen overnemen*/
        IF annee_prest GT 1991 and (TEMPS_PART EQ 0 or temps_part_hr EQ 0) THEN DO;
            VTEarbeid=jour_remun;
        END;
    END;
    /*--------------------------------------------------------GROEP 2.---------------------------------------*/
    /*Groep 2: Met uren en maatman: uren omzetten in dagen/Zonder uren: overname AD (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("015" "016" "017" "018" "020" "021" "050" "051" "052" "053" "055" "056" "057" "173" "175" "300"  "301" "328" "342" "390" "401" "449" "450" "451" "452" "454" "472" "478" "490" "550") THEN DO;
        IF temps_part GT 0 AND temps_part_hr GT 0 THEN DO;
            temps_part_hrjaar = temps_part_hr*52;
            VTEarbeid = (temps_part/temps_part_hrjaar)*312;
        END;
        ELSE IF temps_part EQ 0 or temps_part_hr EQ 0 THEN DO;
            VTEarbeid = jour_remun;
        END;
    END;
    /*--------------------------------------------------------GROEP 3.---------------------------------------*/
    /*Groep 3: overname AD/overname GD (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("002" "063" "106" "107" "109" "110" "151" "160") THEN DO;
        VTEarbeid = jour_remun;
    END;
    IF code_carriere IN ("004" "005" "008" "029" "032" "033" "037" "170" "180" "181" "182" "183" "186" "198") THEN DO;
        VTEarbeid = jour_remun;
    END;
    IF code_carriere IN ("001") THEN DO;
        VTEarbeid = jour_remun;
    END;
    IF code_carriere IN ("023" "024" "025" "026" "034" "040" "043" "044" "047" "097" "098" "116" "117" "119" "120" "144" "154" "155" "156" "190" "193" "194" "305" "306" "344" "345" "405" "406" "444" "445" "447") THEN DO;
        VTEarbeid = jour_remun;
    END;
    IF code_carriere IN ("041" "042" "045" "048" "145" "164" "191" "192" "197" "304" "307" "346" "404" "407" "446") THEN DO;
        VTEarbeid = jour_remun;
    END;
    IF code_carriere IN ("031" "007") THEN DO;
        VTEarbeid = jour_remun;
    END;
    IF code_carriere IN ("062") THEN DO;
        VTEarbeid = jour_remun*0.866;
    END;
    /*--------------------------------------------------------GROEP 4.--------------------------------------*/
    /*Groep 4: overname loon (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("013" "014" "026" "027" "028" "054") THEN DO;  
        IF jour_remun = 0 AND jour_assimil = 0 AND remun_eur GT 0 THEN DO;
            VTEarbeid = jour_remun;
        END;
    END;
    /*--------------------------------------------------------GROEP 5.---------------------------------------*/
    /*Groep 5: overname GD als LV/beperkte gelijkstelling LV en LD (zie Onderrichting nr. 367)*/
    /*1.Voltijdse werknemer, met een volledige loopbaanonderbreking*/
    IF code_carriere IN ("010" "310" "410") THEN DO;
        VTEarbeid = jour_remun;
    END;
    /*2. Voltijdse werknemer, met een gedeeltelijke loopbaanonderbreking*/
    IF code_carriere IN ("012" "308" "309" "312" "315" "317" "319" "325" "408" "409" "412") THEN DO;
        VTEarbeid = jour_remun;
    END;
    /*3. Voltijdse werknemer, met volledige of gedeeltelijke loopbaanonderbreking*/
    IF code_carriere IN ("313" "316" "318" "413") THEN DO;
        VTEarbeid = jour_remun;
    END;
    /*4. Deeltijdse werknemer, met een volledige loopbaanonderbreking*/
    IF code_carriere IN ("011" "311" "314" "320" "321" "411" "414") THEN DO;
        VTEarbeid = jour_remun;
    END;
    /*--------------------------------------------------------GROEP 6.------------------------------------*/
    /*Groep 6: Tijdskrediet (zie Onderrichting nr. 367)*/
    /*Volledig tijdskrediet
    Volledige schorsing van de arbeidsprestaties vanuit een voltijdse of een deeltijdse betrekking*/
    IF code_carriere IN ("323" ) THEN DO;
        VTEarbeid = jour_remun;
    END;
    /*Gedeeltelijk tijdskrediet*/
    IF code_carriere IN ("324") THEN DO;
        VTEarbeid =jour_remun;
    END;
    /*--------------------------------------------------------GROEP 7.--------------------------------------*/
    /*Groep 7: Met uren en maatman: uren omzetten in dagen/ArbeidZIGU (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("502" "512") THEN DO;
        IF annee_prest GT 1989 AND temps_part GT 0 AND temps_part_hr GT 0 THEN DO;
            temps_part_hrjaar = temps_part_hr*52;
            VTEarbeid = (temps_part/temps_part_hrjaar)*312;
        END;
        ELSE IF temps_part EQ 0 or temps_part_hr EQ 0 THEN DO;
            VTEarbeid = jour_remun;
        END;
    END;
    IF code_carriere IN ("504" "514" "303" "513" "403") THEN DO;
        VTEarbeid = jour_remun;
    END;
    IF code_carriere IN ("508" "518") THEN DO;
        IF annee_prest GT 1989 AND temps_part GT 0 AND temps_part_hr GT 0 THEN DO;
            temps_part_hrjaar = temps_part_hr*52;
            VTEarbeid= (temps_part/temps_part_hrjaar)*312;
        END;
        ELSE IF temps_part EQ 0 or temps_part_hr EQ 0 THEN DO;
            VTEarbeid = jour_remun;
        END;
    END;
    /*--------------------------------------------------------GROEP 8.--------------------------------------*/
    /*Groep 8: Geen omzetting, gegevens worden verwaarloosd. Bijdragen hebben immers geen betrekking op persoonlijke loopbaan.(zie Onderrichting nr. 367)*/
    IF code_carriere IN ("006" "009" "038" "039" "046" "049" "108" "111" "112" "143" "147" "152" "158" "163" "174" "177" "176" "188" "199" "242" "245" "246" "447" "322") then do;
        VTEarbeid = jour_remun;
    END;
    /*--------------------------------------------------------GROEP 9.--------------------------------------*/
    /*Groep 9: Indien VTEarbeid hier nog missing vermoedelijk codes overgenomen uit T23 en T24*/
    IF VTEarbeid EQ . THEN DO;
        IF code_carriere IN ("200" "201" "202" "204" "205" "206" "208" "209" "211" "213" "226" "227" "228" 
                             "230" "237" "240" "241" "242" "243" "244" "245" "247" "248" "249" "250" "252" 
                             "253" "254" "255" "256" "257" "258" "260" "261" "262") THEN DO;
            IF jour_remun NE . THEN DO;                             
                VTEarbeid = jour_remun;
            END;
            ELSE DO;
                VTEarbeid = 0;
            END;
        END;
    END;
RUN;
/*Test tussentijds resultaat*/
PROC MEANS DATA=Prest_dagen;
    TITLE 'Verdelingsgegevens van aantal geconstrueerde VTEDagen per carrire-code';
    VAR   VTEarbeid;
    CLASS code_carriere;
RUN; 
PROC FREQ DATA=Prest_dagen(WHERE=(VTEarbeid=.));
    TITLE 'Loopbaancodes voor gevallen met een missing value voor de variabele VTEArbeid';
    TABLES code_carriere;
RUN; 
PROC PRINT DATA=Prest_dagen(WHERE=(VTEarbeid=. AND code_carriere <> '***') obs=100);
    TITLE 'Loopbaancodes voor gevallen met een missing value voor de variabele VTEArbeid';
RUN; 
/***************Constructie hulpvariabelen voor bepaling gelijkgestelde dagen**************/
PROC SORT DATA=Prest_dagen;
    BY GECODEERD_INSZ annee_prest;
RUN;
/*bereken het aantal vergoede dagen en het aantal geteld vergoede dagen per jaar en per individu*/
DATA SumPerIndiv;
    SET Prest_dagen;
    BY  gecodeerd_insz annee_prest;
    RETAIN totaaljour_remun totaalVTEarbeid 0;
    /*Initialiseer waarde bij eerste loopbaanjaar*/
    IF first.annee_prest THEN DO;
        /*vergoede dagen*/
        IF jour_remun NE 0 AND jour_remun NE . THEN DO;
            totaaljour_remun = jour_remun; 
        END;    
        ELSE DO;
            totaaljour_remun = 0; 
        END;
        /*geteld vergoede dagen*/
        IF VTEarbeid NE 0 AND VTEarbeid NE . THEN DO;
            totaalVTEarbeid = VTEarbeid; 
        END;    
        ELSE DO;
            totaalVTEarbeid = 0; 
        END;
    END;
    ELSE DO;
        /*vergoede dagen*/
        IF jour_remun NE 0 AND jour_remun NE . THEN DO;
            totaaljour_remun = totaaljour_remun + jour_remun; 
        END;    
        /*geteld vergoede dagen*/
        IF VTEarbeid NE 0 AND VTEarbeid NE . THEN DO;
            totaalVTEarbeid = totaalVTEarbeid + VTEarbeid; 
        END;    
    END;        
    IF last.annee_prest THEN OUTPUT;
RUN;
DATA SumPerIndiv;
    SET SumPerIndiv;
    BY  gecodeerd_insz annee_prest;
    /*defaultwaarde RC = 1*/
    RETAIN RC 1;
    /*bereken per individu waarde indien gegevens beschikbaar en herhaal waarde voorgaande lijn indien geen gegevens beschikbaar*/
    IF first.gecodeerd_insz THEN DO;
        IF totaaljour_remun NE 0 AND totaalVTEarbeid NE 0 THEN DO;
            RC = totaalVTEarbeid/totaaljour_remun;
        END;
        ELSE DO;
            RC = 1;
        END;
    END;
    ELSE DO;
        IF totaaljour_remun NE 0 AND totaalVTEarbeid NE 0 THEN DO;
            RC = totaalVTEarbeid/totaaljour_remun;
        END;
    END;
    /*het is blijkbaar mogelijk dat RC groter wordt dan 1 op basis van beschikbare gegevens*/
    IF RC GT 1 THEN RC = 1;
    /*HulpVar1*/
    LABEL RC = "Het aantal geteld vergoede dagen gedeeld door het aantal vergoede dagen op jaarbasis";
    KEEP gecodeerd_insz annee_prest RC;
RUN;
/*Test tussentijds resultaat*/
PROC MEANS DATA=SumPerIndiv;
    VAR RC;
RUN; 
/*Voeg resultaten toe aan file met gepresteerde dagen en construeer andere tussentijdse variabelen*/
DATA Prest_dagen;
    MERGE Prest_dagen SumPerIndiv;
    BY gecodeerd_insz annee_prest;
    /*Was er een vermindering van de arbeidsdagen in een lijn? Is het aantal VTEarbeid kleiner dan het aantal jour_remun?*/
    IF VTEarbeid NE . AND VTEarbeid LT jour_remun       THEN verminderd = 1;
    ELSE IF VTEarbeid NE . AND VTEarbeid GE jour_remun  THEN verminderd = 0;
    /*HulpVar2*/
    LABEL verminderd = "Aanduiding of het aantal geteld vergoede dagen gedeeld kleiner is dan het aantal vergoede dagen voor een gegeven lijn (i.e. niet op jaarbasis en dus <> RC)";
    /*Aanduiding deeltijdse arbeid op basis van de inhoud van een bepaalde loopbaancode*/
    deelt_lbc = 0; /*0 = niet deeltijds; 1 = deeltijds*/
    /*--------------------------------------------------------GROEP 1------------------------------*/
    IF code_carriere IN ("166" "028" "178") THEN deelt_lbc = 1;
    /*--------------------------------------------------------GROEP 2---------------------------------------*/
    IF code_carriere IN ("020" "016" "017" "018" "021" "050" "057" "051" "053" "342" "056" "328" "449" "452" "478") THEN deelt_lbc = 1;
    /*--------------------------------------------------------GROEP 3---------------------------------------*/
    IF code_carriere IN ("041" "042" "045" "048" "164" "191" "192" "197" "304" "307" "346" "404" "407" "446") THEN deelt_lbc = 1;
    /*--------------------------------------------------------GROEP 5---------------------------------------*/
    /*4. Deeltijdse werknemer, met een volledige loopbaanonderbreking*/
    IF code_carriere IN ("011" "311" "314" "320" "321" "411" "414") THEN deelt_lbc = 1;
    /*--------------------------------------------------------GROEP 7--------------------------------------*/
    /* Deeltijds werkenden, met behoud van rechten*/
    IF code_carriere IN ("303" "403" "502" "504" "508" "512" "513" "514" "518") THEN deelt_lbc = 1;
    /*HulpVar3*/
    LABEL deelt_lbc = "Aanduiding deeltijdse arbeid op basis van de inhoud van een bepaalde loopbaancode";
    /*Reductiecofficint op basis van beschikbare observaties in uurvariabele*/
    IF      temps_part_hr EQ 0.01 THEN RCloopbaan = 1; 
    ELSE IF temps_part_hr EQ 0.02 THEN RCloopbaan = 0.5;   /*delen door 2*/
    ELSE IF temps_part_hr EQ 0.03 THEN RCloopbaan = 0.5;   /*delen door 2*/
    ELSE IF temps_part_hr EQ 0.04 THEN RCloopbaan = 0.33;  /*delen door 3*/
    ELSE IF temps_part_hr EQ 0.05 THEN RCloopbaan = 0.25;  /*delen door 4*/
    ELSE IF temps_part_hr EQ 0.06 THEN RCloopbaan = 0.20;  /*delen door 5*/
    IF      RCloopbaan EQ .       THEN RCloopbaan = 1; 
    /*HulpVar4*/
    LABEL RCloopbaan = "Reductiecofficint geobserveerd in uurvariabele";
RUN;   
/***************************************************GELIJKGESTELDE DAGEN****************************/
DATA PrestEnGelijk_Dagen;
    SET Prest_dagen;
    /*Initialiseer aan te maken variabelen*/
    VTEgelijk = .; /*gelijkgestelde dagen*/
    LABEL VTEgelijk = "Gelijkgestelde dagen";
    /*--------------------------------------------------------GROEP 1.------------------------------*/
    /*Groep 1: Vr 1978: overname AD/Vanaf 1978 tot en met 1991: overname AD na toets/Vanaf 1990 met uren en maatman: uren omzetten in dagen/Vanaf 1992 zonder uren: overname AD (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("000" "003" "019" "022" "028" "030" "035" "036" "150" "166" "167" "171" "172" "178" "179" "184" "185" "189" "302" "402" "448" "453") THEN DO;
        /*Voor 1978 worden de gelijkgestelde dagen gewoon overgenomen*/
        IF annee_prest LT 1978 THEN DO;
            VTEgelijk = jour_assimil;
        END;
        IF annee_prest GE 1978 THEN DO;
            /*Indien er een vermindering van de arbeidsdagen was (en dus verminderd = 1), dan vermenigvuldig met de RC*/
            IF verminderd = 1 AND jour_assimil GT 0 THEN VTEgelijk = jour_assimil*RC;
            IF verminderd = 1 AND jour_assimil EQ 0 THEN VTEgelijk = 0;
            /*indien er geen vermindering van de arbeidsdagen was, dan neem over jour_assimil*/
            IF verminderd = 0                       THEN VTEgelijk = jour_assimil;
            IF VTEgelijk EQ .                       THEN VTEgelijk = jour_assimil;
        END;
    END;
    /*--------------------------------------------------------GROEP 2.---------------------------------------*/
    /*Groep 2: Met uren en maatman: uren omzetten in dagen/Zonder uren: overname AD (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("015" "016" "017" "018" "020" "021" "050" "051" "052" "053" "055" "056" "057" "173" "175" "300"  "301" "328" "342" "390" "401" "449" "450" "451" "452" "454" "472" "478" "490" "550") THEN DO;
        /*Voor 1978 worden de gelijkgestelde dagen gewoon overgenomen*/
        IF annee_prest LT 1978 THEN DO;
            VTEgelijk = jour_assimil;
        END;
        /*Na 1978 overname gelijkgestelde dagen of vermenigvuldiging met reductiecoefficient*/
        IF annee_prest GE 1978 THEN DO;
            IF verminderd = 1 AND jour_assimil GT 0 THEN VTEgelijk = jour_assimil*RC;
            IF verminderd = 1 AND jour_assimil EQ 0 THEN VTEgelijk = 0;
            /*indien er geen vermindering van de arbeidsdagen was, dan neem over jour_assimil*/
            IF verminderd = 0                       THEN VTEgelijk = jour_assimil;
            IF VTEgelijk EQ .                       THEN VTEgelijk = jour_assimil;
        END;    
    END;
    /*--------------------------------------------------------GROEP 3.---------------------------------------*/
    /*Groep 3: overname AD/overname GD (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("002" "063" "106" "107" "109" "110" "151" "160") THEN DO;
        VTEgelijk = jour_assimil;
    END;
    IF code_carriere IN ("004" "005" "008" "029" "032" "033" "037" "170" "180" "181" "182" "183" "186" "198") THEN DO;
        VTEgelijk = jour_assimil;
    END;
    IF code_carriere IN ("001") THEN DO;
        VTEgelijk = jour_assimil;
    END;
    IF code_carriere IN ("023" "024" "025" "026" "034" "040" "043" "044" "047" "097" "098" "116" "117" "119" "120" "144" "154" "155" "156" "190" "193" "194" "305" "306" "344" "345" "405" "406" "444" "445" "447") THEN DO;
        VTEgelijk= jour_assimil;
    END;
    IF code_carriere IN ("041" "042" "045" "048" "145" "164" "191" "192" "197" "304" "307" "346" "404" "407" "446") THEN DO;
        VTEgelijk = jour_assimil/2;
    END;
    IF code_carriere IN ("031" "007") THEN DO;
        VTEgelijk = jour_assimil;
    END;
    IF code_carriere IN ("062") THEN DO;
        VTEgelijk = jour_assimil;
    END;
    /*--------------------------------------------------------GROEP 4.--------------------------------------*/
    /*Groep 4: overname loon (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("013" "014" "026" "027" "028" "054") THEN DO;  
        IF jour_remun = 0 AND jour_assimil = 0 AND remun_eur GT 0 THEN DO;
            VTEgelijk = jour_assimil;
        END;
    END;
    /*--------------------------------------------------------GROEP 5.---------------------------------------*/
    /*Groep 5: overname GD als LV/beperkte gelijkstelling LV en LD (zie Onderrichting nr. 367)*/
    /*Onderscheid maken tussen volledige en gedeeltelijke  loopbaanonderbreking
    TYPOLOGIE:
    1. Voltijdse werknemer, met een volledige loopbaanonderbreking
    2. Voltijdse werknemer, met een gedeeltelijke loopbaanonderbreking
    3. Voltijdse werknemer, met volledige of gedeeltelijke loopbaanonderbreking
    4. Deeltijdse werknemer, met een volledige loopbaanonderbreking
    */
    /*1.Voltijdse werknemer, met een volledige loopbaanonderbreking*/
    IF code_carriere IN ("010" "310" "410") THEN DO;
        Loopbaanonderbreking = 1;
        VTEgelijk = jour_assimil;
    END;
    /*2. Voltijdse werknemer, met een gedeeltelijke loopbaanonderbreking*/
    IF code_carriere IN ("012" "308" "309" "312" "315" "317" "319" "325" "408" "409" "412") THEN DO;
        Loopbaanonderbreking = 2;
        VTEgelijk = jour_assimil*RCloopbaan;
    END;
    /*3. Voltijdse werknemer, met volledige of gedeeltelijke loopbaanonderbreking*/
    IF code_carriere IN ("313" "316" "318" "413" ) THEN DO;
        Loopbaanonderbreking = 3;
        VTEgelijk = jour_assimil*RCloopbaan;
    END;
    /*4. Deeltijdse werknemer, met een volledige loopbaanonderbreking*/
    IF code_carriere IN ("011" "311" "314" "320" "321" "411" "414") THEN DO;
        Loopbaanonderbreking = 4;
        VTEgelijk = jour_assimil;
    END;
    /*--------------------------------------------------------GROEP 6.------------------------------------*/
    /*Groep 6: Tijdskrediet (zie Onderrichting nr. 367)*/
    /*Volledig tijdskrediet
    Volledige schorsing van de arbeidsprestaties vanuit een voltijdse of een deeltijdse betrekking*/
    IF code_carriere IN ("323" ) THEN DO;
        Tijdskrediet = 1;
        VTEgelijk = jour_assimil*RCloopbaan;
    END;
    /*Gedeeltelijk tijdskrediet*/
    IF code_carriere IN ("324") THEN DO;
        Tijdskrediet = 2;
        VTEgelijk = jour_assimil*RCloopbaan;
    END;
    /*--------------------------------------------------------GROEP 7.--------------------------------------*/
    /*Groep 7: Met uren en maatman: uren omzetten in dagen/ArbeidZIGU (zie Onderrichting nr. 367)*/
    IF code_carriere IN ("502" "512") THEN DO;
        VTEgelijk=jour_assimil;
    END;
    IF code_carriere IN ("504" "514" "303" "513" "403") then do;
        VTEgelijk=jour_assimil;
    END;
    IF code_carriere IN ("508" "518") THEN DO;
        /*Na 1978 overname gelijkgestelde dagen of vermenigvuldiging met reductiecoefficient*/
        IF annee_prest GE 1978 THEN DO;
            IF verminderd = 1 AND jour_assimil GT 0 THEN VTEgelijk = jour_assimil*RC;
            IF verminderd = 1 AND jour_assimil EQ 0 THEN VTEgelijk = 0;
            /*indien er geen vermindering van de arbeidsdagen was, dan neem over jour_assimil*/
            IF verminderd = 0                       THEN VTEgelijk = jour_assimil;
            IF VTEgelijk EQ .                       THEN VTEgelijk = jour_assimil;
        END;    
    END;
    /*--------------------------------------------------------GROEP 8.--------------------------------------*/
    /*Groep 8: Geen omzetting, gegevens worden verwaarloosd. Bijdragen hebben immers geen betrekking op persoonlijke loopbaan.(zie Onderrichting nr. 367)*/
    IF code_carriere IN ("006" "009" "038" "039" "046" "049" "108" "111" "112" "143" "147" "152" "158" "163" "174" "177" "176" "188" "199" "242" "245" "246" "447" "322") then do;
        VTEgelijk = jour_assimil;
    END;
    /*--------------------------------------------------------GROEP 9.--------------------------------------*/
    /*Groep 9: Indien VTEarbeid hier nog missing vermoedelijk codes overgenomen uit T23 en T24*/
    IF VTEgelijk EQ . THEN DO;
        IF code_carriere IN ("200" "201" "202" "204" "205" "206" "208" "209" "211" "213" "226" "227" "228" 
                             "230" "237" "240" "241" "242" "243" "244" "245" "247" "248" "249" "250" "252" 
                             "253" "254" "255" "256" "257" "258" "260" "261" "262") THEN DO;
            IF jour_assimil NE . THEN DO;                             
                VTEgelijk = jour_assimil;
            END;
            ELSE DO;
                VTEgelijk = 0;
            END;
        END;
    END;
    /*HulpVar5 en HulpVar6*/
    /*Labels voor twee aangemaakte tussentijdse variabelen: noodzaak variabelen nog niet duidelijk, misschien in stukken die volgen*/
    LABEL Loopbaanonderbreking = "Aanduiding loopbaanonderbreking op basis van beschikbare codes";
    LABEL Tijdskrediet = "Aanduiding tijdskrediet op basis van beschikbare codes";
RUN;
/*Test tussentijds resultaat*/
PROC MEANS DATA=PrestEnGelijk_Dagen;
    TITLE 'Verdelingsgegevens van aantal geconstrueerde gelijkgestelde dagen per carrire-code';
    VAR   VTEgelijk;
    CLASS code_carriere;
RUN; 
PROC FREQ DATA=PrestEnGelijk_Dagen(WHERE=(VTEGelijk=.));
    TITLE 'Loopbaancodes voor gevallen met een missing value voor de variabele VTEGelijk';
    TABLES code_carriere;
RUN; 
PROC PRINT DATA=PrestEnGelijk_Dagen(WHERE=(VTEGelijk=. AND code_carriere <> '***') obs=100);
    TITLE 'Loopbaancodes voor gevallen met een missing value voor de variabele VTEGelijk';
RUN; 
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                       STAP 2.
Aanduiden deeltijds/voltijds
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
DATA PrestEnGelijk_Dagen;
    SET PrestEnGelijk_Dagen;
    /*breng grote aantallen op VTEarbeid en VTEgelijk terug op maximum*/
    VTEtotaal = VTEarbeid + VTEgelijk;
    /*HulpVar7*/
    LABEL VTEtotaal = "Totaal van gewerkte en gelijkgestelde dagen";
    /*Drie variabelen deeltijdse arbeid*/
    IF      VTEarbeid GE 312 THEN deelt_ab = 0;
    ELSE IF VTEarbeid LT 312 THEN deelt_ab = 1;
    IF      VTEgelijk GE 312 THEN deelt_gl = 0;
    ELSE IF VTEgelijk LT 312 THEN deelt_gl = 1;
    IF                      VTEtotaal GT 250 THEN typedeelt = 1; /*voltijdse*/
    IF VTEtotaal LE 250 and VTEtotaal GT 187 THEN typedeelt = 2; /*4/5e*/
    IF VTEtotaal LE 187 and VTEtotaal GT 156 THEN typedeelt = 3; /*3/5e*/
    IF VTEtotaal LE 156 and VTEtotaal GT 124 THEN typedeelt = 4; /*halftijds*/
    IF VTEtotaal LE 124 and VTEtotaal GT 62  THEN typedeelt = 5; /*2/5e*/
    IF VTEtotaal LE 62  and VTEtotaal GE 0   THEN typedeelt = 6; /*1/5e*/
    /*HulpVar8, HulpVar9 en HulpVar10*/
    LABEL deelt_ab = "Totaal aantal gepresteerde dagen is kleiner dan 312 (ja=1)";
    LABEL deelt_gl = "Totaal aantal gelijkgestelde dagen is kleiner dan 312 (ja=1)";
    LABEL typedeelt = "Type prestatie op basis van gepresteerde en gelijkgestelde dagen";
    /*Maak variabele met aantal gewerkte uren*/
    HOURS = 0;
    /*indien aantal uren geobserveerd: direct aantal geregistreerde uren nemen*/
    IF temps_part NE 0 THEN HOURS = temps_part;
    /*indien geen uren maar wel info ivm tijdsreductie*/
    IF HOURS EQ 0 AND temps_part_hr IN (0.01,0.02,0.03,0.04,0.05,0.06) AND VTEarbeid NOTIN (.,0) THEN DO;
        IF      temps_part_hr EQ 0.01 THEN HOURS = VTEarbeid*7.6;      /*geen vermindering*/
        ELSE IF temps_part_hr EQ 0.02 THEN HOURS = VTEarbeid*7.6*0.5;  /*vermindering tot de helft van een voltijdse*/ 
        ELSE IF temps_part_hr EQ 0.03 THEN HOURS = VTEarbeid*7.6*0.5;  /*vermindering tot de helft van een voltijdse*/
        ELSE IF temps_part_hr EQ 0.04 THEN HOURS = VTEarbeid*7.6*0.66; /*vermindering met 1/3 van een voltijdse*/
        ELSE IF temps_part_hr EQ 0.05 THEN HOURS = VTEarbeid*7.6*0.75; /*vermindering met 1/4 van een voltijdse*/
        ELSE IF temps_part_hr EQ 0.06 THEN HOURS = VTEarbeid*7.6*0.80; /*vermindering met 1/5 van een voltijdse*/
    END;
    /*Indien nog geen uren gebruik dan de variabele type deeltijds*/
    IF HOURS EQ 0 AND typedeelt IN (1,2,3,4,5,6) AND VTEarbeid NOTIN (.,0) THEN DO;
        IF      typedeelt EQ 1 THEN HOURS = VTEarbeid*7.6;      /*geen vermindering*/
        ELSE IF typedeelt EQ 2 THEN HOURS = VTEarbeid*7.6*0.80; /*vermindering tot 1/5 van een voltijdse*/ 
        ELSE IF typedeelt EQ 3 THEN HOURS = VTEarbeid*7.6*0.60; /*vermindering tot 2/5 van een voltijdse*/
        ELSE IF typedeelt EQ 4 THEN HOURS = VTEarbeid*7.6*0.50; /*vermindering met 1/2 van een voltijdse*/
        ELSE IF typedeelt EQ 5 THEN HOURS = VTEarbeid*7.6*0.40; /*vermindering met 3/5 van een voltijdse*/
        ELSE IF typedeelt EQ 6 THEN HOURS = VTEarbeid*7.6*0.20; /*vermindering met 4/5 van een voltijdse*/
    END;
    /*Indien nog geen uren en toch gewerkt dagen: dan veronderstelling voltijds*/
    IF HOURS EQ 0 AND VTEarbeid GT 0 AND VTEarbeid NE . THEN HOURS = VTEarbeid*7.6; 
RUN;
/*Test tussentijds resultaat*/
PROC MEANS DATA=PrestEnGelijk_Dagen;
    TITLE 'Verdelingsgegevens van het aantal gewerkte uren per carrire-code';
    VAR   HOURS;
    CLASS code_carriere;
RUN; 
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                        STAP 3.
Reduceren van informatie tot 1 lijn per persoon per loopbaanjaar.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*Maak een onderscheid tussen gelijkgestelde en gepresteerde dagen*/
/*Telkens code weerhouden met de hoogste waarde van hetzij gepresteerde of gelijkgestelde dagen*/
/*sorteer op individueel nummer en per prestatiejaar en naar aantal vergoede dagen*/
PROC SORT Data=PrestEnGelijk_Dagen;
    BY gecodeerd_insz annee_prest VTEarbeid;
RUN;
/*Bereken de som van de gevraagde variabelen*/    
DATA SumPerIndiv;
    SET PrestEnGelijk_Dagen;
    BY  gecodeerd_insz annee_prest;
    RETAIN REMHOURS REMDAYS REMUN 0;
    IF first.annee_prest THEN DO;
        /*compute hours*/
        IF HOURS NE 0 AND HOURS NE . THEN DO;
            REMHOURS = HOURS;
        END;    
        ELSE DO;
            REMHOURS = 0;
        END;
        /*compute days*/
        IF VTEarbeid NE 0 AND VTEarbeid NE . THEN DO;
            REMDAYS = VTEarbeid;
        END;    
        ELSE DO;
            REMDAYS = 0;
        END;
        /*compute remuneration*/
        IF remun_eur NE 0 AND remun_eur NE . THEN DO;
            REMUN = remun_eur;
        END;    
        ELSE DO;
            REMUN = 0;
        END;
    END;
    ELSE DO;
        /*compute hours*/
        IF HOURS NE 0 AND HOURS NE . THEN DO;
            REMHOURS = REMHOURS + HOURS;
        END;    
        /*compute days*/
        IF VTEarbeid NE 0 AND VTEarbeid NE . THEN DO;
            REMDAYS = REMDAYS + VTEarbeid;
        END;    
        /*compute remuneration*/
        IF remun_eur NE 0 AND remun_eur NE . THEN DO;
            REMUN = REMUN + remun_eur;
        END;    
    END;        
    IF last.annee_prest THEN OUTPUT;
RUN;
/*keep constructed variables*/
DATA SumArbeid;
    SET SumPerIndiv(keep = gecodeerd_insz annee_prest code_carriere REMHOURS REMDAYS REMUN);
    BY gecodeerd_insz annee_prest;
    CODEREMUN = code_carriere;
    Label CODEREMUN = "Career code associated with the largest number of remunerated days in a given year";
    Label REMHOURS  = "Remunerated hours per year";
    Label REMDAYS   = "Remunerated days per year";
    Label REMUN     = "Remunerations in Euro per year (expressed in prices of the year of registration)";
    KEEP gecodeerd_insz annee_prest CODEREMUN REMHOURS REMDAYS REMUN;
RUN;
/*sorteer op individueel nummer en per prestatiejaar en naar aantal gelijkgestelde dagen*/
PROC SORT Data=PrestEnGelijk_Dagen;
    BY gecodeerd_insz annee_prest VTEgelijk;
RUN;
/*compute the sum of the requested variables per individual per year*/ 
/*the career code you retain is the one associated with the largest amount of assimilated days*/
DATA SumPerIndiv;
    SET PrestEnGelijk_Dagen;
    BY gecodeerd_insz annee_prest;
    RETAIN ASSIMDAYS 0;
    IF first.annee_prest THEN DO;
        /*compute days*/
        IF VTEgelijk NE 0 AND VTEgelijk NE . THEN DO;
            ASSIMDAYS = VTEgelijk;
        END;    
        ELSE DO;
            ASSIMDAYS = 0;
        END;
    END;
    ELSE DO;
        /*compute days*/
        IF VTEgelijk NE 0 AND VTEgelijk NE . THEN DO;
            ASSIMDAYS = ASSIMDAYS + VTEgelijk;
        END;    
    END;        
    IF last.annee_prest THEN OUTPUT;
RUN;
/*keep constructed variables*/
DATA SumGelijk;
    SET SumPerIndiv(keep = gecodeerd_insz annee_prest code_carriere ASSIMDAYS);
    BY gecodeerd_insz annee_prest;
    CODEASSIM = code_carriere ;
    Label CODEASSIM         = "Career code associated with the largest number of assimilated days in a given year";
    Label ASSIMDAYS         = "Number of assimilated days in a given year";
    KEEP gecodeerd_insz annee_prest CODEASSIM ASSIMDAYS;
RUN;
/*Voeg onderdelen samen*/
DATA CAREERINFO;
    MERGE SumArbeid SumGelijk;
    by gecodeerd_insz annee_prest;
    /*correct missing values*/
    IF CODEASSIM        EQ . THEN CODEASSIM         = 0 ;
    IF ASSIMDAYS        EQ . THEN ASSIMDAYS         = 0 ; 
    IF CODEREMUN        EQ . THEN CODEREMUN         = 0 ; 
    IF REMDAYS          EQ . THEN REMDAYS           = 0 ;  
    IF REMUN            EQ . THEN REMUN             = 0 ;  
RUN;
/*add index*/
LIBNAME LIB 'C:\My\teksten\MSMSocZek\Data\CIMIRE\FileULg\';
PROC SORT DATA=LIB.index01;
    BY annee_prest;
RUN;
PROC SORT DATA=CAREERINFO;
    BY annee_prest;
RUN;
DATA CAREERINFO;
    MERGE CAREERINFO lib.index01;
    BY annee_prest;
    Label Index01   = "Multiplication factor necessary to express nominal values of a registration year in price level of 2001";
RUN;        
/*Test tussentijds resultaat*/
PROC FREQ DATA=CAREERINFO;
    TITLE 'Frequentieverdeling code gelijkgestelde en gewerkte dagen na samendrukking tot 1 lijn per individu';
    TABLES CODEASSIM CODEREMUN ; 
RUN; 

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                        STAP 5.
Aanmaak WSTATUS en definitieve file
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
DATA CAREERINFO;
    SET CAREERINFO;

    /*Eerste stap: CODEASSIM EN CODEREMUN elk hercoderen tot een WSTATUS -> WSTATUSa & WSTATUSr*/
    /*Aanmaak variabelen WSTATUSa WSTATUSr*/
    WSTATUSa=.;
    WSTATUSr=.;

    /*Oplossing voor CODE '000'*/
    IF CODEASSIM in ("000") THEN DO;
        IF REMUN GT 0 THEN WSTATUSa=1;
        IF REMUN LE 0 THEN WSTATUSa=3456;  
    END;
    IF CODEREMUN in ("000") THEN DO;
        IF REMUN GT 0 THEN WSTATUSr=1;
        IF REMUN LE 0 THEN WSTATUSr=3456;  
    END;

    /*WSTATUSA*/
    /*1. Werkend*/
    IF CODEASSIM in ("001" "002" "003" "019" "020" "022" "028" "029" "050" "054" "300" "301" "302" "322" "328" "390" "150" "166" "167" "172" "178" "490" "051" "053"         
                     "450" "478" "472" "186" "401" "448" "449" "453" "454" "151" "179" "189" "402" "170" "174" "176" "199" "342" "160" "106" "108" "109" "147" "107" 
                     "110" "112" "062" "063" "173" "175" "177" "018" "021" "171" "097" "098" "502" "508" "512" "518" "035" "036" "163" "184" "185" "204" "208" "209"
                     "216" "240" "243" "244")
    THEN DO;    
        WSTATUSa=1;
    END;
    /*2. Gepensioneerd*/
    /*3. Bruggepensioneerd*/
    IF CODEASSIM in ("304" "306" "307" "404" "406" "407") THEN DO;
        WSTATUSa=3;
    END;
    /*4. Werkloos*/
    IF CODEASSIM in ("024" "040" "043" "047" "305" "344" "345" "041" "042" "045" "048" "346" "303" "154" "190" "193" "194" "405" "444" "445" "447" "164" "191" "192" 
                     "197" "446" "403" "504" "514" "513" "143" "144" "145" "230") THEN DO;
        WSTATUSa=4;
    END;
    /*51. Loopbaanonderbreking*/
    IF CODEASSIM in ("308" "309" "310" "312" "408" "409" "410" "411" "412" "010" "011" "311" "012" "323" "324" "325" "227") THEN DO;
        WSTATUSa=51;
    END;
    /*52. Thematische verloven*/
    IF CODEASSIM in ("413" "414" "313" "316" "318" "314" "320" "321" "315" "317" "319") THEN DO;
        WSTATUSa=52;
    END;
    /*6. Ziekte/invaliditeit*/
    IF CODEASSIM in ("025" "155" "156" "116" "119" "117" "120" "111" "023" "034" "044"
                     "201" "202" "205" "213" "225" "226" "231" "237" "241" "223" "248" 
                     "249" "250" "252" "253" "254" "255" "260" "261") THEN DO;            
        WSTATUSa=6;
    END;
    /*7. Regularisatie*/
    IF CODEASSIM in ("004" "005" "006" "008" "031" "032" "033" "039" "037" "038" "009" "152" "158" "180" "181" "182" "183" "188" "198" "007" "046"
                     "200" "206" "211" "228" "242" "245" "247" "256" "257" "258" "262") THEN DO;           
        WSTATUSa=7;
    END;
    /*8. Missings*/
    IF WSTATUSa EQ . THEN DO;
        WSTATUSa=8;
    END;        

    /*WSTATUSR*/
    /*1. Werkend*/
    IF CODEREMUN in ("001" "002" "003" "019" "020" "022" "028" "029" "050" "054" "300" "301" "302" "322" "328" "390" "150" "166" "167" "172" "178" "490" "051" "053"         
                     "450" "478" "472" "186" "401" "448" "449" "453" "454" "151" "179" "189" "402" "170" "174" "176" "199" "342" "160" "106" "108" "109" "147" "107" 
                     "110" "112" "062" "063" "173" "175" "177" "018" "021" "171" "097" "098" "502" "508" "512" "518" "035" "036" "163" "184" "185" "204" "208" "209"
                     "216" "240" "243" "244")
    THEN DO;    
        WSTATUSr=1;
    END;
    /*2. Gepensioneerd*/
    /*3. Bruggepensioneerd*/
    IF CODEREMUN in ("304" "306" "307" "404" "406" "407") THEN DO;
        WSTATUSr=3;
    END;
    /*4. Werkloos*/
    IF CODEREMUN in ("024" "040" "043" "047" "305" "344" "345" "041" "042" "045" "048" "346" "303" "154" "190" "193" "194" "405" "444" "445" "447" "164" "191" "192" 
                     "197" "446" "403" "504" "514" "513" "143" "144" "145" "230") THEN DO;
        WSTATUSr=4;
    END;
    /*51. Loopbaanonderbreking*/
    IF CODEREMUN in ("308" "309" "310" "312" "408" "409" "410" "411" "412" "010" "011" "311" "012" "323" "324" "325" "227") THEN DO;
        WSTATUSr=51;
    END;
    /*52. Thematische verloven*/
    IF CODEREMUN in ("413" "414" "313" "316" "318" "314" "320" "321" "315" "317" "319") THEN DO;
        WSTATUSr=52;
    END;
    /*6. Ziekte/invaliditeit*/
    IF CODEREMUN in ("025" "155" "156" "116" "119" "117" "120" "111" "023" "034" "044"
                     "201" "202" "205" "213" "225" "226" "231" "237" "241" 
                     "223" "248" "249" "250" "252" "253" "254" "255" "260" "261") THEN DO;
        WSTATUSr=6;
    END;
    /*7. Regularisatie*/
    IF CODEREMUN in ("004" "005" "006" "008" "031" "032" "033" "039" "037" "038" "009" "152" "158" "180" "181" "182" "183" "188" "198" "007" "046"
                     "200" "206" "211" "228" "242" "245" "247" "256" "257" "258" "262") THEN DO;           
        WSTATUSr=7;
    END;
    /*8. Missings*/
    IF WSTATUSr EQ . THEN DO;
        WSTATUSr=8;
    END;    

    /*TWEEDE STAP: samengevoegde WSTATUS*/
    /*WSTATUS voor WSTATUSa en WSTATUSr als deze aan elkaar gelijk zijn*/
    IF WSTATUSa EQ WSTATUSr THEN DO;
        WSTATUS=WSTATUSr; /* dit kan evengoed WSTATUS=WSTATUSa zijn*/
    END;
    /*WSTATUS voor WSTATUSa en WSTATUSr als deze niet aan elkaar gelijk zijn*/
    IF WSTATUSa NE WSTATUSr THEN DO;
        IF ASSIMDAYS GT REMDAYS THEN DO;
            WSTATUS = WSTATUSA;
        END;
        IF REMDAYS GE ASSIMDAYS THEN DO;
            WSTATUS = WSTATUSR;
        END;
        /*Code 3456 vervangen door een meer inhoudsvolle code als die er is*/
        IF WSTATUSa EQ 3456 AND WSTATUSr IN (3 4 51 52 6) THEN DO;
            WSTATUS = WSTATUSr;
        END;
        IF WSTATUSr EQ 3456 AND WSTATUSa IN (3 4 51 52 6) THEN DO;
            WSTATUS = WSTATUSa;
        END;
    END;
    /*Eventuele missings hercoderen*/
    IF WSTATUS EQ . THEN DO;
        WSTATUS=8;
    END;

    Label WSTATUSA = "Workstatus based on value of assimilated days career code";
    Label WSTATUSR = "Workstatus based on value of worked days career code";
    Label WSTATUS  = "Workstatus based on either value of assimilated or worked days career code";

    /*Hernoem stringvariabelen*/
    CODEREMUN_STRING = CODEREMUN;
    CODEASSIM_STRING = CODEASSIM;
    DROP CODEREMUN CODEASSIM;
RUN;
/*Schrijf gegevens weg naar definitieve file en converteer karaktervariabelen*/
DATA LIBCAR.CAREERINFO;
    SET CAREERINFO;
    CODEREMUN  = INPUT(SUBSTR(TRIM(CODEREMUN_STRING),1,3),8.);
    CODEASSIM  = INPUT(SUBSTR(TRIM(CODEASSIM_STRING),1,3),8.);
    Label CODEREMUN = "Career code associated with the largest number of remunerated days in a given year";
    Label CODEASSIM = "Career code associated with the largest number of assimilated days in a given year";
    DROP CODEREMUN_STRING CODEASSIM_STRING;
RUN;
/*Test tussentijds resultaat*/
PROC FREQ DATA=LIBCAR.CAREERINFO;
    TITLE 'Frequentieverdeling van WSTATUS';
    TABLES WSTATUSA WSTATUSR WSTATUS; 
RUN; 
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;

