/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens FAO
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateFAO_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateFAO.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA FAO;
    SET LIB.mim2008_fao_code;
RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM FAO
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
/*zo ja reduceer dan tot 1 lijn*/
PROC SORT DATA=FAO;
    BY GECODEERD_INSZ MONTITP_2008 MONTITT_2008 SALBASE_2008;
RUN; 
DATA FAO;
    SET FAO;
    BY GECODEERD_INSZ MONTITP_2008 MONTITT_2008 SALBASE_2008;

    RETAIN DUREEITT_AGG DUREEITP_AGG MONTPERTSAL_AGG MONTITT_AGG MONTITP_AGG 0;

    IF FIRST.GECODEERD_INSZ THEN DO;
        DUREEITT_AGG = 0;
        DUREEITP_AGG = 0; 
        MONTPERTSAL_AGG = 0; 
        MONTITT_AGG = 0; 
        MONTITP_AGG = 0;
        IF DUREEITT_2008        NE . THEN DUREEITT_AGG      = DUREEITT_2008   ;
        IF DUREEITP_2008        NE . THEN DUREEITP_AGG      = DUREEITP_2008   ;   
        IF MONTPERTSAL_2008     NE . THEN MONTPERTSAL_AGG   = MONTPERTSAL_2008;   
        IF MONTITT_2008         NE . THEN MONTITT_AGG       = MONTITT_2008    ;    
        IF MONTITP_2008         NE . THEN MONTITP_AGG       = MONTITP_2008    ;   
    END;
    ELSE DO;
        IF DUREEITT_2008        NE . THEN DUREEITT_AGG      = DUREEITT_AGG    + DUREEITT_2008   ;
        IF DUREEITP_2008        NE . THEN DUREEITP_AGG      = DUREEITP_AGG    + DUREEITP_2008   ;   
        IF MONTPERTSAL_2008     NE . THEN MONTPERTSAL_AGG   = MONTPERTSAL_AGG + MONTPERTSAL_2008;   
        IF MONTITT_2008         NE . THEN MONTITT_AGG       = MONTITT_AGG     + MONTITT_2008    ;    
        IF MONTITP_2008         NE . THEN MONTITP_AGG       = MONTITP_AGG     + MONTITP_2008    ;   
    END;

    DROP DUREEITT_2008 DUREEITP_2008 MONTPERTSAL_2008 MONTITT_2008 MONTITP_2008;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN; 
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM FAO
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na reductie";
    TABLES NUM_Indiv;
RUN;
DATA LIBW.MIM2008_FAO;
    MERGE TOTPOP(in=InA) FAO(in=InB);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele voor latere aanduiding dat iemand FAO-uitkering heeft*/
    FATFAO_BENEF_2008 = 0;
    IF InB EQ 1 THEN FATFAO_BENEF_2008 = 1;
    LABEL FATFAO_BENEF_2008 = "Het indvidiu ontvangt een uitkering voor een arbeidsongeval gedurende het gegeven jaar";

    /*Rename*/
    DUREEITT_2008    = DUREEITT_AGG;   
    DUREEITP_2008    = DUREEITP_AGG;   
    MONTPERTSAL_2008 = MONTPERTSAL_AGG;
    MONTITT_2008     = MONTITT_AGG;    
    MONTITP_2008     = MONTITP_AGG;    

    /*Label*/
    LABEL DUREEITT_2008     = "Aantal dagen tijdelijke arbeidsongeschiktheid: volledige afwezigheid (geregistreerd in 2008)";
    LABEL DUREEITP_2008     = "Aantal dagen tijdelijke arbeidsongeschiktheid: gedeeltelijke afwezigheid (geregistreerd in 2008)";                                                                                                        
    LABEL MONTPERTSAL_2008  = "Bedrag van het verloren loon (geregistreerd in 2008)";                                                                                                                                                    
    LABEL MONTITT_2008      = "Bedrag voor tijdelijke arbeidsongeschiktheid: volledige afwezigheid (geregistreerd in 2008)";                                                                                                             
    LABEL MONTITP_2008      = "Bedrag voor tijdelijke arbeidsongeschiktheid: gedeeltelijke afwezigheid (geregistreerd in 2008)";                                                                                                         

    IF TAUXIT_2008        EQ . THEN TAUXIT_2008      = 0;
    IF DUREEITT_2008      EQ . THEN DUREEITT_2008    = 0;
    IF DUREEITP_2008      EQ . THEN DUREEITP_2008    = 0;
    IF MONTPERTSAL_2008   EQ . THEN MONTPERTSAL_2008 = 0;
    IF SALBASE_2008       EQ . THEN SALBASE_2008     = 0;
    IF MONTITT_2008       EQ . THEN MONTITT_2008     = 0;
    IF MONTITP_2008       EQ . THEN MONTITP_2008     = 0;
    IF TAUXIPRES_2008     EQ . THEN TAUXIPRES_2008   = 0;
    IF TAUXATRES_2008     EQ . THEN TAUXATRES_2008   = 0;

    DROP DUREEITT_AGG DUREEITP_AGG MONTPERTSAL_AGG MONTITT_AGG MONTITP_AGG;

RUN;
PROC FREQ DATA=LIBW.MIM2008_FAO;
    TABLES
    FATFAO_BENEF_2008
    DDEBUT_2008
    DFIN_2008
    ;
RUN;
PROC CONTENTS DATA=LIBW.MIM2008_FAO;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;

