/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens FBZ
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateFBZ_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateFBZ.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA FBZ;
    SET LIB.mim2008_fbz_code;
RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM FBZ
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
/*zo ja reduceer dan tot 1 lijn*/
PROC SORT DATA=FBZ;
    BY GECODEERD_INSZ FBZ_BEDRAG_2008 FBZ_BASLOON_2008;
RUN; 
DATA FBZ;
    SET FBZ;
    BY GECODEERD_INSZ FBZ_BEDRAG_2008 FBZ_BASLOON_2008;
    
    RETAIN FBZ_BEDRAG_AGG 0;
    
    IF FIRST.GECODEERD_INSZ THEN DO;
        FBZ_BEDRAG_AGG = 0;
        IF FBZ_BEDRAG_2008 NE . THEN FBZ_BEDRAG_AGG = FBZ_BEDRAG_2008;
    END;
    ELSE DO;
        IF FBZ_BEDRAG_2008 NE . THEN FBZ_BEDRAG_AGG = FBZ_BEDRAG_AGG + FBZ_BEDRAG_2008;
    END;

    DROP FBZ_BEDRAG_2008;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN; 
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM FBZ
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na reductie";
    TABLES NUM_Indiv;
RUN;
/*aanmaak finaal bestand*/
DATA LIBW.MIM2008_FBZ;
    MERGE TOTPOP(in=InA) FBZ(in=InB);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele voor latere aanduiding dat iemand FBZ-uitkering heeft*/
    FBZFMB_BENEF_2008 = 0;
    IF InB EQ 1 THEN FBZFMB_BENEF_2008 = 1;
    LABEL FBZFMB_BENEF_2008 = "Het indvidiu ontvangt een uitkering voor een beroepsziekte gedurende het gegeven jaar";

    /*Rename*/
    FBZ_BEDRAG_2008 = FBZ_BEDRAG_AGG; 
    
    /*Label*/
    LABEL FBZ_BEDRAG_2008 = "Betaald bedrag beroepsziekte (2008)";

    IF FBZ_BEDRAG_2008  EQ . THEN FBZ_BEDRAG_2008 = 0;
    IF FBZ_BASLOON_2008 EQ . THEN FBZ_BASLOON_2008 = 0;

    DROP FBZ_BEDRAG_AGG;
    
RUN;
PROC FREQ DATA=LIBW.MIM2008_FBZ;
    TABLES
    FBZFMB_BENEF_2008
    FBZ_BEGDBET_2008
    FBZ_ENDDBET_2008
    ;
RUN;
PROC CONTENTS DATA=LIBW.MIM2008_FBZ;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
