/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens FOD SZ
    
*datums converteren naar numeriek en juiste lijnen selecteren
*oplossing zoeken voor ontbrekende wetgeving in bestanden leg en pay
    eventueel eerst sorteren en toevoegen aan leg en pay en dan oude procedure volgen
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateFODSZ_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateFODSZ.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

DM 'Log; CLEAR; Output; Clear; ';

/*Zet macro opties*/
OPTIONS MPRINT MLOGIC SYMBOLGEN;

/*Start selection macro*/
%MACRO MakeHand_Stat(EEJJMMDD);

    %let EEJJ   = %SUBSTR(&EEJJMMDD,1,4);
    %let EEJJMM = %SUBSTR(&EEJJMMDD,1,6);
    %let JJ     = %SUBSTR(&EEJJMMDD,3,2);
    %let MM     = %SUBSTR(&EEJJMMDD,5,2);
    
    /*Manipuleer eerst medisch bestand tot 1 bestand*/
    %DO i = 1 %TO 4;
    
        DATA MED_&i.;
            SET 
            lib.mim2008_fodsz_med08&i._new_code;
            ;
            
            type_rec         = type_rec_08&i.;                 
            code_leg         = code_leg_08&i.;                 
            date_start_recon = date_start_recon_08&i.;         
            date_end_recon   = date_end_recon_08&i.;           
            memb_inf_50perc  = memb_inf_50perc_08&i.;          
            cecite_comp      = cecite_comp_08&i.;              
            amp_memb_sup     = amp_memb_sup_08&i.;             
            paral_memb_sup   = paral_memb_sup_08&i.;           
            incapacite       = incapacite_08&i.;               
            pilier_un        = pilier_un_08&i.;                
            pilier_deux      = pilier_deux_08&i.;              
            pilier_trois     = pilier_trois_08&i.;             
            arr              = arr_08&i.;                      
            critere_un       = critere_un_08&i.;               
            critere_deux     = critere_deux_08&i.;             
            critere_trois    = critere_trois_08&i.;            
            critere_quatre   = critere_quatre_08&i.;           
            critere_cinq     = critere_cinq_08&i.;             
            critere_six      = critere_six_08&i.;              
            date_deces       = date_deces_08&i.;               

            DROP
            type_rec_08&i.                  
            code_leg_08&i.                  
            date_start_recon_08&i.          
            date_end_recon_08&i.            
            memb_inf_50perc_08&i.           
            cecite_comp_08&i.               
            amp_memb_sup_08&i.              
            paral_memb_sup_08&i.            
            incapacite_08&i.                
            pilier_un_08&i.                 
            pilier_deux_08&i.               
            pilier_trois_08&i.              
            arr_08&i.                       
            critere_un_08&i.                
            critere_deux_08&i.              
            critere_trois_08&i.             
            critere_quatre_08&i.            
            critere_cinq_08&i.              
            critere_six_08&i.               
            date_deces_08&i.                
            ;
            
        RUN;

        /*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
        PROC SQL;
            CREATE TABLE COUNT_Indiv AS
            SELECT COUNT(*) AS NUM_Indiv
            FROM MED_&i.
            GROUP BY GECODEERD_INSZ
            ;
        QUIT;
        PROC FREQ DATA=COUNT_Indiv;
            TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand MED_&i.";
            TABLES NUM_Indiv;
        RUN;

    %END;

    DATA MED_BASIS;
        SET
        %DO i = 1 %TO 4;
            MED_&i 
        %END;
        ;

        /*converteer datum erkenning*/
        Jaar_M = INPUT(SUBSTR(TRIM(date_start_recon),4,4),8.);
        Maand_M = INPUT(SUBSTR(TRIM(date_start_recon),1,2),8.);
        Date_M = Jaar_M*100 + Maand_M;
        IF Date_M EQ . THEN Date_M = 0;

        /*bereken totale waarde parameter-criteria*/
        total_param_anc_legis = critere_un + critere_deux + critere_trois + critere_quatre + critere_cinq + critere_six;

    RUN;        
    PROC PRINT DATA=MED_BASIS(obs=20);
        TITLE "Waarde start datum medische erkenning en omzetting naar numerieke waarde";
        VAR date_start_recon Date_M;
    RUN;

    PROC FREQ DATA=MED_BASIS;
        TITLE "Verdeling waarden code recht: check of er missing values zijn";
        TABLES code_leg;
    RUN;        
    
    PROC SORT DATA=MED_BASIS;
        BY GECODEERD_INSZ date_start_recon;
    RUN;
    
    DATA MED_BASIS;
        SET MED_BASIS;
        BY GECODEERD_INSZ date_start_recon;
        
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;

    /*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
    PROC SQL;
        CREATE TABLE COUNT_Indiv AS
        SELECT COUNT(*) AS NUM_Indiv
        FROM MED_BASIS
        GROUP BY GECODEERD_INSZ
        ;
    QUIT;
    PROC FREQ DATA=COUNT_Indiv;
        TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand Med na samenvoeging onderdelen";
        TABLES NUM_Indiv;
    RUN;

    /*Voeg code wetgeving vanuit medisch toe aan rechtenbestand*/
    DATA DROIT_BASIS;
        SET lib.mim2008_fodsz_rht2008_new_code;
    RUN;
    PROC SORT DATA=DROIT_BASIS;
        BY GECODEERD_INSZ;
    RUN;
    DATA DROIT_BASIS;
        MERGE DROIT_BASIS(in=InA) MED_BASIS(KEEP=GECODEERD_INSZ code_leg);
        BY GECODEERD_INSZ;
        
        IF InA EQ 1;
        
        Jaar_D = INPUT(SUBSTR(TRIM(date_decision_&EEJJ.),4,4),8.);
        Maand_D = INPUT(SUBSTR(TRIM(date_decision_&EEJJ.),1,2),8.);
        Date_D = Jaar_D*100 + Maand_D;
        IF Date_D EQ . THEN Date_D = 0;
        
    RUN;
    PROC PRINT DATA=DROIT_BASIS(obs=20);
        TITLE "Waarde start datum beslissing recht en omzetting naar numerieke waarde";
        VAR date_decision_&EEJJ. Date_D;
    RUN;

    /*Test of een individu nog meer dan 1 keer voorkomt in het bestand met rechten*/
    PROC SQL;
        CREATE TABLE COUNT_Indiv AS
        SELECT COUNT(*) AS NUM_Indiv
        FROM DROIT_BASIS
        GROUP BY GECODEERD_INSZ
        ;
    QUIT;
    PROC FREQ DATA=COUNT_Indiv;
        TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand Droit";
        TABLES NUM_Indiv;
    RUN;
    
    /*Selecteer gegevens rechtenbestand en maak typologie IT-IVT*/
    /*Hou n recht over per individu: het recht met de laatste beslissingsdatum genomen voorafgaand aan maand x*/
    DATA DROIT;
        /*Selecteer enkel gegevens met aanduiding recht type 3 i.e. IT/IVT
        en 
        recht toegekend voor begin van x = om min of meer vergelijkbaar te zijn met jaarverslag*/
        SET 
        DROIT_BASIS(keep = GECODEERD_INSZ code_leg mnt_mens_sim_&EEJJ. mnt_mens_AI_sim_&EEJJ. date_decision_&EEJJ. Date_D WHERE=(code_leg="03" AND Date_D<%eval(&EEJJMM.)))
        ;
        IF mnt_mens_sim&EEJJ. EQ . THEN mnt_mens_sim&EEJJ. = 0;
        IF mnt_mens_AI_sim&EEJJ. EQ . THEN mnt_mens_AI_sim&EEJJ. = 0;
        IT = 0;
        IVT = 0;
        IF ABS(mnt_mens_sim_&EEJJ.-mnt_mens_AI_sim_&EEJJ.) LE 1 AND mnt_mens_AI_sim_&EEJJ. GT 0 THEN IT = 1;
        IF ABS(mnt_mens_sim_&EEJJ.-mnt_mens_AI_sim_&EEJJ.) GT 1 AND mnt_mens_AI_sim_&EEJJ. LE 0 THEN IVT = 1;
        IF ABS(mnt_mens_sim_&EEJJ.-mnt_mens_AI_sim_&EEJJ.) GT 1 AND mnt_mens_AI_sim_&EEJJ. GT 0 THEN DO;
            IT = 1;
            IVT = 1;
        END;
        IT_Type = 0;
        IF IT = 1 AND IVT = 0 THEN IT_Type = 1;
        IF IT = 0 AND IVT = 1 THEN IT_Type = 2;
        IF IT = 1 AND IVT = 1 THEN IT_Type = 3;
    RUN;
    PROC SORT DATA=DROIT;
        BY GECODEERD_INSZ date_decision_&EEJJ. IT_Type;
    RUN;
    DATA DROIT;
        SET DROIT;
        BY GECODEERD_INSZ;
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;

    /*Selecteer gegevens betalingsbestand en maak typologie IT-IVT*/
    /*Hou n betaling over per individu: er moet een betaling gebeurd zijn in maand x en bij meerdere
    betaling wordt de lijn met het hoogste bedrag gekozen*/
    /*Voeg code wetgeving vanuit medisch toe aan rechtenbestand*/
    DATA PAY_BASIS;
        SET lib.mim2008_fodsz_pay2008_new_code;
    RUN;
    /*Test of een individu nog meer dan 1 keer voorkomt in het bestand met betalingen*/
    PROC SQL;
        CREATE TABLE COUNT_Indiv_PAY AS
        SELECT GECODEERD_INSZ, COUNT(*) AS NUM_Indiv_PAY
        FROM PAY_BASIS
        GROUP BY GECODEERD_INSZ
        ;
    QUIT;
    PROC FREQ DATA=COUNT_Indiv;
        TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand PAY";
        TABLES NUM_Indiv;
    RUN;
    
    PROC SORT DATA=PAY_BASIS;
        BY GECODEERD_INSZ;
    RUN;
    DATA PAY_BASIS;
        MERGE PAY_BASIS(in=InA) MED_BASIS(KEEP=GECODEERD_INSZ code_leg) COUNT_Indiv_PAY;
        BY GECODEERD_INSZ;
        
        IF InA EQ 1;
        
        /*Merk op: per start pay is nog numeriek en staat in juiste formaat*/
        
    RUN;

    DATA PAY;
        /*Selecteer enkel betalingsgegevens van voor x zonder bijkomende condities (i.e. bedrag positief of niet 
        werd niet gecontroleerd, maar is ook moeilijk met onze gegevens*/
        SET 
        PAY_BASIS(keep = GECODEERD_INSZ per_start_pay_&EEJJ. per_end_pay_&EEJJ. montant_&EEJJ. mont_emis_&EEJJ. class_stat_&EEJJ. WHERE=(per_start_pay_&EEJJ.=%eval(&EEJJMM.)))
        ;

        /*Create PC*/
        PC = SUBSTR(class_stat_&EEJJ.,1,2);

        /*Lees medische categorie in*/
        IT_Code = "0";
        IF PC IN ("13", "14", "15", "16", "44", "46") THEN IT_Code = SUBSTR(class_stat_&EEJJ.,6,1);
        IT_Type_PC = 0;
        IF PC IN ("15", "16", "46")                                             THEN IT_Type_PC = 1;
        IF PC IN ("45") OR (PC IN ("13", "14", "44") AND IT_Code EQ "0")        THEN IT_Type_PC = 2;
        IF PC IN ("13", "14", "44") AND IT_Code IN ("1", "2", "3", "4", "5")    THEN IT_Type_PC = 3;
        KEEP GECODEERD_INSZ montant_&EEJJ. PC IT_Type_PC;
    RUN;
    PROC SORT DATA=PAY;
        BY GECODEERD_INSZ montant_&EEJJ. IT_Type_PC;
    RUN;    
    DATA PAY;
        SET PAY;
        BY GECODEERD_INSZ;
        DROP montant_&EEJJ.;
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;

    /*Selecteer gegevens medisch bestand en maak typologie IT-IVT*/
    /*Hou n medische beslissing over per individu: met name deze met de laatste ingangsdatum*/
    DATA MED;
        SET 
        MED_BASIS(keep = GECODEERD_INSZ code_leg date_start_recon arr total_param_anc_legis date_deces Date_M WHERE=(Date_M<%eval(&EEJJMM.)))
        ;
        IT_Type_MED = 0;
        IF total_param_anc_legis > 6 AND arr = 0 THEN IT_Type_MED = 1;
        IF total_param_anc_legis < 7 AND arr = 1 THEN IT_Type_MED = 2;
        IF total_param_anc_legis > 6 AND arr = 1 THEN IT_Type_MED = 3;
        KEEP GECODEERD_INSZ date_start_recon arr total_param_anc_legis IT_Type_MED;
    RUN;
    PROC SORT DATA=MED;
        BY GECODEERD_INSZ date_start_recon IT_Type_MED;
    RUN;
    DATA MED;
        SET MED;
        BY GECODEERD_INSZ;
        DROP date_start_recon;
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;
    /*Combineer rechten, betalingen en medische gegevens*/
    /*Rechten vormen de basis voor de afbakening van de populatie*/
    DATA COMBIN;
        MERGE PAY(in=InP) DROIT(in=InD) MED;
        BY GECODEERD_INSZ;
        /*Hou enkel gevallen over met een recht op uitkering en gekend in het betalingsbestand*/
        /*Betalingsgegevens worden verder enkel gebruikt voor identificatie statuut IT/IVT*/
        IF InP EQ 0 THEN DELETE;
        IF InD EQ 0 THEN DELETE;
    RUN;
    DATA COMBIN_ITIVT;
        SET COMBIN;
        BY GECODEERD_INSZ;
        IT_Type_PAY = IT_Type_PC;
        IF IT_Type_PC EQ . THEN IT_Type_PC = 0; 
        /*Indien op basis van vorige gegevens nog geen identificatie van het statuut IT/IVT mogelijk was,
        wijs dan toe op basis van "regel" met gesimuleerde bedragen*/
        IF IT_Type_PC EQ 0 AND IT_Type NE 0                THEN IT_Type_PC = IT_Type; 
        /*Indien cumul op basis van statistische codificatie maar niet op basis van gesimuleerd recht
        neem dan regel op basis van gesimuleerd recht*/
        IF IT_Type_PC EQ 3 AND IT_Type IN (1, 2)           THEN IT_Type_PC = IT_Type; 
        /*Indien op basis van voorgaande regels nog geen toewijzing gebruik dan medische categorie*/
        IF IT_Type_PC EQ 0 AND IT_Type_MED NE 0            THEN IT_Type_PC = IT_Type_MED; 
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;    
    
    /*Herhaal de oefening voor THB*/
    /*Hou n recht over per individu: het recht met de laatste beslissingsdatum genomen voorafgaand aan maand x*/
    DATA DROIT;
        /*Selecteer enkel gegevens met aanduiding recht type 4 i.e. THB
        en 
        recht toegekend voor begin van x = om min of meer vergelijkbaar te zijn met jaarverslag*/
        SET 
        DROIT_BASIS(keep = GECODEERD_INSZ code_leg date_decision_&EEJJ. Date_D WHERE=(code_leg="04" AND Date_D<%eval(&EEJJMM.)))
        ;
    RUN;
    PROC SORT DATA=DROIT;
        BY GECODEERD_INSZ date_decision_&EEJJ.;
    RUN;
    DATA DROIT;
        SET DROIT;
        BY GECODEERD_INSZ;
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;
    /*Selecteer gegevens betalingsbestand en maak typologie THB*/
    /*Hou n betaling over per individu: er moet een betaling gebeurd zijn in maand x en bij meerdere
    betaling wordt de lijn met het hoogste bedrag gekozen*/
    DATA PAY;
        /*Selecteer enkel betalingsgegevens van voor x zonder bijkomende condities (i.e. bedrag positief of niet 
        werd niet gecontroleerd, maar is ook moeilijk met onze gegevens*/
        SET 
        PAY_BASIS(keep = GECODEERD_INSZ per_start_pay_&EEJJ. montant_&EEJJ. WHERE=(per_start_pay_&EEJJ.=%eval(&EEJJMM.)))
        ;
        KEEP GECODEERD_INSZ montant_&EEJJ.;
    RUN;
    PROC SORT DATA=PAY;
        BY GECODEERD_INSZ montant_&EEJJ.;
    RUN;    
    DATA PAY;
        SET PAY;
        BY GECODEERD_INSZ;
        DROP montant_&EEJJ.;
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;
    /*Combineer rechten, betalingen en medische gegevens*/
    /*Rechten vormen de basis voor de afbakening van de populatie*/
    DATA COMBIN;
        MERGE PAY(in=InP) DROIT(in=InD);
        BY GECODEERD_INSZ;
        /*Hou enkel gevallen over met een recht op uitkering*/
        IF InP EQ 0 THEN DELETE;
        IF InD EQ 0 THEN DELETE;
    RUN;
    DATA COMBIN_THB;
        SET COMBIN;
        BY GECODEERD_INSZ;
        IT_Type_PC = 4; 
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;    
    
    /*Zet beide bestanden onder elkaar*/
    DATA ITIVT_THB;
        SET
        COMBIN_ITIVT
        COMBIN_THB
        ;
        IT_Type_PC_&EEJJMMDD. = IT_Type_PC;
        LABEL  IT_Type_PC_&EEJJMMDD. = "IT-IVT-THB status bij de start van maand &EEJJMM";
    RUN;
    PROC SORT DATA=ITIVT_THB;
        BY GECODEERD_INSZ IT_Type_PC_&EEJJMMDD.;
    RUN;
    DATA ITIVT_THB_&EEJJMMDD.;
        SET ITIVT_THB;
        BY GECODEERD_INSZ;
        
        KEEP GECODEERD_INSZ IT_Type_PC_&EEJJMMDD.;
        
        IF LAST.GECODEERD_INSZ THEN OUTPUT;
    RUN;
    PROC SORT DATA=ITIVT_THB_&EEJJMMDD.;
        BY GECODEERD_INSZ;
    RUN;        
    
%MEND MakeHand_Stat;
/*Compute statistics*/
%MACRO Compute_Stat(DayA);
    %LET maandA = %SUBSTR(&DayA,1,6);
    %LET JaarA  = %SUBSTR(&DayA,1,4);
    %MakeHand_Stat(&DayA);
    PROC FORMAT;
        value NumFMTA     
            . = "missing value"
            0 = "Individu gekend, maar met onbekend statuut bij de start van &maandA"
            1 = "Enkel IT  bij de start van &maandA"
            2 = "Enkel IVT bij de start van &maandA"
            3 = "IT-IVT bij de start van &maandA"
            4 = "THB bij de start van &maandA"
            5 = "Individu werd niet geobserveerd bij de start van &maandA"
        other = "Individu gekend, maar met onbekend statuut bij de start van &maandA"
        ;
    RUN;
    /*Frequentietabel gereconstrueerde gegevens*/
    PROC FREQ DATA=ITIVT_THB_&DayA.;
        TITLE1 "Start nieuwe analyse    Start nieuwe analyse    Start nieuwe analyse";
        TITLE2 "====================================================================";
        TITLE3 "Frequentie van gereconstrueerde status op basis van de gegevens aangeleverd aan het DWH AMenSB";
        TITLE4 "resultaten voor &maandA";
        TABLES IT_Type_PC_&DayA. / NoCum;
        FORMAT IT_Type_PC_&DayA. NumFMTA. ;
    RUN;
%MEND Compute_Stat;
%Compute_Stat(20080101);
%Compute_Stat(20080201);
%Compute_Stat(20080301);
%Compute_Stat(20080401);
%Compute_Stat(20080501);
%Compute_Stat(20080601);
%Compute_Stat(20080701);
%Compute_Stat(20080801);
%Compute_Stat(20080901);
%Compute_Stat(20081001);
%Compute_Stat(20081101);
%Compute_Stat(20081201);
/*Voeg gegevens samen in n bestand*
/*Reduceer eerst ieder basisbestand tot n lijn */
/*Medisch bestand*/
/*herlabel want variabelen werden samengevoegd op basis van 4 medische bestanden*/
DATA MED_BASIS;
    SET MED_BASIS(DROP=Jaar_M Maand_M Date_M);
    
    LABEL type_rec              = "Type Record";
    LABEL code_leg              = "Code wetgeving";
    LABEL date_start_recon      = "Begindatum erkenning (=beslissing medische commissie)";
    LABEL date_end_recon        = "Einddatum erkenning (=beslissing medische commissie)";
    LABEL memb_inf_50perc       = "50% onderste ledematen";
    LABEL cecite_comp           = "Volledige blindheid";
    LABEL amp_memb_sup          = "Amputatie van bovenste ledematen";
    LABEL paral_memb_sup        = "Verlamming van de bovenste ledematen";
    LABEL incapacite            = "ongeschiktheid";
    LABEL pilier_un             = "pijler 1";
    LABEL pilier_deux           = "pijler 2";
    LABEL pilier_trois          = "pijler 3";
    LABEL arr                   = "IVT";
    LABEL critere_un            = "punten criterium 1";
    LABEL critere_deux          = "punten criterium 2";
    LABEL critere_trois         = "punten criterium 3";
    LABEL critere_quatre        = "punten criterium 4";
    LABEL critere_cinq          = "punten criterium 5";
    LABEL critere_six           = "punten criterium 6";
    LABEL total_param_anc_legis = "totaal parameters op 18 of 15 voor oude wet";
    LABEL date_deces            = "Overlijdensdatum";

    /*Maak extra variabelen aan voor bepaling kinderbijslag*/
    /*Zet pijler 1 om naar juiste waarde voor bepaling VKB-nieuwe wet: zie VragenDGPMHV6.doc*/
    pilier_un_conv = 0;
    IF pilier_un EQ 1 THEN pilier_un_conv = 0;
    IF pilier_un EQ 2 THEN pilier_un_conv = 1;
    IF pilier_un EQ 3 THEN pilier_un_conv = 2;
    IF pilier_un EQ 4 THEN pilier_un_conv = 4;
    IF pilier_un EQ 5 THEN pilier_un_conv = 6;
    LABEL pilier_un_conv             = "pijler 1: omgezet voor bepaling VKB nieuwe wet";
    /*Schat waarde punten zelfredzaamheid: gegeven werd niet opgevraagd*/
    Aandoen = memb_inf_50perc + cecite_comp + amp_memb_sup + paral_memb_sup;
    PUNT_ZELFVKB = 0;
    IF incapacite LE 1 AND Aandoen EQ 0 THEN PUNT_ZELFVKB = 1;
    IF incapacite LE 1 AND Aandoen GE 1 THEN PUNT_ZELFVKB = 3;
    IF incapacite EQ 2 AND Aandoen EQ 0 THEN PUNT_ZELFVKB = 2;
    IF incapacite EQ 2 AND Aandoen GE 1 THEN PUNT_ZELFVKB = 3;
    IF incapacite GE 3 AND Aandoen EQ 0 THEN PUNT_ZELFVKB = 3;
    IF incapacite GE 3 AND Aandoen GE 1 THEN PUNT_ZELFVKB = 3;
    LABEL PUNT_ZELFVKB             = "Geschat aantal punten zelfredzaamheid voor bepaling VKB oude wet";

    DROP Aandoen;
    
RUN;
PROC FREQ DATA=MED_BASIS(WHERE=(code_leg="01"));
    TITLE "Geschat aantal punten zelfredzaamheid voor gevallen VKB oude wet";
    TABLES PUNT_ZELFVKB;
RUN;    
PROC SORT DATA=MED_BASIS;
    BY GECODEERD_INSZ date_start_recon;
RUN;
DATA MED_BASIS;
    SET MED_BASIS;
    BY GECODEERD_INSZ date_start_recon;
    
    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC CONTENTS DATA=MED_BASIS;
    TITLE1 " ";
RUN;
/*Bestand met rechten*/
/*alle variabelen zouden al een label moeten hebben*/
DATA DROIT_BASIS;
    SET DROIT_BASIS(DROP=Jaar_D Maand_D Date_D code_leg);
RUN;
PROC SORT DATA=DROIT_BASIS;
    BY GECODEERD_INSZ date_start_2008;
RUN;
DATA DROIT_BASIS;
    SET DROIT_BASIS;
    BY GECODEERD_INSZ date_start_2008;
    
    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC CONTENTS DATA=DROIT_BASIS;
RUN;
/*Bestand met betalingen*/
DATA PAY_BASIS;
    SET PAY_BASIS(DROP=code_leg);
    
    LABEL NUM_Indiv_PAY = "Aantal keer dat een individu een betaling ontving gedurende het jaar";
    
    /*Converteer datums naar vast datum-formaat*/
    LENGTH StartV $6.;
    LENGTH StopV $6.;
    LENGTH NStartV $7.;
    LENGTH NStopV $7.;

    StartV = PUT(per_start_pay_2008,6.);
    StopV = PUT(per_end_pay_2008,6.);
    NStartV = SUBSTR(StartV,5,2) || "-" || SUBSTR(StartV,1,4);
    NStopV = SUBSTR(StopV,5,2) || "-" || SUBSTR(StopV,1,4);

    LABEL NStartV = "Begindatum betaling";
    LABEL NStopV = "Einddatum betaling";
    DROP StartV StopV per_start_pay_2008 per_end_pay_2008;
    
RUN;
DATA PAY_BASIS;
    SET PAY_BASIS(RENAME=(NStartV=per_start_pay_2008 NStopV=per_end_pay_2008));
RUN;    
PROC SORT DATA=PAY_BASIS;
    BY GECODEERD_INSZ per_start_pay_2008;
RUN;
DATA PAY_BASIS;
    SET PAY_BASIS;
    BY GECODEERD_INSZ per_start_pay_2008;

    RETAIN mont_emis_agg 0;
    
    IF FIRST.GECODEERD_INSZ THEN DO;
        mont_emis_agg = 0;    
        IF mont_emis_2008 NE . THEN mont_emis_agg = mont_emis_2008;
    END;
    ELSE DO;
        IF mont_emis_2008 NE . THEN mont_emis_agg = mont_emis_agg + mont_emis_2008;
    END;
        
    DROP mont_emis_2008;
    
    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC CONTENTS DATA=PAY_BASIS;
RUN;
/*Partner-bestand*/
DATA PTN_BASIS;
    SET lib.mim2008_fodsz_ptn2008_new_code(RENAME=(date_start_2008=date_start_ptn_2008 date_end_2008=date_end_ptn_2008));
    
    LABEL gecodeerd_insz            = "Gecodeerd INSZ van het individu zelf";
    LABEL gecodeerd_insz_partner    = "Gecodeerd INSZ van de partner van het individu";

RUN;
PROC SORT DATA=PTN_BASIS;
    BY GECODEERD_INSZ date_start_ptn_2008;
RUN;
DATA PTN_BASIS;
    SET PTN_BASIS;
    BY GECODEERD_INSZ date_start_ptn_2008;
    
    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC CONTENTS DATA=PTN_BASIS;
RUN;
/*Bestand met aanvullende variabele statuut IT-IVT-THB*/
PROC SORT DATA=ITIVT_THB_20080101;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20080201;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20080301;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20080401;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20080501;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20080601;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20080701;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20080801;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20080901;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20081001;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20081101;
    BY GECODEERD_INSZ;
RUN;    
PROC SORT DATA=ITIVT_THB_20081201;
    BY GECODEERD_INSZ;
RUN;    
/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
/*Voeg bestanden samen*/
DATA LIBW.MIM2008_FODSZ;
    MERGE TOTPOP(in=InA) MED_BASIS(in=InB) DROIT_BASIS(in=InC) PAY_BASIS(in=InD) PTN_BASIS ITIVT_THB_20080101 ITIVT_THB_20080201 ITIVT_THB_20080301 ITIVT_THB_20080401 ITIVT_THB_20080501 ITIVT_THB_20080601 ITIVT_THB_20080701 ITIVT_THB_20080801 ITIVT_THB_20080901 ITIVT_THB_20081001 ITIVT_THB_20081101 ITIVT_THB_20081201;
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InFODSZ = 0;
    IF InB EQ 1 OR InC EQ 1 OR InD EQ 1 THEN InFODSZ = 1;
    LABEL InFODSZ = "Individu geselecteerd uit n van de drie basisbestanden FODSZ voor verwerking steekproef";

    /*Rename*/
    mont_emis_2008 = mont_emis_agg;
    /*Label*/
    LABEL mont_emis_2008 = "Totaal betaald bedrag gedurende de periode";

    IF IT_Type_PC_20080101      EQ . THEN IT_Type_PC_20080101 = 0;  
    IF IT_Type_PC_20080201      EQ . THEN IT_Type_PC_20080201 = 0;  
    IF IT_Type_PC_20080301      EQ . THEN IT_Type_PC_20080301 = 0;  
    IF IT_Type_PC_20080401      EQ . THEN IT_Type_PC_20080401 = 0;  
    IF IT_Type_PC_20080501      EQ . THEN IT_Type_PC_20080501 = 0;  
    IF IT_Type_PC_20080601      EQ . THEN IT_Type_PC_20080601 = 0;  
    IF IT_Type_PC_20080701      EQ . THEN IT_Type_PC_20080701 = 0;  
    IF IT_Type_PC_20080801      EQ . THEN IT_Type_PC_20080801 = 0;  
    IF IT_Type_PC_20080901      EQ . THEN IT_Type_PC_20080901 = 0;  
    IF IT_Type_PC_20081001      EQ . THEN IT_Type_PC_20081001 = 0;  
    IF IT_Type_PC_20081101      EQ . THEN IT_Type_PC_20081101 = 0;  
    IF IT_Type_PC_20081201      EQ . THEN IT_Type_PC_20081201 = 0;  
    IF NUM_Indiv_PAY            EQ . THEN NUM_Indiv_PAY = 0;        
    IF amp_memb_sup             EQ . THEN amp_memb_sup = 0;         
    IF arr                      EQ . THEN arr = 0;                  
    IF cecite_comp              EQ . THEN cecite_comp = 0;          
    IF critere_un               EQ . THEN critere_un = 0;           
    IF critere_deux             EQ . THEN critere_deux = 0;         
    IF critere_trois            EQ . THEN critere_trois = 0;        
    IF critere_quatre           EQ . THEN critere_quatre = 0;       
    IF critere_cinq             EQ . THEN critere_cinq = 0;         
    IF critere_six              EQ . THEN critere_six = 0;          
    IF incapacite               EQ . THEN incapacite = 0;           
    IF memb_inf_50perc          EQ . THEN memb_inf_50perc = 0;      
    IF mnt_mens_AI_sim_2008     EQ . THEN mnt_mens_AI_sim_2008 = 0;        
    IF mnt_mens_sim_2008        EQ . THEN mnt_mens_sim_2008 = 0;        
    IF mont_emis_2008           EQ . THEN mont_emis_2008 = 0;       
    IF montant_2008             EQ . THEN montant_2008 = 0;         
    IF paral_memb_sup           EQ . THEN paral_memb_sup = 0;       
    IF periode_2008             EQ . THEN periode_2008 = 0;         
    IF pilier_un                EQ . THEN pilier_un = 0; 
    IF pilier_un_conv           EQ . THEN pilier_un_conv = 0; 
    IF pilier_deux              EQ . THEN pilier_deux = 0;          
    IF pilier_trois             EQ . THEN pilier_trois = 0;         
    IF total_param_anc_legis    EQ . THEN total_param_anc_legis = 0;
    IF PUNT_ZELFVKB             EQ . THEN PUNT_ZELFVKB = 0;

    /*Maak variabele die maandstatuten combineert*/    
    Length IT_Type_PC_20080101Char $1; 
    Length IT_Type_PC_20080201Char $1; 
    Length IT_Type_PC_20080301Char $1; 
    Length IT_Type_PC_20080401Char $1; 
    Length IT_Type_PC_20080501Char $1; 
    Length IT_Type_PC_20080601Char $1; 
    Length IT_Type_PC_20080701Char $1; 
    Length IT_Type_PC_20080801Char $1;                 
    Length IT_Type_PC_20080901Char $1; 
    Length IT_Type_PC_20081001Char $1; 
    Length IT_Type_PC_20081101Char $1; 
    Length IT_Type_PC_20081201Char $1; 
    IT_Type_PC_20080101Char = putn(IT_Type_PC_20080101,'1.');    
    IT_Type_PC_20080201Char = putn(IT_Type_PC_20080201,'1.');    
    IT_Type_PC_20080301Char = putn(IT_Type_PC_20080301,'1.');    
    IT_Type_PC_20080401Char = putn(IT_Type_PC_20080401,'1.');    
    IT_Type_PC_20080501Char = putn(IT_Type_PC_20080501,'1.');    
    IT_Type_PC_20080601Char = putn(IT_Type_PC_20080601,'1.');    
    IT_Type_PC_20080701Char = putn(IT_Type_PC_20080701,'1.');    
    IT_Type_PC_20080801Char = putn(IT_Type_PC_20080801,'1.');    
    IT_Type_PC_20080901Char = putn(IT_Type_PC_20080901,'1.');    
    IT_Type_PC_20081001Char = putn(IT_Type_PC_20081001,'1.');    
    IT_Type_PC_20081101Char = putn(IT_Type_PC_20081101,'1.');    
    IT_Type_PC_20081201Char = putn(IT_Type_PC_20081201,'1.');    
    Length IT_Type_PC_2008 $12; 
    IT_Type_PC_2008 = IT_Type_PC_20080101Char || IT_Type_PC_20080201Char || IT_Type_PC_20080301Char || IT_Type_PC_20080401Char || IT_Type_PC_20080501Char || IT_Type_PC_20080601Char || IT_Type_PC_20080701Char || IT_Type_PC_20080801Char || IT_Type_PC_20080901Char || IT_Type_PC_20081001Char || IT_Type_PC_20081101Char || IT_Type_PC_20081201Char;
    LABEL IT_Type_PC_2008 = "IT-IVT-THB status bij de start van iedere maand in 2008";
    
    DROP    IT_Type_PC_20080101Char IT_Type_PC_20080201Char IT_Type_PC_20080301Char IT_Type_PC_20080401Char 
            IT_Type_PC_20080501Char IT_Type_PC_20080601Char IT_Type_PC_20080701Char IT_Type_PC_20080801Char 
            IT_Type_PC_20080901Char IT_Type_PC_20081001Char IT_Type_PC_20081101Char IT_Type_PC_20081201Char
            mont_emis_agg;

RUN;  
PROC CONTENTS DATA=LIBW.MIM2008_FODSZ;
RUN;
/*Frequentie van voorkomen van gevallen*/
PROC FREQ DATA=LIBW.MIM2008_FODSZ;
    TITLE "Frequentie van voorkomen individuen";
    TABLES InFODSZ;
RUN;   
PROC FREQ DATA=LIBW.MIM2008_FODSZ;
    TITLE "Frequentie van voorkomen statuten per maand";
    TABLES IT_Type_PC_2008;
RUN;   
/*Frequentie zelfredzaamheid voor gevallen met statuut*/
PROC FREQ DATA=LIBW.MIM2008_FODSZ(WHERE=(IT_Type_PC_20081201>0));
    TITLE "Frequentie zelfredzaamheid voor gevallen met statuut IT IVT of THB";
    TABLES total_param_anc_legis arr;
RUN;   
/*Maak bestand met variabelen om een aantal test-statistieken te berekenen*/
DATA BasA;
    SET LIBW.MIM2008_FODSZ(KEEP = GECODEERD_INSZ IT_Type_PC_20081201 total_param_anc_legis RENAME=(IT_Type_PC_20081201=Class_ITIVT total_param_anc_legis=PuntIT));
RUN;
PROC SORT DATA=BasA;
    BY GECODEERD_INSZ;
RUN;    
DATA BasB;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ NAREGNIS_COMMUNIT NAREGNIS_DATBIRTH MIMOSIS_WEIGHT);
RUN;
PROC SORT DATA=BasB;
    BY GECODEERD_INSZ;
RUN;    
DATA TestStat;

    MERGE BasA BasB;
    BY GECODEERD_INSZ;
    
    GebJaar = INPUT(SUBSTR(NAREGNIS_DATBIRTH,4,4),8.);

    /*Leeftijd*/
    indexstreepje = INDEX(NAREGNIS_DATBIRTH,'-');
    yearbirth     = INPUT(SUBSTR(NAREGNIS_DATBIRTH,indexstreepje+1,4),8.);
    monthbirth    = INPUT(SUBSTR(NAREGNIS_DATBIRTH,1,indexstreepje-1),8.);
    Leeftijd      = FLOOR(((2008 - yearbirth)*12 + monthbirth)/12);
    AGE = 9999999;
    IF NAREGNIS_DATBIRTH NE "9999999" AND TRIM(NAREGNIS_DATBIRTH) NE "-" THEN AGE = Leeftijd ;

    /*4 testvariabelen uit Handilab*/
    LENGTH Var_A $3;
    LENGTH Var_B $3;
    LENGTH Var_D $3;
    LENGTH Var_E $3;

    /*Omzetting IT-IVT*/
    IF Class_ITIVT  EQ 1    THEN Var_A = "A2";
    IF Class_ITIVT  EQ 2    THEN Var_A = "A3";
    IF Class_ITIVT  EQ 3    THEN Var_A = "A1";

    /*Omzetting punten IT*/
    IF PuntIT       EQ 0    THEN Var_B = "B18";
    IF PuntIT       EQ 1    THEN Var_B = "B2";
    IF PuntIT       EQ 2    THEN Var_B = "B17";
    IF PuntIT       EQ 3    THEN Var_B = "B3";
    IF PuntIT       EQ 4    THEN Var_B = "B16";
    IF PuntIT       EQ 5    THEN Var_B = "B4";
    IF PuntIT       EQ 6    THEN Var_B = "B15";
    IF PuntIT       EQ 7    THEN Var_B = "B5";
    IF PuntIT       EQ 8    THEN Var_B = "B14";
    IF PuntIT       EQ 9    THEN Var_B = "B6";
    IF PuntIT       EQ 10   THEN Var_B = "B13";
    IF PuntIT       EQ 11   THEN Var_B = "B7";
    IF PuntIT       EQ 12   THEN Var_B = "B12";
    IF PuntIT       EQ 13   THEN Var_B = "B8";
    IF PuntIT       EQ 14   THEN Var_B = "B11";
    IF PuntIT       EQ 15   THEN Var_B = "B9";
    IF PuntIT       EQ 16   THEN Var_B = "B10";
    IF PuntIT       EQ 17   THEN Var_B = "B1";
    IF PuntIT       EQ 18   THEN Var_B = "B19";

    /*Omzetting geboortejaar*/
    IF GebJaar                          LT 1950 THEN Var_D = "D9";
    IF GebJaar      GE 1950 AND GebJaar LT 1955 THEN Var_D = "D1";
    IF GebJaar      GE 1955 AND GebJaar LT 1960 THEN Var_D = "D8";
    IF GebJaar      GE 1960 AND GebJaar LT 1965 THEN Var_D = "D2";
    IF GebJaar      GE 1965 AND GebJaar LT 1970 THEN Var_D = "D7";
    IF GebJaar      GE 1970 AND GebJaar LT 1975 THEN Var_D = "D3";
    IF GebJaar      GE 1975 AND GebJaar LT 1980 THEN Var_D = "D6";
    IF GebJaar      GE 1980 AND GebJaar LT 1985 THEN Var_D = "D4";
    IF GebJaar      GE 1985 AND GebJaar LT 1990 THEN Var_D = "D5";

    /*Maak provincie*/
    IF NAREGNIS_COMMUNIT GE 11000 AND NAREGNIS_COMMUNIT LE 13053 THEN Var_E = "E2";
    IF NAREGNIS_COMMUNIT GE 21001 AND NAREGNIS_COMMUNIT LE 21019 THEN Var_E = "E9";
    IF NAREGNIS_COMMUNIT GE 23002 AND NAREGNIS_COMMUNIT LE 24137 THEN Var_E = "E1";
    IF NAREGNIS_COMMUNIT GE 25005 AND NAREGNIS_COMMUNIT LE 25124 THEN Var_E = "E8";
    IF NAREGNIS_COMMUNIT GE 31003 AND NAREGNIS_COMMUNIT LE 38025 THEN Var_E = "E12";
    IF NAREGNIS_COMMUNIT GE 41002 AND NAREGNIS_COMMUNIT LE 46025 THEN Var_E = "E11";
    IF NAREGNIS_COMMUNIT GE 51004 AND NAREGNIS_COMMUNIT LE 57095 THEN Var_E = "E10";
    IF NAREGNIS_COMMUNIT GE 61003 AND NAREGNIS_COMMUNIT LE 64076 THEN Var_E = "E6";
    IF NAREGNIS_COMMUNIT GE 71002 AND NAREGNIS_COMMUNIT LE 73109 THEN Var_E = "E3";
    IF NAREGNIS_COMMUNIT GE 81001 AND NAREGNIS_COMMUNIT LE 85047 THEN Var_E = "E5";
    IF NAREGNIS_COMMUNIT GE 91005 AND NAREGNIS_COMMUNIT LE 93090 THEN Var_E = "E4";

RUN;
PROC FREQ DATA=TestStat(WHERE=(AGE > 20 AND AGE < 65 AND Class_ITIVT > 0));
    TITLE1 "Aantal teststatistieken op basis van steekproef om te vergelijken met populatie-niveau";
    TITLE2 "Niet gewogen resultaten";
    TABLES VAR_A VAR_B VAR_D VAR_E;
RUN;    
PROC FREQ DATA=TestStat(WHERE=(AGE > 20 AND AGE < 65 AND Class_ITIVT > 0));
    TITLE1 "Aantal teststatistieken op basis van steekproef om te vergelijken met populatie-niveau";
    TITLE2 "Gewogen resultaten";
    TABLES VAR_A VAR_B VAR_D VAR_E;
    WEIGHT MIMOSIS_WEIGHT;
RUN;    
PROC FREQ DATA=TestStat;
    TITLE1 "Verdeling statuut IT-IVT-THB voor december 2008";
    TITLE2 "Gewogen resultaten";
    TABLES Class_ITIVT;
    WEIGHT MIMOSIS_WEIGHT;
RUN;    
/*Einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
