/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens NIC
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateNIC_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateNIC.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA NIC;
    SET LIB.mim2008_nic_code;
    
    LENGTH Date_Start $6.; 
    LENGTH Date_End $6.; 
    /*converteer begin en einddatum*/
    Date_Start = SUBSTR(TRIM(NIC_BEGDATUM_2008),4,4) || SUBSTR(TRIM(NIC_BEGDATUM_2008),1,2);
    Date_End   = SUBSTR(TRIM(NIC_ENDDATUM_2008),4,4) || SUBSTR(TRIM(NIC_ENDDATUM_2008),1,2);

    /*bepaal werkelijke begin-maand ziekte*/    
    Monthstart  = INPUT(SUBSTR(TRIM(NIC_BEGDATUM_2008),1,2),8.);
    Monthend    = INPUT(SUBSTR(TRIM(NIC_ENDDATUM_2008),1,2),8.);
    AantalAO_Geschat = (Monthend - Monthstart + 1)*26;
    AantalMaanden = FLOOR((NIC_DAGENAO_2008 - AantalAO_Geschat)/26);
    Jaarstart = 2008;
    /*Vervang startmaand en/of startjaar*/
    /*van 0 tot 11, van 12 tot 23, van 24 tot 35, van 36 tot 47*/
    IF AantalMaanden GE 0 AND AantalMaanden LT 12 THEN DO;
        Monthstart = 12 - AantalMaanden;
        Jaarstart = 2007;
    END;    
    IF AantalMaanden GE 12 AND AantalMaanden LT 24 THEN DO;
        Monthstart = 24 - AantalMaanden;
        Jaarstart = 2006;
    END;    
    IF AantalMaanden GE 24 AND AantalMaanden LT 35 THEN DO;
        Monthstart = 35 - AantalMaanden;
        Jaarstart = 2005;
    END;    
    IF AantalMaanden GE 36 AND AantalMaanden LT 47 THEN DO;
        Monthstart = 47 - AantalMaanden;
        Jaarstart = 2004;
    END;    
    
    LENGTH Date_Start_Cor $6.;
    IF Monthstart LT 10 THEN Date_Start_Cor = PUT(Jaarstart,4.) || "0" || PUT(Monthstart,1.);
    IF Monthstart GE 10 THEN Date_Start_Cor = PUT(Jaarstart,4.) || PUT(Monthstart,2.);
    
    /*Vaststelling: bedragen en dagen die gewoon geaggregeerd worden leveren een zware overschatting op
    van het geobserveerd totaal. Redelijke aanpassing lijkt mogelijk op basis van het geobserveerde dagbedrag en
    het aftoppen van het aantal dagen*/
    
    MeanDag = 0;
    IF NIC_DAGENAO_2008 NE 0 THEN MeanDag = NIC_BEDRAG_2008/NIC_DAGENAO_2008;
        
    /*Aantal betalingsmaanden*/
    indexstreepje = INDEX(NIC_BEGDATUM_2008,'-');
    BegMaand      = INPUT(SUBSTR(NIC_BEGDATUM_2008,1,indexstreepje-1),8.);
    indexstreepje = INDEX(NIC_ENDDATUM_2008,'-');
    EndMaand      = INPUT(SUBSTR(NIC_ENDDATUM_2008,1,indexstreepje-1),8.);
    
    IF BegMaand EQ .  THEN BegMaand = 0;
    IF BegMaand GT 12 THEN BegMaand = 12;
    IF BegMaand LT 1  THEN BegMaand = 1;
    IF EndMaand EQ .  THEN EndMaand = 0;
    IF EndMaand GT 12 THEN EndMaand = 12;
    IF EndMaand LT 1  THEN EndMaand = 1;
    
    AantMaand = EndMaand - BegMaand + 1;
    
    /*Regel Primaire arbeidsongeschiktheid*/
    IF NIC_SRTDAGEN_2008 EQ '01' AND NIC_DAGENAO_2008 LT 312 AND NIC_DAGENAO_2008 GT ((AantMaand+2)*26) THEN NIC_DAGENAO_2008 = ((AantMaand+2)*26);
    IF NIC_SRTDAGEN_2008 EQ '01' AND NIC_DAGENAO_2008 GT 312 THEN NIC_DAGENAO_2008 = 312;
    /*Regel Moederschapsuitkeringen*/
    /*Maximum aantal weken = 17 plus een week*/
    IF NIC_SRTDAGEN_2008 EQ '05' AND NIC_DAGENAO_2008 GT (19*6) THEN NIC_DAGENAO_2008 = (19*6);
    
    IF NIC_SRTDAGEN_2008 IN ('01', '05') THEN NIC_BEDRAG_2008 = NIC_DAGENAO_2008*MeanDag;

    DROP MeanDag indexstreepje BegMaand EndMaand;
    
RUN;
PROC FREQ DATA=NIC;
    TITLE1 "Geschat aantal maanden dat vooraf gaat aan de werkelijk geobserveerde begindatum";
    TITLE2 "en gecorrigeerde begindatum ziekte";
    TABLES AantalMaanden Date_Start_Cor;
RUN;    
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv, COUNT(DISTINCT NIC_STELSEL_2008) AS NUM_Stelsel, COUNT(DISTINCT NIC_SRTDAGEN_2008) AS NUM_Dagen
    FROM NIC
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat n individu voorkomt met verschillende steselwaarden";
    TABLES NUM_Stelsel;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende waarden voor soort dagen";
    TABLES NUM_Dagen;
RUN;
/*reduceer bestand tot n lijn per individu op basis van voorgaande tests*/
PROC SORT DATA=NIC;
    BY GECODEERD_INSZ NIC_STELSEL_2008 NIC_SRTDAGEN_2008;
RUN;
DATA NIC;
    SET NIC;
    BY GECODEERD_INSZ NIC_STELSEL_2008 NIC_SRTDAGEN_2008;
    
    /*dagen en bedragen worden niet meer opgeteld*/
    RETAIN NIC_BEGDATUM_agg NIC_BEGDATUM_agg_cor NIC_ENDDATUM_agg '      ';
    
    IF FIRST.GECODEERD_INSZ THEN DO;
        /*Datumwaarden*/
        NIC_BEGDATUM_agg        = Date_Start;
        NIC_BEGDATUM_agg_cor    = Date_Start_Cor;
        NIC_ENDDATUM_agg        = Date_End;
    END;
    ELSE DO;
        /*Datumwaarden*/
        IF Date_Start_Cor LT NIC_BEGDATUM_agg_cor THEN DO;
            NIC_BEGDATUM_agg        = Date_Start;
            NIC_BEGDATUM_agg_cor    = Date_Start_Cor;
        END;
        IF Date_End GT NIC_ENDDATUM_agg THEN DO;
            NIC_ENDDATUM_agg = Date_End;
        END;
    END;
    
    KEEP
    GECODEERD_INSZ
    NIC_BEDRAG_2008
    NIC_DAGENAO_2008
    NIC_BEGDATUM_agg
    NIC_BEGDATUM_agg_cor
    NIC_ENDDATUM_agg
    NIC_STELSEL_2008 
    NIC_SRTDAGEN_2008
    ;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
    
RUN;
DATA NIC;

    SET NIC;
    
    LENGTH NIC_BEGDATUM_2008            $7.;
    LENGTH NIC_BEGDATUM_2008_CORR       $7.;
    LENGTH NIC_ENDDATUM_2008            $7.;
    
    NIC_BEGDATUM_2008       = SUBSTR(TRIM(NIC_BEGDATUM_agg),5,2) || "-" || SUBSTR(TRIM(NIC_BEGDATUM_agg),1,4); 
    NIC_BEGDATUM_2008_CORR  = SUBSTR(TRIM(NIC_BEGDATUM_agg_cor),5,2) || "-" || SUBSTR(TRIM(NIC_BEGDATUM_agg_cor),1,4); 
    NIC_ENDDATUM_2008       = SUBSTR(TRIM(NIC_ENDDATUM_agg),5,2) || "-" || SUBSTR(TRIM(NIC_ENDDATUM_agg),1,4);

    LABEL NIC_DAGENAO_2008          = "Aantal dagen arbeidsongeschiktheid (2008) ";
    LABEL NIC_BEDRAG_2008           = "Betaald bedrag aan uitkeringen (2008)";
    LABEL NIC_BEGDATUM_2008         = "Begindatum ziekte (2008) ";
    LABEL NIC_BEGDATUM_2008_CORR    = "Begindatum ziekte (2008): gecorrigeerd op basis van aantal ziektedagen per lijn";
    LABEL NIC_ENDDATUM_2008         = "Einddatum ziekte (2008)";

    KEEP
    GECODEERD_INSZ
    NIC_DAGENAO_2008
    NIC_BEDRAG_2008
    NIC_BEGDATUM_2008
    NIC_BEGDATUM_2008_CORR
    NIC_ENDDATUM_2008
    NIC_STELSEL_2008 
    NIC_SRTDAGEN_2008
    ;
    
RUN;    
PROC FREQ DATA=NIC;
    TABLES NIC_STELSEL_2008 NIC_SRTDAGEN_2008 NIC_BEGDATUM_2008 NIC_BEGDATUM_2008_CORR NIC_ENDDATUM_2008;
RUN;
PROC MEANS DATA=NIC;
    VAR NIC_DAGENAO_2008 NIC_BEDRAG_2008;
RUN;
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv, COUNT(DISTINCT NIC_STELSEL_2008) AS NUM_Stelsel, COUNT(DISTINCT NIC_SRTDAGEN_2008) AS NUM_Dagen
    FROM NIC
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na reductie";
    TABLES NUM_Indiv;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat n individu voorkomt met verschillende steselwaarden: na reductie";
    TABLES NUM_Stelsel;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende waarden voor soort dagen: na reductie";
    TABLES NUM_Dagen;
RUN;
/*aanmaak finaal bestand*/
DATA LIBW.MIM2008_NIC;
    MERGE TOTPOP(in=InA) NIC(in=InB);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InNIC = 0;
    IF InB EQ 1 THEN InNIC = 1;
    LABEL InNIC = "Individu geselecteerd uit basisdata NIC voor verwerking steekproef";
    
    IF NIC_DAGENAO_2008 EQ . THEN NIC_DAGENAO_2008 = 0;
    IF NIC_BEDRAG_2008  EQ . THEN NIC_BEDRAG_2008  = 0;

RUN;
PROC CONTENTS DATA=LIBW.MIM2008_NIC;
RUN;
PROC FREQ DATA=LIBW.MIM2008_NIC;
    TITLE "Aantal individuen geselecteerd uit NIC bestand";
    TABLES InNIC;
RUN;
PROC SORT DATA=LIBW.MIM2008_NIC;
    BY NIC_STELSEL_2008;
RUN;
PROC FREQ DATA=LIBW.MIM2008_NIC;
    TABLES  NIC_SRTDAGEN_2008;
    BY NIC_STELSEL_2008;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;

