/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens Pensioenkadaster
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreatePensCad_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreatePensCad.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA PENSCAD;
    SET LIB.mim2008_rvp_nationaallegaal_code;
RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM PENSCAD
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
/*zo ja reduceer dan tot 1 lijn*/
/*aanmaak finaal bestand*/
DATA MIM2008_PENSCAD;
    MERGE TOTPOP(in=InA) PENSCAD(in=InB);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;
    
    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InPensCad = 0;
    IF InB EQ 1 THEN InPensCad = 1;
    LABEL InPensCad = "Individu geselecteerd uit basisdata Pensioenkadaster voor verwerking steekproef";

    IF aantal_kind_2008     EQ . THEN aantal_kind_2008      = 0;
    IF aantal_andere_2008   EQ . THEN aantal_andere_2008    = 0;
    IF RPWE_2008            EQ . THEN RPWE_2008             = 0;
    IF FIRPCAP_2008         EQ . THEN FIRPCAP_2008          = 0;
    IF FISPCAP_2008         EQ . THEN FISPCAP_2008          = 0;
    IF RPSE_2008            EQ . THEN RPSE_2008             = 0;
    IF RPCIV_2008           EQ . THEN RPCIV_2008            = 0;
    IF RPFOR_2008           EQ . THEN RPFOR_2008            = 0;
    IF RPDOSZ_2008          EQ . THEN RPDOSZ_2008           = 0;
    IF SPWE_2008            EQ . THEN SPWE_2008             = 0;
    IF SPSE_2008            EQ . THEN SPSE_2008             = 0;
    IF SPCIV_2008           EQ . THEN SPCIV_2008            = 0;
    IF SPFOR_2008           EQ . THEN SPFOR_2008            = 0;
    IF SPDOSZ_2008          EQ . THEN SPDOSZ_2008           = 0;
    IF CAPFIRST_2008        EQ . THEN CAPFIRST_2008         = 0;
    IF IGO_2008             EQ . THEN IGO_2008              = 0;
    IF DISAB_2008           EQ . THEN DISAB_2008            = 0;
    IF RPRENT_SPILPRIV_2008 EQ . THEN RPRENT_SPILPRIV_2008  = 0;
    IF RPRENT_SPILPUB_2008  EQ . THEN RPRENT_SPILPUB_2008   = 0;
    IF SPRENT_SPILPRIV_2008 EQ . THEN SPRENT_SPILPRIV_2008  = 0;
    IF SPRENT_SPILPUB_2008  EQ . THEN SPRENT_SPILPUB_2008   = 0;
    IF RPCAP_SPILPRIV_2008  EQ . THEN RPCAP_SPILPRIV_2008   = 0;
    IF RPCAP_SPILPUB_2008   EQ . THEN RPCAP_SPILPUB_2008    = 0;
    IF SPCAP_SPILPRIV_2008  EQ . THEN SPCAP_SPILPRIV_2008   = 0;
    IF SPCAP_SPILPUB_2008   EQ . THEN SPCAP_SPILPUB_2008    = 0;
    IF DIRPENS_2008         EQ . THEN DIRPENS_2008          = 0;
    IF OTHPENS_2008         EQ . THEN OTHPENS_2008          = 0;

    /*Corrigeer datums*/
    LENGTH begindatum_pensioen_c_2008_cor $7.; 
    LENGTH RPWE_PDATE_2008_cor $7.;           
    LENGTH FIRPCAP_PDATE_2008_cor $7.;        
    LENGTH FISPCAP_PDATE_2008_cor $7.;        
    LENGTH RPSE_PDATE_2008_cor $7.;           
    LENGTH RPCIV_PDATE_2008_cor $7.;          
    LENGTH RPFOR_PDATE_2008_cor $7.;          
    LENGTH RPDOSZ_PDATE_2008_cor $7.;         
    LENGTH SPWE_PDATE_2008_cor $7.;           
    LENGTH SPSE_PDATE_2008_cor $7.;           
    LENGTH SPCIV_PDATE_2008_cor $7.;          
    LENGTH SPFOR_PDATE_2008_cor $7.;          
    LENGTH SPDOSZ_PDATE_2008_cor $7.;         
    LENGTH CAPFIRST_PDATE_2008_cor $7.;       
    LENGTH IGO_PDATE_2008_cor $7.;            
    LENGTH DISAB_PDATE_2008_cor $7.;          
    LENGTH RPRENT_SPILPRIV_PDATE_2008_cor $7.;
    LENGTH RPRENT_SPILPUB_PDATE_2008_cor $7.; 
    LENGTH SPRENT_SPILPRIV_PDATE_2008_cor $7.;
    LENGTH SPRENT_SPILPUB_PDATE_2008_cor $7.; 
    LENGTH RPCAP_SPILPRIV_PDATE_2008_cor $7.; 
    LENGTH RPCAP_SPILPUB_PDATE_2008_cor $7.;  
    LENGTH SPCAP_SPILPRIV_PDATE_2008_cor $7.; 
    LENGTH SPCAP_SPILPUB_PDATE_2008_cor $7.;  
    LENGTH DIRPENS_PDATE_2008_cor $7.;        
    LENGTH OTHPENS_PDATE_2008_cor $7.;        

    begindatum_pensioen_c_2008_cor =    SUBSTR(begindatum_pensioen_c_2008,5,2)  || "-" || SUBSTR(begindatum_pensioen_c_2008,1,4);
    RPWE_PDATE_2008_cor =               SUBSTR(RPWE_PDATE_2008,5,2)             || "-" || SUBSTR(RPWE_PDATE_2008,1,4);
    FIRPCAP_PDATE_2008_cor =            SUBSTR(FIRPCAP_PDATE_2008,5,2)          || "-" || SUBSTR(FIRPCAP_PDATE_2008,1,4);
    FISPCAP_PDATE_2008_cor =            SUBSTR(FISPCAP_PDATE_2008,5,2)          || "-" || SUBSTR(FISPCAP_PDATE_2008,1,4);
    RPSE_PDATE_2008_cor =               SUBSTR(RPSE_PDATE_2008,5,2)             || "-" || SUBSTR(RPSE_PDATE_2008,1,4);
    RPCIV_PDATE_2008_cor =              SUBSTR(RPCIV_PDATE_2008,5,2)            || "-" || SUBSTR(RPCIV_PDATE_2008,1,4);
    RPFOR_PDATE_2008_cor =              SUBSTR(RPFOR_PDATE_2008,5,2)            || "-" || SUBSTR(RPFOR_PDATE_2008,1,4);
    RPDOSZ_PDATE_2008_cor =             SUBSTR(RPDOSZ_PDATE_2008,5,2)           || "-" || SUBSTR(RPDOSZ_PDATE_2008,1,4);
    SPWE_PDATE_2008_cor =               SUBSTR(SPWE_PDATE_2008,5,2)             || "-" || SUBSTR(SPWE_PDATE_2008,1,4);
    SPSE_PDATE_2008_cor =               SUBSTR(SPSE_PDATE_2008,5,2)             || "-" || SUBSTR(SPSE_PDATE_2008,1,4);
    SPCIV_PDATE_2008_cor =              SUBSTR(SPCIV_PDATE_2008,5,2)            || "-" || SUBSTR(SPCIV_PDATE_2008,1,4);
    SPFOR_PDATE_2008_cor =              SUBSTR(SPFOR_PDATE_2008,5,2)            || "-" || SUBSTR(SPFOR_PDATE_2008,1,4);
    SPDOSZ_PDATE_2008_cor =             SUBSTR(SPDOSZ_PDATE_2008,5,2)           || "-" || SUBSTR(SPDOSZ_PDATE_2008,1,4);
    CAPFIRST_PDATE_2008_cor =           SUBSTR(CAPFIRST_PDATE_2008,5,2)         || "-" || SUBSTR(CAPFIRST_PDATE_2008,1,4);
    IGO_PDATE_2008_cor =                SUBSTR(IGO_PDATE_2008,5,2)              || "-" || SUBSTR(IGO_PDATE_2008,1,4);
    DISAB_PDATE_2008_cor =              SUBSTR(DISAB_PDATE_2008,5,2)            || "-" || SUBSTR(DISAB_PDATE_2008,1,4);
    RPRENT_SPILPRIV_PDATE_2008_cor =    SUBSTR(RPRENT_SPILPRIV_PDATE_2008,5,2)  || "-" || SUBSTR(RPRENT_SPILPRIV_PDATE_2008,1,4);
    RPRENT_SPILPUB_PDATE_2008_cor =     SUBSTR(RPRENT_SPILPUB_PDATE_2008,5,2)   || "-" || SUBSTR(RPRENT_SPILPUB_PDATE_2008,1,4);
    SPRENT_SPILPRIV_PDATE_2008_cor =    SUBSTR(SPRENT_SPILPRIV_PDATE_2008,5,2)  || "-" || SUBSTR(SPRENT_SPILPRIV_PDATE_2008,1,4);
    SPRENT_SPILPUB_PDATE_2008_cor =     SUBSTR(SPRENT_SPILPUB_PDATE_2008,5,2)   || "-" || SUBSTR(SPRENT_SPILPUB_PDATE_2008,1,4);
    RPCAP_SPILPRIV_PDATE_2008_cor =     SUBSTR(RPCAP_SPILPRIV_PDATE_2008,5,2)   || "-" || SUBSTR(RPCAP_SPILPRIV_PDATE_2008,1,4);
    RPCAP_SPILPUB_PDATE_2008_cor =      SUBSTR(RPCAP_SPILPUB_PDATE_2008,5,2)    || "-" || SUBSTR(RPCAP_SPILPUB_PDATE_2008,1,4);
    SPCAP_SPILPRIV_PDATE_2008_cor =     SUBSTR(SPCAP_SPILPRIV_PDATE_2008,5,2)   || "-" || SUBSTR(SPCAP_SPILPRIV_PDATE_2008,1,4);
    SPCAP_SPILPUB_PDATE_2008_cor =      SUBSTR(SPCAP_SPILPUB_PDATE_2008,5,2)    || "-" || SUBSTR(SPCAP_SPILPUB_PDATE_2008,1,4);
    DIRPENS_PDATE_2008_cor =            SUBSTR(DIRPENS_PDATE_2008,5,2)          || "-" || SUBSTR(DIRPENS_PDATE_2008,1,4);
    OTHPENS_PDATE_2008_cor =            SUBSTR(OTHPENS_PDATE_2008,5,2)          || "-" || SUBSTR(OTHPENS_PDATE_2008,1,4);

    DROP
    begindatum_pensioen_c_2008
    RPWE_PDATE_2008
    FIRPCAP_PDATE_2008
    FISPCAP_PDATE_2008
    RPSE_PDATE_2008
    RPCIV_PDATE_2008
    RPFOR_PDATE_2008
    RPDOSZ_PDATE_2008
    SPWE_PDATE_2008
    SPSE_PDATE_2008
    SPCIV_PDATE_2008
    SPFOR_PDATE_2008
    SPDOSZ_PDATE_2008
    CAPFIRST_PDATE_2008
    IGO_PDATE_2008
    DISAB_PDATE_2008
    RPRENT_SPILPRIV_PDATE_2008
    RPRENT_SPILPUB_PDATE_2008
    SPRENT_SPILPRIV_PDATE_2008
    SPRENT_SPILPUB_PDATE_2008
    RPCAP_SPILPRIV_PDATE_2008
    RPCAP_SPILPUB_PDATE_2008
    SPCAP_SPILPRIV_PDATE_2008
    SPCAP_SPILPUB_PDATE_2008
    DIRPENS_PDATE_2008
    OTHPENS_PDATE_2008
    ;

RUN;
DATA LIBW.MIM2008_PENSCAD;
    SET MIM2008_PENSCAD;
    
    begindatum_pensioen_c_2008 =      begindatum_pensioen_c_2008_cor;  
    RPWE_PDATE_2008 =                 RPWE_PDATE_2008_cor;             
    FIRPCAP_PDATE_2008 =              FIRPCAP_PDATE_2008_cor;          
    FISPCAP_PDATE_2008 =              FISPCAP_PDATE_2008_cor;          
    RPSE_PDATE_2008 =                 RPSE_PDATE_2008_cor;             
    RPCIV_PDATE_2008 =                RPCIV_PDATE_2008_cor;            
    RPFOR_PDATE_2008 =                RPFOR_PDATE_2008_cor;            
    RPDOSZ_PDATE_2008 =               RPDOSZ_PDATE_2008_cor;           
    SPWE_PDATE_2008 =                 SPWE_PDATE_2008_cor;             
    SPSE_PDATE_2008 =                 SPSE_PDATE_2008_cor;             
    SPCIV_PDATE_2008 =                SPCIV_PDATE_2008_cor;            
    SPFOR_PDATE_2008 =                SPFOR_PDATE_2008_cor;            
    SPDOSZ_PDATE_2008 =               SPDOSZ_PDATE_2008_cor;           
    CAPFIRST_PDATE_2008 =             CAPFIRST_PDATE_2008_cor;         
    IGO_PDATE_2008 =                  IGO_PDATE_2008_cor;              
    DISAB_PDATE_2008 =                DISAB_PDATE_2008_cor;            
    RPRENT_SPILPRIV_PDATE_2008 =      RPRENT_SPILPRIV_PDATE_2008_cor;  
    RPRENT_SPILPUB_PDATE_2008 =       RPRENT_SPILPUB_PDATE_2008_cor;   
    SPRENT_SPILPRIV_PDATE_2008 =      SPRENT_SPILPRIV_PDATE_2008_cor;  
    SPRENT_SPILPUB_PDATE_2008 =       SPRENT_SPILPUB_PDATE_2008_cor;   
    RPCAP_SPILPRIV_PDATE_2008 =       RPCAP_SPILPRIV_PDATE_2008_cor;   
    RPCAP_SPILPUB_PDATE_2008 =        RPCAP_SPILPUB_PDATE_2008_cor;    
    SPCAP_SPILPRIV_PDATE_2008 =       SPCAP_SPILPRIV_PDATE_2008_cor;   
    SPCAP_SPILPUB_PDATE_2008 =        SPCAP_SPILPUB_PDATE_2008_cor;    
    DIRPENS_PDATE_2008 =              DIRPENS_PDATE_2008_cor;          
    OTHPENS_PDATE_2008 =              OTHPENS_PDATE_2008_cor;          

    /*Label date variables*/
    LABEL begindatum_pensioen_c_2008       =  "begindatum_pensioen_c (geregistreerd in 2008)";
    LABEL RPWE_PDATE_2008                  =  "startdatum betaling rustpensioen werknemer (betalingsjaar = 2008)";
    LABEL FIRPCAP_PDATE_2008               =  "startdatum betaling voordelen vrije verzekerden (rust) (kapitaal) (betalingsjaar = 2008)";
    LABEL FISPCAP_PDATE_2008               =  "startdatum betaling voordelen vrije verzekerden (overleving) (kapitaal) (betalingsjaar = 2008)";
    LABEL RPSE_PDATE_2008                  =  "startdatum betaling rustpensioen zelfstandige (betalingsjaar = 2008)";
    LABEL RPCIV_PDATE_2008                 =  "startdatum betaling rustpensioen overheid (betalingsjaar = 2008)";
    LABEL RPFOR_PDATE_2008                 =  "startdatum betaling buitenlands rustpensioen (betalingsjaar = 2008)";
    LABEL RPDOSZ_PDATE_2008                =  "startdatum betaling rustpensioen DOSZ (betalingsjaar = 2008)";
    LABEL SPWE_PDATE_2008                  =  "startdatum betaling overlevingspensioen werknemer (betalingsjaar = 2008)";
    LABEL SPSE_PDATE_2008                  =  "startdatum betaling overlevingspensioen zelfstandige (betalingsjaar = 2008)";
    LABEL SPCIV_PDATE_2008                 =  "startdatum betaling overlevingspensioen overheid (betalingsjaar = 2008)";
    LABEL SPFOR_PDATE_2008                 =  "startdatum betaling buitenlands overlevingspensioen (betalingsjaar = 2008)";
    LABEL SPDOSZ_PDATE_2008                =  "startdatum betaling overlevingspensioen DOSZ (betalingsjaar = 2008)";
    LABEL CAPFIRST_PDATE_2008              =  "startdatum betaling kapitalen eerste pijler (betalingsjaar = 2008)";
    LABEL IGO_PDATE_2008                   =  "startdatum betaling GIB/IGO (betalingsjaar = 2008)";
    LABEL DISAB_PDATE_2008                 =  "startdatum betaling tegemoetkoming mindervaliden (betalingsjaar = 2008)";
    LABEL RPRENT_SPILPRIV_PDATE_2008       =  "startdatum betaling tweedepijler(rust)pensioen, rente-uitkering door private instelling (betalingsjaar = 2008)";
    LABEL RPRENT_SPILPUB_PDATE_2008        =  "startdatum betaling tweedepijler(rust)pensioen, rente-uitkering door publieke instelling (betalingsjaar = 2008)";
    LABEL SPRENT_SPILPRIV_PDATE_2008       =  "startdatum betaling tweedepijler(overlevings)pensioen, rente-uitkering door private instelling (betalingsjaar = 2008)";
    LABEL SPRENT_SPILPUB_PDATE_2008        =  "startdatum betaling tweedepijler(overlevings)pensioen, rente-uitkering door publieke instelling (betalingsjaar = 2008)";
    LABEL RPCAP_SPILPRIV_PDATE_2008        =  "startdatum betaling tweedepijler(rust)pensioen, kapitaaluitkering door private instelling (betalingsjaar = 2008)";
    LABEL RPCAP_SPILPUB_PDATE_2008         =  "startdatum betaling tweedepijler(rust)pensioen, kapitaaluitkering door publieke instelling (betalingsjaar = 2008)";
    LABEL SPCAP_SPILPRIV_PDATE_2008        =  "startdatum betaling tweedepijler(overlevings)pensioen, kapitaaluitkering door private instelling (betalingsjaar = 2008)";
    LABEL SPCAP_SPILPUB_PDATE_2008         =  "startdatum betaling tweedepijler(overlevings)pensioen, kapitaaluitkering door publieke instelling (betalingsjaar = 2008)";
    LABEL DIRPENS_PDATE_2008               =  "startdatum betaling afgeleide pensioenen (betalingsjaar = 2008)";
    LABEL OTHPENS_PDATE_2008               =  "startdatum betaling overige pensioenbedragen (betalingsjaar = 2008)";

    DROP
    begindatum_pensioen_c_2008_cor
    RPWE_PDATE_2008_cor
    FIRPCAP_PDATE_2008_cor
    FISPCAP_PDATE_2008_cor
    RPSE_PDATE_2008_cor
    RPCIV_PDATE_2008_cor
    RPFOR_PDATE_2008_cor
    RPDOSZ_PDATE_2008_cor
    SPWE_PDATE_2008_cor
    SPSE_PDATE_2008_cor
    SPCIV_PDATE_2008_cor
    SPFOR_PDATE_2008_cor
    SPDOSZ_PDATE_2008_cor
    CAPFIRST_PDATE_2008_cor
    IGO_PDATE_2008_cor
    DISAB_PDATE_2008_cor
    RPRENT_SPILPRIV_PDATE_2008_cor
    RPRENT_SPILPUB_PDATE_2008_cor
    SPRENT_SPILPRIV_PDATE_2008_cor
    SPRENT_SPILPUB_PDATE_2008_cor
    RPCAP_SPILPRIV_PDATE_2008_cor
    RPCAP_SPILPUB_PDATE_2008_cor
    SPCAP_SPILPRIV_PDATE_2008_cor
    SPCAP_SPILPUB_PDATE_2008_cor
    DIRPENS_PDATE_2008_cor
    OTHPENS_PDATE_2008_cor
    ;
    
RUN;    
PROC FREQ DATA=LIBW.MIM2008_PENSCAD;
    TABLES
    InPensCad
    begindatum_pensioen_c_2008
    RPWE_PDATE_2008           
    FIRPCAP_PDATE_2008        
    FISPCAP_PDATE_2008        
    RPSE_PDATE_2008           
    RPCIV_PDATE_2008          
    RPFOR_PDATE_2008          
    RPDOSZ_PDATE_2008         
    SPWE_PDATE_2008           
    SPSE_PDATE_2008           
    SPCIV_PDATE_2008          
    SPFOR_PDATE_2008          
    SPDOSZ_PDATE_2008         
    CAPFIRST_PDATE_2008       
    IGO_PDATE_2008            
    DISAB_PDATE_2008          
    RPRENT_SPILPRIV_PDATE_2008
    RPRENT_SPILPUB_PDATE_2008 
    SPRENT_SPILPRIV_PDATE_2008
    SPRENT_SPILPUB_PDATE_2008 
    RPCAP_SPILPRIV_PDATE_2008 
    RPCAP_SPILPUB_PDATE_2008  
    SPCAP_SPILPRIV_PDATE_2008 
    SPCAP_SPILPUB_PDATE_2008  
    DIRPENS_PDATE_2008        
    OTHPENS_PDATE_2008        
    ;
RUN;
PROC CONTENTS DATA=LIBW.MIM2008_PENSCAD;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;


