/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens PODMI
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreatePODMI_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreatePODMI.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*include format file*/
%include 'C:\My\teksten\MIMS2009\DataFS\ProgManip\FileFormats.sas' ;

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ NAREGNIS_COMMUNIT MIMOSIS_WEIGHT);

    /*Maak provincie*/
    IF NAREGNIS_COMMUNIT GE 11000 AND NAREGNIS_COMMUNIT LE 13053 THEN PROV = 1;
    IF NAREGNIS_COMMUNIT GE 21001 AND NAREGNIS_COMMUNIT LE 21019 THEN PROV = 2;
    IF NAREGNIS_COMMUNIT GE 23002 AND NAREGNIS_COMMUNIT LE 24137 THEN PROV = 3;
    IF NAREGNIS_COMMUNIT GE 25005 AND NAREGNIS_COMMUNIT LE 25124 THEN PROV = 4;
    IF NAREGNIS_COMMUNIT GE 31003 AND NAREGNIS_COMMUNIT LE 38025 THEN PROV = 5;
    IF NAREGNIS_COMMUNIT GE 41002 AND NAREGNIS_COMMUNIT LE 46025 THEN PROV = 6;
    IF NAREGNIS_COMMUNIT GE 51004 AND NAREGNIS_COMMUNIT LE 57095 THEN PROV = 7;
    IF NAREGNIS_COMMUNIT GE 61003 AND NAREGNIS_COMMUNIT LE 64076 THEN PROV = 8;
    IF NAREGNIS_COMMUNIT GE 71002 AND NAREGNIS_COMMUNIT LE 73109 THEN PROV = 9;
    IF NAREGNIS_COMMUNIT GE 81001 AND NAREGNIS_COMMUNIT LE 85047 THEN PROV = 10;
    IF NAREGNIS_COMMUNIT GE 91005 AND NAREGNIS_COMMUNIT LE 93090 THEN PROV = 11;

RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA PODMI_BASIS;
    SET LIB.mim2008_podmi_code;
    
    /*Select line*/
    Select_Line = 0;
    /*Persoon moet kandidaat vluchteling zijn, vreemdeling of onbekend*/
    /*een aantal waarden waarvan we geen verklaring kennen worden op deze manier niet meegenomen*/
    IF PODMI_STSID_2008 EQ -1 OR PODMI_STSID_2008 EQ 1256 OR PODMI_STSID_2008 EQ 1263 THEN DO;
        /*Wetgeving moet wijzen of leefloon of maatschappelijke steun*/
        IF PODMI_LEGIS_2008 EQ 1 OR (PODMI_LEGIS_2008 EQ 2 AND PODMI_THP_2008 EQ 48) THEN DO;
            /*Budget-artikel moet wijzen of leefloon of equivalent leefloon*/
            IF PODMI_BUDART_2008 IN (1166, 1167, 1168, 1170, 1171, 1176, 7710, 7713, 7714, 7715, 7716, 7717, 7718, 7719, 7720, 7721, 7722, 7723, 7724, 7725, 7726, 7727, 7728) THEN DO;
                Select_Line = 1;
            END;
        END;
    END;

    LENGTH Date_Start $6.; 
    LENGTH Date_End $6.; 
    /*converteer begin en einddatum*/
    Date_Start = SUBSTR(TRIM(PODMI_BEGDATUM_2008),4,4) || SUBSTR(TRIM(PODMI_BEGDATUM_2008),1,2);
    Date_End   = SUBSTR(TRIM(PODMI_ENDDATUM_2008),4,4) || SUBSTR(TRIM(PODMI_ENDDATUM_2008),1,2);

RUN;
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM PODMI_BASIS
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
PROC FREQ DATA=PODMI_BASIS;
    TITLE "Aantal lijnen die zullen geselecteerd worden uit het basisbestand";
    TABLES Select_Line;
RUN;    
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand en test een aantal meer voorkomende waarden*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv, COUNT(DISTINCT PODMI_BUDART_2008) AS NUM_Budart, COUNT(DISTINCT PODMI_CATID_2008) AS NUM_CAT
    FROM PODMI_BASIS
    WHERE Select_Line = 1
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand met een selectielijn";
    TABLES NUM_Indiv;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat n individu voorkomt met verschillende budget-artikels met een selectielijn";
    TABLES NUM_Budart;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende gezinscategorin met een selectielijn";
    TABLES NUM_CAT;
RUN;
PROC FREQ DATA=PODMI_BASIS(WHERE=(Select_Line = 0));
    TITLE "Frequentie gevallen die niet geselecteerd worden voor verdere analyse";
    TABLES PODMI_BUDART_2008 PODMI_THP_2008 PODMI_LEGIS_2008;
RUN;
/*Reduceer gevallen tot n lijn*/
PROC SORT DATA=PODMI_BASIS;
    BY GECODEERD_INSZ PODMI_BEDRAG_2008;
RUN; 
DATA PODMI;
    SET PODMI_BASIS(WHERE=(Select_Line = 1));
    BY GECODEERD_INSZ PODMI_BEDRAG_2008;

    RETAIN PODMI_BEDRAG_agg 0;
    RETAIN PODMI_BEGDATUM_agg PODMI_ENDDATUM_agg '      ';
    
    IF FIRST.GECODEERD_INSZ THEN DO;
        /*Initialiseer variabelen die geaggregeerd worden*/
        PODMI_BEDRAG_agg      = 0;
        /*Zet waarde indien basisgegeven niet missing is*/
        IF PODMI_BEDRAG_agg   NE . THEN PODMI_BEDRAG_agg = PODMI_BEDRAG_2008;   
        /*Datumwaarden*/
        PODMI_BEGDATUM_agg  = Date_Start;
        PODMI_ENDDATUM_agg  = Date_End;
    END;
    ELSE DO;
        /*Tel andere waarden er bij op*/
        IF PODMI_BEDRAG_agg   NE . THEN PODMI_BEDRAG_agg   = PODMI_BEDRAG_agg   + PODMI_BEDRAG_2008;   
        /*Datumwaarden*/
        IF Date_Start LT PODMI_BEGDATUM_agg THEN DO;
            PODMI_BEGDATUM_agg = Date_Start;
        END;
        IF Date_End GT PODMI_ENDDATUM_agg THEN DO;
            PODMI_ENDDATUM_agg = Date_End;
        END;
    END;
 
    KEEP
    GECODEERD_INSZ
    PODMI_BEGDATUM_agg
    PODMI_ENDDATUM_agg
    PODMI_BEDRAG_agg  
    PODMI_CATID_2008   
    PODMI_CATCNTID_2008
    PODMI_STSID_2008   
    PODMI_BUDART_2008  
    PODMI_LEGIS_2008       
    PODMI_THP_2008      
    ;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
    
RUN;
DATA PODMI;
    SET PODMI;

    LENGTH PODMI_BEGDATUM_2008    $7.;
    LENGTH PODMI_ENDDATUM_2008    $7.;

    PODMI_BEDRAG_2008         = PODMI_BEDRAG_agg;
    PODMI_BEGDATUM_2008       = SUBSTR(TRIM(PODMI_BEGDATUM_agg),5,2) || "-" || SUBSTR(TRIM(PODMI_BEGDATUM_agg),1,4); 
    PODMI_ENDDATUM_2008       = SUBSTR(TRIM(PODMI_ENDDATUM_agg),5,2) || "-" || SUBSTR(TRIM(PODMI_ENDDATUM_agg),1,4);

    LABEL PODMI_BEGDATUM_2008 = "Begindatum betaling recht POD MI (2008)";                                                                                                                                                                 
    LABEL PODMI_ENDDATUM_2008 = "Einddatum betaling recht POD MI (2008)";                                                                                                                                                                  
    LABEL PODMI_BEDRAG_2008   = "Bedrag betaling recht POD MI (2008)";                                                                                                                                                                     

    /*bepaal aantal maanden leefloon*/    
    Monthstart      = INPUT(SUBSTR(TRIM(PODMI_BEGDATUM_2008),1,2),8.);
    Monthend        = INPUT(SUBSTR(TRIM(PODMI_ENDDATUM_2008),1,2),8.);
    NumMonth_Hulp_2008   = (Monthend - Monthstart + 1);
    LABEL NumMonth_Hulp_2008 = "Aantal maanden gedurende dewelke individu financile steun OCMW ontvangt in 2008";

    KEEP
    GECODEERD_INSZ
    PODMI_BEGDATUM_2008
    PODMI_ENDDATUM_2008
    PODMI_BEDRAG_2008  
    PODMI_CATID_2008   
    PODMI_CATCNTID_2008
    PODMI_STSID_2008   
    PODMI_BUDART_2008  
    PODMI_LEGIS_2008       
    PODMI_THP_2008  
    NumMonth_Hulp_2008
    ; 

RUN;
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand en test een aantal meer voorkomende waarden*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv, COUNT(DISTINCT PODMI_BUDART_2008) AS NUM_Budart, COUNT(DISTINCT PODMI_CATID_2008) AS NUM_CAT
    FROM PODMI
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na correctie";
    TABLES NUM_Indiv;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat n individu voorkomt met verschillende budget-artikels: na correctie";
    TABLES NUM_Budart;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende gezinscategorin: na correctie";
    TABLES NUM_CAT;
RUN;
/*Maak bestand met nummers van niet geselecteerde individuen*/
DATA PODMI_NOSEL;
    SET PODMI_BASIS(WHERE=(Select_Line = 0));
    BY GECODEERD_INSZ PODMI_BEDRAG_2008;

    RETAIN PODMI_BEDRAG_agg 0;
    RETAIN PODMI_BEGDATUM_agg PODMI_ENDDATUM_agg '      ';
    
    IF FIRST.GECODEERD_INSZ THEN DO;
        /*Initialiseer variabelen die geaggregeerd worden*/
        PODMI_BEDRAG_agg      = 0;
        /*Zet waarde indien basisgegeven niet missing is*/
        IF PODMI_BEDRAG_agg   NE . THEN PODMI_BEDRAG_agg = PODMI_BEDRAG_2008;   
        /*Datumwaarden*/
        PODMI_BEGDATUM_agg  = Date_Start;
        PODMI_ENDDATUM_agg  = Date_End;
    END;
    ELSE DO;
        /*Tel andere waarden er bij op*/
        IF PODMI_BEDRAG_agg   NE . THEN PODMI_BEDRAG_agg   = PODMI_BEDRAG_agg   + PODMI_BEDRAG_2008;   
        /*Datumwaarden*/
        IF Date_Start LT PODMI_BEGDATUM_agg THEN DO;
            PODMI_BEGDATUM_agg = Date_Start;
        END;
        IF Date_End GT PODMI_ENDDATUM_agg THEN DO;
            PODMI_ENDDATUM_agg = Date_End;
        END;
    END;
 
    KEEP
    GECODEERD_INSZ
    PODMI_BEGDATUM_agg
    PODMI_ENDDATUM_agg
    PODMI_BEDRAG_agg  
    PODMI_CATID_2008   
    PODMI_CATCNTID_2008
    PODMI_STSID_2008   
    PODMI_BUDART_2008  
    PODMI_LEGIS_2008       
    PODMI_THP_2008      
    ;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
    
RUN;
DATA PODMI_NOSEL;

    SET PODMI_NOSEL;

    LENGTH PODMI_BEGDATUM_2008_NOSEL    $7.;
    LENGTH PODMI_ENDDATUM_2008_NOSEL    $7.;

    PODMI_BEDRAG_2008_NOSEL         = PODMI_BEDRAG_agg;
    PODMI_BEGDATUM_2008_NOSEL       = SUBSTR(TRIM(PODMI_BEGDATUM_agg),5,2) || "-" || SUBSTR(TRIM(PODMI_BEGDATUM_agg),1,4); 
    PODMI_ENDDATUM_2008_NOSEL       = SUBSTR(TRIM(PODMI_ENDDATUM_agg),5,2) || "-" || SUBSTR(TRIM(PODMI_ENDDATUM_agg),1,4);

    LABEL PODMI_BEGDATUM_2008_NOSEL = "Begindatum betaling recht POD MI (2008): op basis van niet geselecteerde lijnen";                                                                                                                                                                 
    LABEL PODMI_ENDDATUM_2008_NOSEL = "Einddatum betaling recht POD MI (2008): op basis van niet geselecteerde lijnen";                                                                                                                                                                  
    LABEL PODMI_BEDRAG_2008_NOSEL   = "Bedrag betaling recht POD MI (2008): op basis van niet geselecteerde lijnen";                                                                                                                                                                     

    KEEP
    GECODEERD_INSZ
    PODMI_BEGDATUM_2008_NOSEL
    PODMI_ENDDATUM_2008_NOSEL
    ; 

RUN;
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand en test een aantal meer voorkomende waarden*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM PODMI_NOSEL
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na correctie van niet geselecteerde lijne";
    TABLES NUM_Indiv;
RUN;
/*aanmaak finaal bestand*/
DATA MIM2008_PODMI;
    MERGE TOTPOP(in=InA) PODMI(in=InB) PODMI_NOSEL(in=InC);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InPODMI_SEL = 0;
    IF InB EQ 1 THEN InPODMI_SEL = 1;
    LABEL InPODMI_SEL = "Individu geselecteerd uit basisdata PODMI voor verwerking steekproef";

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: individuen waarvan minstens n lijn niet geselecteerd werd*/
    InPODMI_NOSEL = 0;
    IF InC EQ 1 THEN InPODMI_NOSEL = 1;
    LABEL InPODMI_NOSEL = "Individu in basisdata PODMI maar niet geselecteerd voor verwerking steekproef";
    
    IF PODMI_BEDRAG_2008    EQ . THEN PODMI_BEDRAG_2008     = 0;
    IF PODMI_CATID_2008     EQ . THEN PODMI_CATID_2008      = 0;
    IF PODMI_CATCNTID_2008  EQ . THEN PODMI_CATCNTID_2008   = 0;
    IF PODMI_STSID_2008     EQ . THEN PODMI_STSID_2008      = 0;
    IF PODMI_BUDART_2008    EQ . THEN PODMI_BUDART_2008     = 0;
    IF PODMI_THP_2008       EQ . THEN PODMI_THP_2008        = 0;
    IF NumMonth_Hulp_2008   EQ . THEN NumMonth_Hulp_2008    = 0;

RUN;
PROC FREQ DATA=MIM2008_PODMI;
    TITLE "Aantal individuen geselecteerd uit PODMI bestand";
    TABLES InPODMI_SEL InPODMI_NOSEL PODMI_BEGDATUM_2008 PODMI_ENDDATUM_2008;
RUN;
PROC FREQ DATA=MIM2008_PODMI(WHERE=(InPODMI_SEL=1));
    TITLE "Aantal maanden financile hulp voor geselecteerde individuen";
    TABLES NumMonth_Hulp_2008;
RUN;
PROC MEANS DATA=MIM2008_PODMI(WHERE=(InPODMI_SEL=1));
    TITLE "Gemiddeld bedrag individuen geselecteerd uit PODMI bestand";
    VAR PODMI_BEDRAG_2008;
RUN;
PROC MEANS DATA=MIM2008_PODMI(WHERE=(InPODMI_NOSEL=1));
    TITLE "Gemiddeld bedrag individuen NIET geselecteerd uit PODMI bestand";
    VAR PODMI_BEDRAG_2008;
RUN;
PROC FREQ DATA=MIM2008_PODMI(WHERE=(InPODMI_SEL=1));
    TITLE "Verdeling steuntrekkers OCMW naar provincie";
    TABLES PROV;
    FORMAT PROV FMPROV.;
    WEIGHT MIMOSIS_WEIGHT;
RUN;    
DATA LIBW.MIM2008_PODMI;
    SET MIM2008_PODMI(DROP = NAREGNIS_COMMUNIT MIMOSIS_WEIGHT PROV);
RUN;    
PROC CONTENTS DATA=LIBW.MIM2008_PODMI;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;

