/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens RIZIV
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRIZIV_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRIZIV.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA RIZIV;
    SET LIB.mim2008_riziv_code;
RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RIZIV
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
/*zo ja reduceer dan tot 1 lijn*/
DATA LIBW.MIM2008_RIZIV;
    MERGE TOTPOP(in=InA) RIZIV(in=InB);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InRIZIV = 0;
    IF InB EQ 1 THEN InRIZIV = 1;
    LABEL InRIZIV = "Individu geselecteerd uit basisdata RIZIV voor verwerking steekproef";
    
    IF RIZIVINA_VERGOEDE_INVAL_2008  EQ . THEN RIZIVINA_VERGOEDE_INVAL_2008  = 0;
    IF RIZIVINA_BEDRAG_INVAL_2008    EQ . THEN RIZIVINA_BEDRAG_INVAL_2008    = 0;
    IF RIZIVINA_VERGOEDE_MAT_2008    EQ . THEN RIZIVINA_VERGOEDE_MAT_2008    = 0;
    IF RIZIVINA_BEDRAG_MAT_2008      EQ . THEN RIZIVINA_BEDRAG_MAT_2008      = 0;

RUN;
PROC FREQ DATA=LIBW.MIM2008_RIZIV;
    TABLES
    InRIZIV
    RIZIVINA_AANVANGS_INVAL_2008
    RIZIVINA_EINDBETA_INVAL_2008
    RIZIVINA_AANVANGS_MAT_2008  
    RIZIVINA_EINDBETA_MAT_2008  
    B_ZIEKTE_2008               
    ;
RUN;
PROC CONTENTS DATA=LIBW.MIM2008_RIZIV;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;

