/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens RKW
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRKW_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRKW.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA RKW;
    SET LIB.mim2008_rkw_code(RENAME=(GECODEERD_INSZ_RG=GECODEERD_INSZ));
RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RKW
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
/*reduceer het aantal lijnen tot n per rechtgevend kind*/
PROC SORT DATA=RKW;
    BY GECODEERD_INSZ GECODEERD_INSZ_RH GECODEERD_INSZ_BT;
RUN;
DATA RKW;
    SET RKW;
    BY GECODEERD_INSZ GECODEERD_INSZ_RH GECODEERD_INSZ_BT;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
    
RUN;
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RKW
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na reductie";
    TABLES NUM_Indiv;
RUN;
/*Voeg gegevens samen op niveau populatie*/
DATA LIBW.MIM2008_RKW;
    MERGE TOTPOP(in=InA) RKW(in=InB);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InRKW = 0;
    IF InB EQ 1 THEN InRKW = 1;
    LABEL InRKW = "Individu geselecteerd uit basisdata RKW voor verwerking steekproef";

    IF RKW_GWB_2008 EQ . THEN RKW_GWB_2008 = 0;
    
    LABEL GECODEERD_INSZ_RH = "Gecodeerd_insz rechthebbende";
    LABEL GECODEERD_INSZ_BT = "Gecodeerd_insz bijslagtrekkende";

RUN;
PROC FREQ DATA=LIBW.MIM2008_RKW;
    TABLES InRKW RKW_GWB_2008;
RUN;    
PROC CONTENTS DATA=LIBW.MIM2008_RKW;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
