/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens RSVZ
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSVZ_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSVZ.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

DM 'Log; CLEAR; Output; Clear; ';

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ MIMOSIS_WEIGHT NAREGNIS_DATBIRTH);
    
    /*Leeftijd*/
    indexstreepje = INDEX(NAREGNIS_DATBIRTH,'-');
    yearbirth     = INPUT(SUBSTR(NAREGNIS_DATBIRTH,indexstreepje+1,4),8.);
    monthbirth    = INPUT(SUBSTR(NAREGNIS_DATBIRTH,1,indexstreepje-1),8.);
    Leeftijd      = FLOOR(((2008 - yearbirth)*12 + monthbirth)/12);
    AGE = 9999999;
    IF NAREGNIS_DATBIRTH NE "9999999" AND TRIM(NAREGNIS_DATBIRTH) NE "-" THEN AGE = Leeftijd ;

    /*leeftijdsklasse*/
    AgeClass = 0;
    IF AGE LE 4                 then AgeClass = 1;
    IF AGE GT 4  and AGE LE 9   then AgeClass = 2;
    IF AGE GT 9  and AGE LE 14  then AgeClass = 3;
    IF AGE GT 14 and AGE LE 19  then AgeClass = 4;
    IF AGE GT 19 and AGE LE 24  then AgeClass = 5;
    IF AGE GT 24 and AGE LE 29  then AgeClass = 6;
    IF AGE GT 29 and AGE LE 34  then AgeClass = 7;
    IF AGE GT 34 and AGE LE 39  then AgeClass = 8;
    IF AGE GT 39 and AGE LE 44  then AgeClass = 9;
    IF AGE GT 44 and AGE LE 49  then AgeClass = 10;
    IF AGE GT 49 and AGE LE 54  then AgeClass = 11;
    IF AGE GT 54 and AGE LE 59  then AgeClass = 12;
    IF AGE GT 59 and AGE LE 64  then AgeClass = 13;
    IF AGE GT 64 and AGE LE 69  then AgeClass = 14;
    IF AGE GT 69 and AGE LE 74  then AgeClass = 15;
    IF AGE GT 74 and AGE LE 79  then AgeClass = 16;
    IF AGE GT 79 and AGE LE 84  then AgeClass = 17;
    IF AGE GT 84 and AGE LE 89  then AgeClass = 18;
    IF AGE GT 89 and AGE LE 94  then AgeClass = 19;
    IF AGE GT 94                then AgeClass = 20;
    
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA RSVZ;
    SET LIB.mim2008_rsvz_code;
    
    /*
    CONTRIB_SELFPCR
    !1   Self employed before the age of retirement  in principal activity
    !2   Self employed before the age of retirement in complementary activity
    !3   Self employed after the age of retirement
    !4   Self employed assistant before the age of retirement  in principal activity
    !5   Self employed assistant  before the age of retirement in complementary activity
    !6   Self employed assistant after the age of retirement
    */
    
    CONTRIB_SELFPCR = 0;
    IF HOEDRSVZ_2008 IN ("1","3") THEN DO;
        IF BIJDCAT_2008 IN ("A","H","I","J","K","O","L","Q","R","S","U")    THEN CONTRIB_SELFPCR = 1;
        IF BIJDCAT_2008 IN ("D")                                            THEN CONTRIB_SELFPCR = 2;
        IF BIJDCAT_2008 IN ("E","F","Y")                                    THEN CONTRIB_SELFPCR = 3;
    END;
    IF HOEDRSVZ_2008 IN ("2","4") THEN DO;
        IF BIJDCAT_2008 IN ("A","H","I","J","K","O","L","Q","R","S","U")    THEN CONTRIB_SELFPCR = 4;
        IF BIJDCAT_2008 IN ("D")                                            THEN CONTRIB_SELFPCR = 5;
        IF BIJDCAT_2008 IN ("E","F","Y")                                    THEN CONTRIB_SELFPCR = 6;
    END;
    Label CONTRIB_SELFPCR = "Status of the self employed in 2008";
    
    /*Maak variabele voor latere indentificatie van niet te reconstrueren inkomen*/
    NoIncomeLine_RSVZ = 0;
    IF BIJDCAT_2008 IN ("Q","K","R","S","T","U")    THEN NoIncomeLine_RSVZ = 1;

    /*jaar eerste aansluiting*/
    indexstreepje = INDEX(BEGAANSC_2008,'-');
    yearstart     = INPUT(SUBSTR(BEGAANSC_2008,indexstreepje+1,4),8.);

RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RSVZ
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
/*Voeg inkomensgegevens samen*/
DATA INC_SELF;
    SET 
    LIB.mim2008_rsvzinc2005_code(RENAME=(jaar_2005=jaar inkomens_2005=inkomens))
    LIB.mim2008_rsvzinc2006_code(RENAME=(jaar_2006=jaar inkomens_2006=inkomens))
    LIB.mim2008_rsvzinc2007_code(RENAME=(jaar_2007=jaar inkomens_2007=inkomens))
    LIB.mim2008_rsvzinc2008_code(RENAME=(jaar_2008=jaar inkomens_2008=inkomens))
    ;
    
    /*Maak variabele voor latere indentificatie van niet te reconstrueren inkomen*/
    IncomeZero_RSVZ = 0;    
    IF inkomens = 0 THEN IncomeZero_RSVZ = 1;   
    
    IF inkomens eq . THEN inkomens = 0;

RUN;
PROC FREQ DATA=INC_SELF;
    TITLE "Frequentie van lijnen met 0 inkomen in RSVZ inkomensbestanden";
    TABLES IncomeZero_RSVZ;
RUN;    
PROC SORT DATA=INC_SELF;
    BY GECODEERD_INSZ jaar inkomens;
RUN;
DATA INC_SELF;
    SET INC_SELF;
    BY GECODEERD_INSZ jaar inkomens;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;

RUN;
PROC FREQ DATA=INC_SELF;
    TITLE "Frequentie van lijnen met 0 inkomen in RSVZ inkomensbestanden: na reductie";
    TABLES IncomeZero_RSVZ;
RUN;    
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM INC_SELF
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
PROC FREQ DATA=INC_SELF;
    TITLE "Frequentie verdeling jaar-waarde voor alle INSZ in de inkomensbestanden";
    TABLES jaar;
RUN; 
PROC FREQ DATA=INC_SELF(WHERE=(inkomens=0));
    TITLE "Frequentie verdeling jaar-waarde voor INSZ in de inkomensbestanden met missing";
    TABLES jaar;
RUN; 
/*Lees herwaarderingscofficinten in*/
/*prijsindexen*/
DATA Index;
    INPUT @1 JAAR $4. @11 INDEX 10.6;
    DATALINES;
1990        1.397255
1991        1.384679
1992        1.360938
1993        1.344244
1994        1.320380
1995        1.301281
1996        1.297884
1997        1.279495
1998        1.238527
1999        1.215827
2000        1.194185
2001        1.175256
2002        1.139858
2003        1.102706
2004        1.088249
2005        1.062112
2006        1.025825
2007        1.025825
2008        1.000000
   ;
RUN;
PROC SORT DATA=Index;
    BY JAAR;
RUN;    
PROC PRINT DATA=Index;
RUN;
/*Maak tabel met toegevoegde index*/
PROC SORT DATA=INC_SELF;
    BY JAAR;
RUN;    
DATA INC_SELF;
    MERGE INC_SELF(in=InA) Index;
    BY JAAR;
    
    IF InA EQ 1;
    
    inkomens_2008 = inkomens*index;
    inkomens_2008_basis = inkomens_2008;
    
    KEEP GECODEERD_INSZ jaar inkomens inkomens_2008 inkomens_2008_basis IncomeZero_RSVZ;

RUN;   
PROC FREQ DATA=INC_SELF;
    TITLE "Frequentie van lijnen met 0 inkomen in RSVZ inkomensbestanden: na samenvoeging met index";
    TABLES IncomeZero_RSVZ;
RUN;    
PROC PRINT DATA=INC_SELF(obs=20);
    TITLE "Geconverteerde inkomens";
RUN; 
/*Maak een samengevoegd bestand*/
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=RSVZ;
    BY GECODEERD_INSZ;
RUN;  
PROC SORT DATA=INC_SELF;
    BY GECODEERD_INSZ;
RUN;  
DATA COMBIN;
    MERGE TOTPOP(in=InA) INC_SELF(in=InB) RSVZ(in=InC);
    BY GECODEERD_INSZ;

    IF InA EQ 1;

    /*Vul identifier aan die aangeeft of inkomen moet gereconstrueerd worden of niet*/
    /*Eerst starters met nul-inkomen herinschakelen*/
    IF yearstart GE 2006 AND IncomeZero_RSVZ EQ 1 THEN IncomeZero_RSVZ = 0;   
    IF NoIncomeLine_RSVZ   EQ . THEN NoIncomeLine_RSVZ = 0;
    IF NoIncomeLine_RSVZ EQ 0 AND IncomeZero_RSVZ EQ 1 THEN NoIncomeLine_RSVZ = 2;
    
    /*Vul andere missing values in*/
    IF inkomens_2008 EQ .       THEN inkomens_2008 = 0;
    IF inkomens_2008_basis EQ . THEN inkomens_2008_basis = 0;

    SelfStat_2008 = 0;
    IF InB EQ 1 AND InC EQ 0 THEN SelfStat_2008 = 1;
    IF InB EQ 0 AND InC EQ 1 THEN SelfStat_2008 = 2;
    IF InB EQ 1 AND InC EQ 1 THEN SelfStat_2008 = 3;
    
RUN; 
PROC FREQ DATA=COMBIN;
    TITLE "Aantal zelfstandigen aangeduid op basis van RSVZ basisbestand";
    TABLES SelfStat_2008;
RUN;    
/*Bereken gemiddelde waarde*/
PROC MEANS DATA=COMBIN(where=(inkomens_2008<>0)) VARDEF=WEIGHT;
    TITLE "Gemiddeld geobserveerd inkomen";
    VAR     inkomens_2008;
    WEIGHT  MIMOSIS_WEIGHT;
    OUTPUT  OUT=OutMean_Tot
            MEAN(inkomens_2008)     = Mean_Tot_Inc2008
            N(inkomens_2008)        = N_Tot_Inc2008
    ;            
RUN; 
DATA OutMean_Tot;
    SET OutMean_Tot(KEEP = Mean_Tot_Inc2008 N_Tot_Inc2008);
RUN;    
/*bereken het gemiddelde per leeftijd*/
PROC MEANS DATA=COMBIN(where=(inkomens_2008<>0)) VARDEF=WEIGHT;
    TITLE "Gemiddeld geobserveerd inkomen per leeftijdsklasse";
    VAR     inkomens_2008;
    WEIGHT  MIMOSIS_WEIGHT;
    CLASS   AgeClass;
    OUTPUT  OUT=OutMean_AGE
            MEAN(inkomens_2008)     = Mean_Age_Inc2008
            N(inkomens_2008)        = N_Age_Inc2008
    ;            
RUN; 
DATA OutMean_AGE;
    SET OutMean_AGE(KEEP = AgeClass Mean_Age_Inc2008 N_Age_Inc2008 WHERE=(AgeClass>0));
RUN;    
/*bereken het gemiddelde per bijdragegroep*/
PROC MEANS DATA=COMBIN(where=(inkomens_2008<>0)) VARDEF=WEIGHT;
    TITLE "Gemiddeld geobserveerd inkomen per bijdragegroep";
    VAR     inkomens_2008;
    WEIGHT  MIMOSIS_WEIGHT;
    CLASS   CONTRIB_SELFPCR;
    OUTPUT  OUT=OutMean_Bijdr
            MEAN(inkomens_2008)     = Mean_Bijdr_Inc2008
            N(inkomens_2008)        = N_Bijdr_Inc2008
    ;            
RUN; 
DATA OutMean_Bijdr;
    SET OutMean_Bijdr(KEEP = CONTRIB_SELFPCR Mean_Bijdr_Inc2008 N_Bijdr_Inc2008 WHERE=(CONTRIB_SELFPCR>0));
RUN;    
/*bereken het gemiddelde per leeftijd en per bijdragegroep*/
PROC MEANS DATA=COMBIN(where=(inkomens_2008<>0)) VARDEF=WEIGHT;
    TITLE "Gemiddeld geobserveerd inkomen per bijdragegroep in leeftijdsklasse";
    VAR     inkomens_2008;
    WEIGHT  MIMOSIS_WEIGHT;
    CLASS   AgeClass CONTRIB_SELFPCR;
    OUTPUT  OUT=OutMean_Age_Bijdr
            MEAN(inkomens_2008)     = Mean_Age_Bijdr_Inc2008
            N(inkomens_2008)        = N_Age_Bijdr_Inc2008
    ;            
RUN; 
DATA OutMean_Age_Bijdr;
    SET OutMean_Age_Bijdr(KEEP = AgeClass CONTRIB_SELFPCR Mean_Age_Bijdr_Inc2008 N_Age_Bijdr_Inc2008 WHERE=(AgeClass>0 AND CONTRIB_SELFPCR>0));
RUN;    
/*Voeg onderdelen samen*/
PROC SORT DATA=OutMean_Age;
    BY AgeClass;
RUN;
PROC SORT DATA=COMBIN;
    BY AgeClass;
RUN;
DATA COMBIN;
    MERGE COMBIN(in=InA) OutMean_Age;
    BY AgeClass;
    
    IF InA EQ 1;
    
RUN;
PROC SORT DATA=OutMean_Bijdr;
    BY CONTRIB_SELFPCR;
RUN;
PROC SORT DATA=COMBIN;
    BY CONTRIB_SELFPCR;
RUN;
DATA COMBIN;
    MERGE COMBIN(in=InA) OutMean_Bijdr;
    BY CONTRIB_SELFPCR;

    IF InA EQ 1;

RUN;
PROC SORT DATA=OutMean_Age_Bijdr;
    BY AgeClass CONTRIB_SELFPCR;
RUN;
PROC SORT DATA=COMBIN;
    BY AgeClass CONTRIB_SELFPCR;
RUN;
DATA COMBIN;
    MERGE COMBIN(in=InA) OutMean_Age_Bijdr;
    BY AgeClass CONTRIB_SELFPCR;

    IF InA EQ 1;

RUN;
/*Voeg info toe aan basisdataset en vervang missing values inkomen*/
DATA MIM2008_RSVZ;
    SET COMBIN;
    IF _N_ EQ 1 THEN SET OutMean_Tot;
    
    Bron_Aanv = 0;
    IF SelfStat_2008 GT 1 AND inkomens_2008 GT 0 THEN Bron_Aanv = 1;

    /*Merk op: ook voor starters wordt dus een ontbrekende waarde ingevuld:
    Bij het doorgeven van CONTRIB naar PIT moet er dan wel opgelet worden dat daar hun inkomen wordt uitgeschakeld
    maar voor de constructie van de inkomensverdeling moet het dan weer wel in rekening gebracht worden*/

    IF SelfStat_2008 GT 1 AND NoIncomeLine_RSVZ EQ 0 THEN DO;
        IF inkomens_2008 EQ 0 AND N_Age_Bijdr_Inc2008 > 100 THEN DO;
            inkomens_2008 = Mean_Age_Bijdr_Inc2008;
            Bron_Aanv = 2;
        END;            
        IF inkomens_2008 EQ 0 AND N_Bijdr_Inc2008 > 100     THEN DO;
            inkomens_2008 = Mean_Bijdr_Inc2008;
            Bron_Aanv = 3;
        END;            
        IF inkomens_2008 EQ 0 AND N_Age_Inc2008 > 100       THEN DO;
            inkomens_2008 = Mean_Age_Inc2008;
            Bron_Aanv = 4;
        END;            
        IF inkomens_2008 EQ 0                               THEN DO;
            inkomens_2008 = Mean_Tot_Inc2008;
            Bron_Aanv = 5;
        END;            
    END;
    
    /*Selecteer over te houden variabelen*/
    LABEL jaar                  = "Jaar waarin het RSVZ-inkomen geobserveerd werd";
    LABEL inkomens              = "Inkomen op jaarbasis voor correctie en uitgedrukt in prijzen van het registratiejaar";
    LABEL inkomens_2008         = "Inkomen op jaarbasis na aanvulling van ontbrekende waarden en uitgedrukt in prijzen van 2008";
    LABEL SelfStat_2008         = "Aanduiding of het individu voorkomt in het bestand met inkomens en/of aansluitingsgegevens RSVZ";
    LABEL inkomens_2008_basis   = "Inkomen op jaarbasis voor aanvulling van ontbrekende waarden en uitgedrukt in prijzen van 2008";
    LABEL Bron_Aanv             = "Bron op basis waarvan de ontbrekende inkomensgegevens werden aangevuld";
    LABEL NoIncomeLine_RSVZ     = "Variabele die aangeeft of voor een gegeven lijn geen inkomen gereconstrueerd moest worden";
    
    KEEP 
    GECODEERD_INSZ
    jaar
    inkomens
    inkomens_2008
    inkomens_2008_basis
    Bron_Aanv
    SelfStat_2008
    BEGAANSC_2008
    SCHAANSC_2008
    BEROEPC_2008 
    NACEC_2008   
    BIJDCAT_2008 
    HOEDRSVZ_2008
    NoIncomeLine_RSVZ
    MIMOSIS_WEIGHT
    ;
    
RUN;
PROC MEANS DATA=MIM2008_RSVZ(where=(SelfStat_2008>1));
    TITLE "Gemiddeld geobserveerd inkomen: na aanvulling 0 waarden";
    VAR   inkomens_2008;
RUN; 
PROC MEANS DATA=MIM2008_RSVZ(where=(SelfStat_2008>1)) SUM VARDEF=WEIGHT;
    TITLE "Som geobserveerd inkomen: na aanvulling 0 waarden";
    VAR   inkomens_2008;
    CLASS Bron_Aanv;
    WEIGHT MIMOSIS_WEIGHT;
RUN; 
PROC FREQ DATA=MIM2008_RSVZ(where=(SelfStat_2008>1));
    TITLE "Verdeling bron op basis waarvan de ontbrekende inkomensgegevens werden aangevuld";
    TABLES Bron_Aanv;
    WEIGHT MIMOSIS_WEIGHT;
RUN; 
PROC FREQ DATA=MIM2008_RSVZ(where=(SelfStat_2008>1));
    TITLE "Verdeling lijnen waarvoor geen inkomensgegeven moest worden aangevuld";
    TABLES NoIncomeLine_RSVZ;
RUN;
PROC FREQ DATA=MIM2008_RSVZ(where=(Bron_Aanv = 1));
    TITLE "Verdeling lijnen die later moeten uitgeschakeld worden en die toch een geobserveerd inkomen hebben";
    TABLES NoIncomeLine_RSVZ;
RUN; 
PROC PRINT DATA=MIM2008_RSVZ(where=(SelfStat_2008>1 and inkomens_2008 eq .));
RUN;
/*Voeg info toe aan basisdataset en vervang missing values inkomen*/
DATA LIBW.MIM2008_RSVZ;
    SET MIM2008_RSVZ;
    DROP MIMOSIS_WEIGHT;
RUN;    
PROC CONTENTS DATA=LIBW.MIM2008_RSVZ;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
