/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens RSVZ_KB
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSVZ_KB_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSVZ_KB.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA RSVZ_KB;
    SET LIB.mim2008_rsvz_kb_code(RENAME=(GECODEERD_INSZ_RG=GECODEERD_INSZ));
RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RSVZ_KB
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
/*reduceer het aantal lijnen tot n per rechtgevend kind*/
PROC SORT DATA=RSVZ_KB;
    BY GECODEERD_INSZ GECODEERD_INSZ_RH GECODEERD_INSZ_BT;
RUN;
DATA RSVZ_KB;
    SET RSVZ_KB;
    BY GECODEERD_INSZ GECODEERD_INSZ_RH GECODEERD_INSZ_BT;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
    
RUN;
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RSVZ_KB
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na reductie";
    TABLES NUM_Indiv;
RUN;
/*Voeg gegevens samen op niveau populatie*/
DATA LIBW.MIM2008_RSVZ_KB;
    MERGE TOTPOP(in=InA) RSVZ_KB(in=InB);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InRSVZ_KB = 0;
    IF InB EQ 1 THEN InRSVZ_KB = 1;
    LABEL InRSVZ_KB = "Individu geselecteerd uit basisdata RSVZ_KB voor verwerking steekproef";

    IF BT_HOED_2008 EQ . THEN BT_HOED_2008 = 0;
    
    GECODEERD_INSZ_RH_RSVZ = GECODEERD_INSZ_RH;
    GECODEERD_INSZ_BT_RSVZ = GECODEERD_INSZ_BT;
    
    
    LABEL GECODEERD_INSZ_RH_RSVZ = "Gecodeerd_insz rechthebbende bij RSVZ";
    LABEL GECODEERD_INSZ_BT_RSVZ = "Gecodeerd_insz bijslagtrekkende bij RSVZ";
    
    DROP GECODEERD_INSZ_RH GECODEERD_INSZ_BT;

RUN;
PROC FREQ DATA=LIBW.MIM2008_RSVZ_KB;
    TABLES InRSVZ_KB BT_HOED_2008;
RUN;    
PROC CONTENTS DATA=LIBW.MIM2008_RSVZ_KB;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
