/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens RSZ
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSZ_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSZ.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ MIMOSIS_WEIGHT);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA RSZ_BASIS;
    SET LIB.mim2008_rszquart_code
    (DROP = 
    CONTRIBUTIONCODE_081          
    CONTRIBUTIONCALCULATIONBASIS_081
    CONTRIBUTIONAMOUNT_081        
    CONTRIBUTIONCODE_082          
    CONTRIBUTIONCALCULATIONBASIS_082
    CONTRIBUTIONAMOUNT_082        
    CONTRIBUTIONCODE_083          
    CONTRIBUTIONCALCULATIONBASIS_083
    CONTRIBUTIONAMOUNT_083        
    CONTRIBUTIONCODE_084          
    CONTRIBUTIONCALCULATIONBASIS_084
    CONTRIBUTIONAMOUNT_084);
    
    /*schrap lijnen die niet moeten weerhouden worden volgens de DOCDWH regels*/
    IF (sal100_20084+primes_20084+preavi_20084+salatt_20084+salfor_20084)<0 THEN DELETE;

    /*Construeer variabelen vakantiegeld*:
    /*Definieer groepen bepaling enkel vakantiegeld*/
    GROEP_VG = 0;
    IF                   Clatra_20084 EQ 2 AND                                                Clatr2_20084 IN ('EU', 'ER') THEN GROEP_VG = 1; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 1   AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 1   AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 1   AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 1   AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 1   AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 1   AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 16  AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OX'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 16  AND Codtra_20084 EQ 20 AND Clatr2_20084 EQ 'OY'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 17  AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OX'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 17  AND Codtra_20084 EQ 20 AND Clatr2_20084 EQ 'OY'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 27  AND Codtra_20084 EQ 13 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 27  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 27  AND Codtra_20084 EQ 16 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 27  AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 27  AND Codtra_20084 EQ 41 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 27  AND Codtra_20084 EQ 45 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 28  AND Codtra_20084 EQ 13 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 28  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 28  AND Codtra_20084 EQ 16 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 28  AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 28  AND Codtra_20084 EQ 45 AND Clatr2_20084 EQ 'XA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 34  AND Codtra_20084 EQ 11 AND Clatr2_20084 EQ 'XC'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 34  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'XC'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 40  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 40  AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 40  AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 42  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 42  AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 42  AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 43  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 43  AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 45  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 45  AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 45  AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 46  AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 46  AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 50  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 50  AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 50  AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 50  AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 50  AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 71  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 96  AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 96  AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 96  AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 96  AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 96  AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 97  AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OZ'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 97  AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OH'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 97  AND Codtra_20084 EQ 20 AND Clatr2_20084 EQ 'OY'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 97  AND Codtra_20084 EQ 22 AND Clatr2_20084 EQ 'OJ'         THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 101 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 140 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 145 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 150 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 175 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 175 AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 175 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 175 AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 193 AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OH'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 193 AND Codtra_20084 EQ 22 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 194 AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OH'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 194 AND Codtra_20084 EQ 22 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 196 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 245 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 245 AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 245 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 296 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 296 AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 296 AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 296 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;  
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 296 AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 347 AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 347 AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 351 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 351 AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 351 AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 351 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 351 AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 396 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 396 AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 396 AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 396 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 396 AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 440 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 440 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 441 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 441 AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 441 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 441 AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 443 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 443 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 445 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 445 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 494 AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OH'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 494 AND Codtra_20084 EQ 22 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 496 AND Codtra_20084 EQ 15 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 496 AND Codtra_20084 EQ 19 AND Clatr2_20084 EQ 'OO'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 496 AND Codtra_20084 EQ 24 AND Clatr2_20084 EQ 'OS'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 496 AND Codtra_20084 EQ 27 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 496 AND Codtra_20084 EQ 35 AND Clatr2_20084 EQ 'OA'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 497 AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OZ'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 497 AND Codtra_20084 EQ 20 AND Clatr2_20084 EQ 'OY'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 594 AND Codtra_20084 EQ 10 AND Clatr2_20084 EQ 'OH'         THEN GROEP_VG = 2;
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1 AND Cattra_20084 EQ 594 AND Codtra_20084 EQ 22 AND Clatr2_20084 EQ 'OE'         THEN GROEP_VG = 2;            
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 1                                                                                 THEN GROEP_VG = 1; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 2                                                                                 THEN GROEP_VG = 2; 
    IF GROEP_VG EQ 0 AND Clatra_20084 EQ 3                                                                                 THEN GROEP_VG = 3; 
    IF GROEP_VG EQ 0                                                                                                       THEN GROEP_VG = 2; 

RUN; 
/*Test frequentie vakantiegeld-regime*/
PROC FREQ DATA=RSZ_BASIS;
    TITLE "Frequentie vakantiegeld-regimes";
    TABLES GROEP_VG;
RUN;  
PROC FREQ DATA=RSZ_BASIS;
    TITLE "Codes bijdragevermindering";
    TABLES DeductionCode_20084;
RUN;  
PROC FREQ DATA=RSZ_BASIS(WHERE=( pp_rrnmc_20084 = "Y"));
    TITLE "Codes bijdragevermindering in de hoofdlijn van de job";
    TABLES DeductionCode_20084;
RUN;   
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_PersRed
    FROM RSZ_BASIS
    WHERE DeductionCode_20084 = 1
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met een werkbonus-lijn";
    TABLES NUM_PersRed;
RUN;
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv, COUNT(DISTINCT CATTRA_20084) AS NUM_CATTRA, COUNT(DISTINCT CODTRA_20084) AS NUM_CODTRA, COUNT(DISTINCT CLATR2_20084) AS NUM_CLATR2, COUNT(DISTINCT GROEP_VG) AS NUM_VG
    FROM RSZ_BASIS
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende Cattra codes";
    TABLES NUM_CATTRA;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende Codtra codes";
    TABLES NUM_CODTRA;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende Clatr2 codes";
    TABLES NUM_CLATR2;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende vakantiegeld code";
    TABLES NUM_VG;
RUN;
/*Tel unieke verminderingscodes per individu*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(DISTINCT DeductionCode_20084) AS NUM_PersRed
    FROM RSZ_BASIS
    WHERE DeductionCode_20084 IN (1, 501, 600)
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met meerdere codes voor persoonlijke bijdragevermindering";
    TABLES NUM_PersRed;
RUN;
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(DISTINCT DeductionCode_20084) AS NUM_EmpRed
    FROM RSZ_BASIS
    WHERE DeductionCode_20084 > 600
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met meerdere codes voor bijdrageverminderingen werkgever";
    TABLES NUM_EmpRed;
RUN;
/*Test aantal jobs per individu*/
PROC SQL;
    CREATE TABLE COUNT_Jobs AS
    SELECT COUNT(*) AS NUM_Jobs
    FROM RSZ_BASIS
    WHERE pp_rrnmc_20084 = "Y"
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Jobs;
    TITLE "Frequentie van het aantal jobs per individu";
    TABLES NUM_Jobs;
RUN;
/*Reduceer gegevens tot n lijn*/
PROC SORT DATA=RSZ_BASIS;
    BY
    GECODEERD_INSZ
    pp_rrnmc_20084
    sal100_20084         
    saljrs_20084         
    primes_20084         
    preavi_20084         
    salatt_20084         
    salfor_20084         
    mntded_20084         
    cotpat_20084         
    cotper_20084         
    cotspe_20084         
    DeductionAmount_20084
    mpecvac_20084        
    mcotdpv_20084        
    jrsrem_f_20084       
    jrsrem_p_20084       
    jrspre_20084         
    jrsvac_20084         
    jrsasm_20084             
    ;
RUN;
DATA RSZ;
    SET RSZ_BASIS;
    BY
    GECODEERD_INSZ
    pp_rrnmc_20084
    sal100_20084         
    saljrs_20084         
    primes_20084         
    preavi_20084         
    salatt_20084         
    salfor_20084         
    mntded_20084         
    cotpat_20084         
    cotper_20084         
    cotspe_20084         
    DeductionAmount_20084
    mpecvac_20084        
    mcotdpv_20084        
    jrsrem_f_20084       
    jrsrem_p_20084       
    jrspre_20084         
    jrsvac_20084         
    jrsasm_20084             
    ;

    RETAIN
    sal100_agg         
    primes_agg         
    preavi_agg         
    salatt_agg         
    salfor_agg         
    mntded_agg         
    cotpat_agg         
    cotper_agg         
    cotspe_agg         
    DeductionAmount_agg_pers
    DeductionAmount_agg_pat
    mpecvac_agg        
    mcotdpv_agg        
    jrsrem_f_agg       
    jrsrem_p_agg       
    jrspre_agg         
    jrsvac_agg         
    jrsasm_agg             
    0
    ;

    IF FIRST.GECODEERD_INSZ THEN DO;
        /*Initialiseer variabelen die geaggregeerd worden*/
        sal100_agg                  = 0;
        primes_agg                  = 0;
        preavi_agg                  = 0;
        salatt_agg                  = 0;
        salfor_agg                  = 0;
        mntded_agg                  = 0;
        cotpat_agg                  = 0;
        cotper_agg                  = 0;
        cotspe_agg                  = 0;
        DeductionAmount_agg_pers    = 0;
        DeductionAmount_agg_pat     = 0;
        mpecvac_agg                 = 0;
        mcotdpv_agg                 = 0;
        jrsrem_f_agg                = 0;
        jrsrem_p_agg                = 0;
        jrspre_agg                  = 0;
        jrsvac_agg                  = 0;
        jrsasm_agg                  = 0;
        /*Zet waarde indien basisgegeven niet missing is*/
        IF sal100_20084          NE .                                               THEN sal100_agg                 = sal100_20084         ;
        IF primes_20084          NE .                                               THEN primes_agg                 = primes_20084         ;   
        IF preavi_20084          NE .                                               THEN preavi_agg                 = preavi_20084         ;
        IF salatt_20084          NE .                                               THEN salatt_agg                 = salatt_20084         ;
        IF salfor_20084          NE .                                               THEN salfor_agg                 = salfor_20084         ;
        IF mntded_20084          NE .                                               THEN mntded_agg                 = mntded_20084         ;
        IF cotpat_20084          NE .                                               THEN cotpat_agg                 = cotpat_20084         ;
        IF cotper_20084          NE .                                               THEN cotper_agg                 = cotper_20084         ;
        IF cotspe_20084          NE .                                               THEN cotspe_agg                 = cotspe_20084         ;
        IF DeductionAmount_20084 NE . AND DeductionCode_20084 IN (1, 501, 600)      THEN DeductionAmount_agg_pers   = DeductionAmount_20084;
        IF DeductionAmount_20084 NE . AND DeductionCode_20084 NOT IN (1, 501, 600)  THEN DeductionAmount_agg_pat    = DeductionAmount_20084;
        IF mpecvac_20084         NE .                                               THEN mpecvac_agg                = mpecvac_20084        ;
        IF mcotdpv_20084         NE .                                               THEN mcotdpv_agg                = mcotdpv_20084        ;
        IF jrsrem_f_20084        NE .                                               THEN jrsrem_f_agg               = jrsrem_f_20084       ;
        IF jrsrem_p_20084        NE .                                               THEN jrsrem_p_agg               = jrsrem_p_20084       ;
        IF jrspre_20084          NE .                                               THEN jrspre_agg                 = jrspre_20084         ;
        IF jrsvac_20084          NE .                                               THEN jrsvac_agg                 = jrsvac_20084         ;
        IF jrsasm_20084          NE .                                               THEN jrsasm_agg                 = jrsasm_20084         ;
    END;
    ELSE DO;
        /*Tel andere waarden er bij op*/
        IF sal100_20084          NE .                                               THEN sal100_agg                 = sal100_agg                + sal100_20084         ;
        IF primes_20084          NE .                                               THEN primes_agg                 = primes_agg                + primes_20084         ;   
        IF preavi_20084          NE .                                               THEN preavi_agg                 = preavi_agg                + preavi_20084         ;
        IF salatt_20084          NE .                                               THEN salatt_agg                 = salatt_agg                + salatt_20084         ;
        IF salfor_20084          NE .                                               THEN salfor_agg                 = salfor_agg                + salfor_20084         ;
        IF mntded_20084          NE .                                               THEN mntded_agg                 = mntded_agg                + mntded_20084         ;
        IF cotpat_20084          NE .                                               THEN cotpat_agg                 = cotpat_agg                + cotpat_20084         ;
        IF cotper_20084          NE .                                               THEN cotper_agg                 = cotper_agg                + cotper_20084         ;
        IF cotspe_20084          NE .                                               THEN cotspe_agg                 = cotspe_agg                + cotspe_20084         ;
        IF DeductionAmount_20084 NE . AND DeductionCode_20084 IN (1, 501, 600)      THEN DeductionAmount_agg_pers   = DeductionAmount_agg_pers  + DeductionAmount_20084;
        IF DeductionAmount_20084 NE . AND DeductionCode_20084 NOT IN (1, 501, 600)  THEN DeductionAmount_agg_pat    = DeductionAmount_agg_pat   + DeductionAmount_20084;
        IF mpecvac_20084         NE .                                               THEN mpecvac_agg                = mpecvac_agg               + mpecvac_20084        ;
        IF mcotdpv_20084         NE .                                               THEN mcotdpv_agg                = mcotdpv_agg               + mcotdpv_20084        ;
        IF jrsrem_f_20084        NE .                                               THEN jrsrem_f_agg               = jrsrem_f_agg              + jrsrem_f_20084       ;
        IF jrsrem_p_20084        NE .                                               THEN jrsrem_p_agg               = jrsrem_p_agg              + jrsrem_p_20084       ;
        IF jrspre_20084          NE .                                               THEN jrspre_agg                 = jrspre_agg                + jrspre_20084         ;
        IF jrsvac_20084          NE .                                               THEN jrsvac_agg                 = jrsvac_agg                + jrsvac_20084         ;
        IF jrsasm_20084          NE .                                               THEN jrsasm_agg                 = jrsasm_agg                + jrsasm_20084         ;
    END;

    DROP
    sal100_20084         
    primes_20084         
    preavi_20084         
    salatt_20084         
    salfor_20084         
    mntded_20084         
    cotpat_20084         
    cotper_20084         
    cotspe_20084         
    DeductionAmount_20084
    mpecvac_20084        
    mcotdpv_20084        
    jrsrem_f_20084       
    jrsrem_p_20084       
    jrspre_20084         
    jrsvac_20084         
    jrsasm_20084             
    ;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;

RUN; 
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RSZ
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na reductie";
    TABLES NUM_Indiv;
RUN;
/*Selecteer eerste, tweede en derde code vermindering werkgeversbijdrage*/
/*Werknemers-bijdrageverminderingen*/
/*eerste code*/
DATA CODE_BASIS;
    SET RSZ_BASIS(KEEP=GECODEERD_INSZ DeductionCode_20084 pp_rrnmc_20084 sal100_20084);

    IF DeductionCode_20084 NOT IN (1, 501, 600)     THEN DELETE;
    IF DeductionCode_20084 EQ 0                     THEN DELETE;
RUN;
PROC SORT DATA=CODE_BASIS;
    BY GECODEERD_INSZ pp_rrnmc_20084 sal100_20084;
RUN;
DATA CODE_PERS1;
    SET CODE_BASIS;
    BY GECODEERD_INSZ pp_rrnmc_20084 sal100_20084;
    
    DeductionCode_Pers_1 = DeductionCode_20084;
    
    KEEP GECODEERD_INSZ DeductionCode_Pers_1;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC FREQ DATA=CODE_PERS1;
    TITLE "Eerste reductiecode persoonlijke bijdrageverminderingen";
    TABLES DeductionCode_Pers_1;
RUN;    
/*Werkgevers-bijdrageverminderingen*/
/*eerste code*/
DATA CODE_BASIS;
    SET RSZ_BASIS(KEEP=GECODEERD_INSZ DeductionCode_20084 pp_rrnmc_20084 sal100_20084);

    IF DeductionCode_20084 IN (1, 501, 600)         THEN DELETE;
    IF DeductionCode_20084 EQ 0                     THEN DELETE;
RUN;
PROC SORT DATA=CODE_BASIS;
    BY GECODEERD_INSZ pp_rrnmc_20084 sal100_20084;
RUN;
DATA CODE_PAT1;
    SET CODE_BASIS;
    BY GECODEERD_INSZ pp_rrnmc_20084 sal100_20084;
    
    DeductionCode_Pat_1 = DeductionCode_20084;
    
    KEEP GECODEERD_INSZ DeductionCode_Pat_1;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC FREQ DATA=CODE_PAT1;
    TITLE "Eerste reductiecode patronale bijdrageverminderingen";
    TABLES DeductionCode_Pat_1;
RUN;    
/*Tweede code*/
DATA CODE_PAT1;
    SET CODE_PAT1(KEEP=GECODEERD_INSZ DeductionCode_Pat_1);
RUN;
PROC SORT DATA=CODE_PAT1;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=CODE_BASIS;
    BY GECODEERD_INSZ;
RUN;
DATA CODE_BASIS;
    MERGE CODE_BASIS CODE_PAT1;
    BY GECODEERD_INSZ;

    IF DeductionCode_20084 IN (1, 501, 600)         THEN DELETE;
    IF DeductionCode_20084 EQ DeductionCode_Pat_1   THEN DELETE;
    IF DeductionCode_20084 EQ 0                     THEN DELETE;
RUN;
PROC SORT DATA=CODE_BASIS;
    BY GECODEERD_INSZ pp_rrnmc_20084 sal100_20084;
RUN;
DATA CODE_PAT2;
    SET CODE_BASIS;
    BY GECODEERD_INSZ pp_rrnmc_20084 sal100_20084;
    
    DeductionCode_Pat_2 = DeductionCode_20084;
    
    KEEP GECODEERD_INSZ DeductionCode_Pat_2;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC FREQ DATA=CODE_PAT2;
    TITLE "Tweede reductiecode patronale bijdrageverminderingen";
    TABLES DeductionCode_Pat_2;
RUN; 
/*Derde code*/
PROC SORT DATA=CODE_PAT2;
    BY GECODEERD_INSZ;
RUN;
DATA CODE_BASIS;
    MERGE CODE_BASIS CODE_PAT2;
    BY GECODEERD_INSZ;

    IF DeductionCode_20084 IN (1, 501, 600)         THEN DELETE;
    IF DeductionCode_20084 EQ DeductionCode_Pat_2   THEN DELETE;
    IF DeductionCode_20084 EQ 0                     THEN DELETE;
RUN;
PROC SORT DATA=CODE_BASIS;
    BY GECODEERD_INSZ pp_rrnmc_20084 sal100_20084;
RUN;
DATA CODE_PAT3;
    SET CODE_BASIS;
    BY GECODEERD_INSZ pp_rrnmc_20084 sal100_20084;
    
    DeductionCode_Pat_3 = DeductionCode_20084;
    
    KEEP GECODEERD_INSZ DeductionCode_Pat_3;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC FREQ DATA=CODE_PAT3;
    TITLE "Derde reductiecode patronale bijdrageverminderingen";
    TABLES DeductionCode_Pat_3;
RUN;
/*Voeg onderdelen samen tot n bestand*/
PROC SORT DATA=CODE_PERS1;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=CODE_PAT1;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=CODE_PAT2;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=CODE_PAT3;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=LIB.mim2008_rszyear_2008_code;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=LIB.mim2008_labmstatrsz_2008_code;
    BY GECODEERD_INSZ;
RUN;
/*Breng gegevens op niveau totale populatie*/
DATA MIM2008_RSZ;
    MERGE TOTPOP(in=InA) RSZ(in=InB) CODE_PERS1 CODE_PAT1 CODE_PAT2 CODE_PAT3 LIB.mim2008_rszyear_2008_code(in=InC) LIB.mim2008_labmstatrsz_2008_code;
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InRSZ = 0;
    IF InB EQ 1                 THEN InRSZ = 1;
    IF InB EQ 0 AND InC EQ 1    THEN InRSZ = 2;
    LABEL InRSZ = "Individu geselecteerd uit basisdata RSZ voor verwerking steekproef";

    /*Geaggregeerde waarden*/
    LABEL sal100_agg                = "loon 100% (aggregaat op kwartaalbasis)";                                                                                                                                                                                             
    LABEL primes_agg                = "premies (aggregaat op kwartaalbasis)";                                                                                                                                                                                                 
    LABEL preavi_agg                = "vooropzeg (aggregaat op kwartaalbasis)";                                                                                                                                                                                               
    LABEL salatt_agg                = "wachtloon (aggregaat op kwartaalbasis)";                                                                                                                                                                                               
    LABEL salfor_agg                = "forfaitair loon (aggregaat op kwartaalbasis)";                                                                                                                                                                                         
    LABEL mntded_agg                = "gecumuleerd bedrag van de vermindering (aggregaat op kwartaalbasis)";                                                                                                                                                                  
    LABEL cotpat_agg                = "bedrag werkgeversbijdrage (aggregaat op kwartaalbasis)";                                                                                                                                                                               
    LABEL cotper_agg                = "bedrag persoonlijke bijdrage (aggregaat op kwartaalbasis)";                                                                                                                                                                            
    LABEL cotspe_agg                = "bedrag bijzondere bijdragen (aggregaat op kwartaalbasis)";                                                                                                                                                                             
    LABEL DeductionAmount_agg_pers  = "Bedrag van de toegestane persoonlijke bijdragevermindering (aggregaat op kwartaalbasis)";                                                                                                                                                           
    LABEL DeductionAmount_agg_pat   = "Bedrag van de toegestane patronale bijdragevermindering (aggregaat op kwartaalbasis)";                                                                                                                                                           
    LABEL mpecvac_agg               = "geaggregeerd dubbel vakantiegeld (aggregaat op kwartaalbasis)";                                                                                                                                                                        
    LABEL mcotdpv_agg               = "Bijdrage op geaggregeerd dubbel vakantiegeld (aggregaat op kwartaalbasis)";                                                                                                                                                            
    LABEL jrsrem_f_agg              = "aantal normale bezoldigde fulltimedagen (aggregaat op kwartaalbasis)";                                                                                                                                                                 
    LABEL jrsrem_p_agg              = "aantal bezoldigde parttimedagen (aggregaat op kwartaalbasis)";                                                                                                                                                                         
    LABEL jrspre_agg                = "aantal bezoldigde dagen vooropzeg (aggregaat op kwartaalbasis)";                                                                                                                                                                       
    LABEL jrsvac_agg                = "aantal bezoldigde vakantiedagen (aggregaat op kwartaalbasis)";                                                                                                                                                                         
    LABEL jrsasm_agg                = "aantal bezoldigde gelijkgestelde dagen (aggregaat op kwartaalbasis)";                                                                                                                                                                  
    /*geconstrueerde bijdrage-verminderingen*/
    LABEL GROEP_VG              = "Groep bepaling vakantiegeld";
    LABEL DeductionCode_Pers_1  = "Verminderingscode persoonlijke bijdragevermindering";
    LABEL DeductionCode_Pat_1   = "Verminderingscode patronale bijdragevermindering: code 1";
    LABEL DeductionCode_Pat_2   = "Verminderingscode patronale bijdragevermindering: code 2";
    LABEL DeductionCode_Pat_3   = "Verminderingscode patronale bijdragevermindering: code 3";
    /*Extra variabelen op jaarbasis*/
    LABEL RSZ_Full_2008         = "Aantal dagen voltijds op jaarbasis";
    LABEL RSZ_Part_2008         = "Aantal dagen deeltijds op jaarbasis";

    /*Initialiseer missing values voor numerieke waarden*/
    /*Geaggregeerde waarden*/
    IF sal100_agg                       EQ . THEN sal100_agg                        = 0;                                                                                                                                                         
    IF primes_agg                       EQ . THEN primes_agg                        = 0;                                                                                                                                                            
    IF preavi_agg                       EQ . THEN preavi_agg                        = 0;                                                                                                                                                            
    IF salatt_agg                       EQ . THEN salatt_agg                        = 0;                                                                                                                                                            
    IF salfor_agg                       EQ . THEN salfor_agg                        = 0;                                                                                                                                                            
    IF mntded_agg                       EQ . THEN mntded_agg                        = 0;                                                                                                                                                            
    IF cotpat_agg                       EQ . THEN cotpat_agg                        = 0;                                                                                                                                                            
    IF cotper_agg                       EQ . THEN cotper_agg                        = 0;                                                                                                                                                            
    IF cotspe_agg                       EQ . THEN cotspe_agg                        = 0;                                                                                                                                                            
    IF DeductionAmount_agg_pers         EQ . THEN DeductionAmount_agg_pers          = 0;                                                                                                                                                            
    IF DeductionAmount_agg_pat          EQ . THEN DeductionAmount_agg_pat           = 0;                                                                                                                                                            
    IF mpecvac_agg                      EQ . THEN mpecvac_agg                       = 0;                                                                                                                                                            
    IF mcotdpv_agg                      EQ . THEN mcotdpv_agg                       = 0;                                                                                                                                                            
    IF jrsrem_f_agg                     EQ . THEN jrsrem_f_agg                      = 0;                                                                                                                                                            
    IF jrsrem_p_agg                     EQ . THEN jrsrem_p_agg                      = 0;                                                                                                                                                            
    IF jrspre_agg                       EQ . THEN jrspre_agg                        = 0;                                                                                                                                                            
    IF jrsvac_agg                       EQ . THEN jrsvac_agg                        = 0;                                                                                                                                                            
    IF jrsasm_agg                       EQ . THEN jrsasm_agg                        = 0;
    /*Niet geaggregeerde waarden*/
    IF codtra_20084                     EQ . THEN codtra_20084                      = 0;
    IF clatra_20084                     EQ . THEN clatra_20084                      = 0;                                                                                                                                                  
    IF codasm_20084                     EQ . THEN codasm_20084                      = 0;                                                                                                                                                  
    IF saljrs_20084                     EQ . THEN saljrs_20084                      = 0;                                                                                                                                                  
    IF tauxpt_20084                     EQ . THEN tauxpt_20084                      = 0;                                                                                                                                                  
    IF tauxsa_20084                     EQ . THEN tauxsa_20084                      = 0;                                                                                                                                                  
    IF tauxaa_20084                     EQ . THEN tauxaa_20084                      = 0;                                                                                                                                                  
    IF t_dnrb_20084                     EQ . THEN t_dnrb_20084                      = 0;                                                                                                                                                  
    IF maatman_20084                    EQ . THEN maatman_20084                     = 0;                                                                                                                                                  
    IF DeductionCode_20084              EQ . THEN DeductionCode_20084               = 0;                                                                                                                                                  
    IF DeductionCalculationBasis_20084  EQ . THEN DeductionCalculationBasis_20084   = 0;                                                                                                                                                  
    IF CATTRA_20084                     EQ . THEN CATTRA_20084                      = 0;   
    /*geconstrueerde bijdrage-verminderingen*/
    IF GROEP_VG                         EQ . THEN GROEP_VG                          = 0;
    IF DeductionCode_Pers_1             EQ . THEN DeductionCode_Pers_1              = 0;
    IF DeductionCode_Pat_1              EQ . THEN DeductionCode_Pat_1               = 0;
    IF DeductionCode_Pat_2              EQ . THEN DeductionCode_Pat_2               = 0;
    IF DeductionCode_Pat_3              EQ . THEN DeductionCode_Pat_3               = 0;
    /*Extra variabelen op jaarbasis*/
    /*vul missing values in of zet waarde op nul voor gevallen die niet meer aanwezig waren in kwartaal 4*/
    IF GeschatDubbelVakantieGeld_2008   EQ . THEN GeschatDubbelVakantieGeld_2008    = 0;
    IF heurpt_2008                      EQ . THEN heurpt_2008                       = 0;                                                                                
    IF jrsasm_2008                      EQ . THEN jrsasm_2008                       = 0;                                                                                
    IF jrsrem_f_2008                    EQ . THEN jrsrem_f_2008                     = 0;                                                                                
    IF jrsrem_p_2008                    EQ . THEN jrsrem_p_2008                     = 0;                                                                                
    IF GeschatEnkelVakantieGeld_2008    EQ . THEN GeschatEnkelVakantieGeld_2008     = 0;                                                                                
    IF saljrs_2008                      EQ . THEN saljrs_2008                       = 0;                                                                                
    IF SumSal_2008                      EQ . THEN SumSal_2008                       = 0;                                                                                
    IF RSZ_LABMSTAT_PRIV_2008           EQ . THEN RSZ_LABMSTAT_PRIV_2008            = 0;                                                                                
    IF RSZ_LABMSTAT_PUB_2008            EQ . THEN RSZ_LABMSTAT_PUB_2008             = 0;                                                                                
    IF RSZ_Full_2008                    EQ . THEN RSZ_Full_2008                     = 0;                                                                                
    IF RSZ_Part_2008                    EQ . THEN RSZ_Part_2008                     = 0;                                                                                

    /*Maak extra variabele aan voor bepaling ficitief inkomen bij berekening vakantiegeld (principes gedeeltelijk gebaseerd op nota notie inkomensconcept DWH AM&SB*/
    RATE_FICTIF_RSZ = 0;
    IF tauxsa_20084 NE 0 THEN RATE_FICTIF_RSZ = (tauxaa_20084/tauxsa_20084)-1;
    /*gebruik omweg om suggestie Peter Vets in mail 18 juli 2011 op te vangen (we beschikken niet over tauxaa op jaarbasis)*/
    IF RATE_FICTIF_RSZ EQ 0 AND ((jrsrem_f_2008 + jrsrem_p_2008) NE 0) THEN RATE_FICTIF_RSZ = ((jrsrem_f_2008 + jrsrem_p_2008 + jrsasm_2008)/(jrsrem_f_2008 + jrsrem_p_2008))-1;
    /*Corrigeer gevallen met een negatieve rate: niet getest of die voorkomen*/
    IF RATE_FICTIF_RSZ LT 0 THEN RATE_FICTIF_RSZ = 0;
    /*corrigeer rate fictif voor gevallen waar je vermoedelijk een te hoog ficitief loon zou toekennen*/
    /*Vergelijk dagloon maal gelijkgestelde dagen met fictief bedrag*/
    /*We hebben niet alle componenten om een correcte vermindering te doen van SumSal_2008: is dus een benadering*/
    IF (RATE_FICTIF_RSZ*(SumSal_2008-primes_agg-preavi_agg-salfor_agg)) GT (saljrs_2008*jrsasm_2008) THEN DO;
        IF (RATE_FICTIF_RSZ*(SumSal_2008-primes_agg-preavi_agg-salfor_agg)) NE 0 THEN DO;
            RATE_FICTIF_RSZ = (saljrs_2008*jrsasm_2008)/(RATE_FICTIF_RSZ*(SumSal_2008-primes_agg-preavi_agg-salfor_agg));
        END;
        ELSE DO;
            RATE_FICTIF_RSZ = 0;
        END;
    END;        
    /*Corrigeer tenslotte voor outliers*/
    /*Mean (tauxaa_20084/tauxsa_20084)-1 = 0.1110663 en Std (tauxaa_20084/tauxsa_20084)-1 = 1.4026579*/
    /*IF tauxsa_20084 EQ 0 AND RATE_FICTIF_RSZ GT 0.1110663 + 2*1.4026579 THEN RATE_FICTIF_RSZ = 0.1110663 + 2*1.4026579; */
    /*Gebruik maximale redelijke waarde*/
    /*Veronderstelling is dat je maximaal n volledig kwartaal kan omzetten in fictieve arbeidsvergoedingen*/
    IF tauxsa_20084 EQ 0 AND RATE_FICTIF_RSZ GT 65 THEN RATE_FICTIF_RSZ = 65;
    
    LABEL RATE_FICTIF_RSZ         = "Fractie die gebruikt zal worden om het fictief inkomen te bepalen bij de eventuele berekening van het vakantiegeld";

RUN;
PROC MEANS DATA=MIM2008_RSZ(WHERE=(InRSZ =1));
    TITLE "Fractie die gebruikt zal worden om het fictief inkomen te bepalen bij de eventuele berekening van het vakantiegeld";
    VAR RATE_FICTIF_RSZ;
RUN;
PROC MEANS DATA=MIM2008_RSZ(WHERE=(saljrs_20084>0));
    TITLE "Gemiddelde voor gevallen met positief uurloon in 4de kwartaal";
    VAR sal100_agg saljrs_20084;
RUN;
PROC MEANS DATA=MIM2008_RSZ(WHERE=(saljrs_20084=0 AND InRSZ=1));
    TITLE "Gemiddelde voor gevallen zonder uurloon in 4de kwartaal";
    VAR saljrs_2008;
RUN;
PROC MEANS DATA=MIM2008_RSZ(WHERE=(saljrs_20084=0 AND saljrs_2008 = 0 AND InRSZ=1));
    TITLE "Gemiddelde voor gevallen zonder uurloon in 4de kwartaal";
    VAR saljrs_2008;
RUN;
PROC FREQ DATA=MIM2008_RSZ;
    TITLE "Aantal individuen geselecteerd uit RSZ bestand";
    TABLES InRSZ;
RUN;
PROC FREQ DATA=MIM2008_RSZ(WHERE=(DeductionCode_Pat_1 <> 0 AND DeductionCode_Pat_1 = DeductionCode_Pat_2));
    TITLE "Gevallen met eerste en twee code bijdragevermindering werkgever gelijk";
    TABLES DeductionCode_Pat_2;
RUN;
PROC FREQ DATA=MIM2008_RSZ(WHERE=(DeductionCode_Pat_1 <> 0 AND DeductionCode_Pat_1 = DeductionCode_Pat_3));
    TITLE "Gevallen met eerste en derde code bijdragevermindering werkgever gelijk";
    TABLES DeductionCode_Pat_2;
RUN;
PROC FREQ DATA=MIM2008_RSZ(WHERE=(DeductionCode_Pat_2 <> 0 AND DeductionCode_Pat_2 = DeductionCode_Pat_3));
    TITLE "Gevallen met tweede en derde code bijdragevermindering werkgever gelijk";
    TABLES DeductionCode_Pat_2;
RUN;
PROC FREQ DATA=MIM2008_RSZ;
    TITLE "Codes persoonlijke en patronale bijdragevermindering";
    TABLES DeductionCode_20084 DeductionCode_Pers_1 DeductionCode_Pat_1 DeductionCode_Pat_2 DeductionCode_Pat_3;
RUN;
/*Bereken verhouding verminderingen*/
DATA REDUC;

    SET MIM2008_RSZ(WHERE=(InRSZ =1));

    /*Verhouding bijdragen en bijdragenverminderingen*/
    REDRATE_PAT = 0;
    IF (cotpat_agg) NE 0 THEN REDRATE_PAT = 100*(DeductionAmount_agg_pat)/(cotpat_agg); 
    REDRATE_PERS = 0;
    IF (cotper_agg) NE 0 THEN REDRATE_PERS = 100*(DeductionAmount_agg_pers)/(cotper_agg); 

RUN;
PROC MEANS DATA=REDUC VARDEF=WEIGHT;
    TITLE "Verhouding bijdrageverminderingen versus bijdragen: RSZ";
    VAR REDRATE_PAT REDRATE_PERS;
    WEIGHT MIMOSIS_WEIGHT;
RUN;    
PROC UNIVARIATE DATA=REDUC;
    TITLE "Univariate verdeling procentuele bijdragevermindering";
    VAR REDRATE_PAT REDRATE_PERS;
    WEIGHT MIMOSIS_WEIGHT;
RUN;
/*Aanmaak percentielwaarden voor latere plot*/
PROC UNIVARIATE DATA=REDUC NOPRINT;
    VAR REDRATE_PAT REDRATE_PERS;
    WEIGHT MIMOSIS_WEIGHT;
    OUTPUT 
    OUT=PCTLPT
    PCTLPTS = 1 TO 100 BY 1
    PCTLPRE = PPAT PPERS
    ;
RUN;
PROC TRANSPOSE DATA=PCTLPT OUT=PCTLPT_TRANS;
    VAR PPAT1-PPAT100 PPERS1-PPERS100;
RUN;    
PROC PRINT DATA=PCTLPT_TRANS;
    TITLE "Univariate verdeling procentuele bijdragevermindering";
RUN;
/*Output histogram-waarden voor aanmaak latere grafieken*/
PROC UNIVARIATE DATA=REDUC NOPRINT;
    TITLE "Univariate verdeling procentuele bijdragevermindering";
    VAR REDRATE_PAT REDRATE_PERS;
    HISTOGRAM REDRATE_PAT REDRATE_PERS /    ENDPOINTS = 0 TO 100 BY 1
                                            OUTHIST = OutputHisto;
RUN;
PROC PRINT DATA=OutputHisto;
    TITLE "Histogram procentuele bijdragevermindering";
RUN;
/*Kernels bijdrageverminderingen*/
PROC KDE DATA=REDUC;
    UNIVAR REDRATE_PAT /  GRIDL=0 GRIDU=100 NG=100 OUT=KERNEL_OUT1;
    WEIGHT MIMOSIS_WEIGHT;
RUN;
PROC PRINT DATA=KERNEL_OUT1;
    TITLE "Kernel procentuele bijdragevermindering: werkgevers";
RUN;
PROC KDE DATA=REDUC;
    UNIVAR REDRATE_PERS /  GRIDL=0 GRIDU=100 NG=100 OUT=KERNEL_OUT2;
    WEIGHT MIMOSIS_WEIGHT;
RUN;
PROC PRINT DATA=KERNEL_OUT2;
    TITLE "Kernel procentuele bijdragevermindering: werknemers";
RUN;
/*Breng gegevens op niveau totale populatie*/
DATA LIBW.MIM2008_RSZ;
    SET MIM2008_RSZ;
    DROP MIMOSIS_WEIGHT;
RUN;    
PROC CONTENTS DATA=LIBW.MIM2008_RSZ;
RUN;
ods listing close;
ods pdf File = "C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSZ_Plots.pdf";
PROC UNIVARIATE DATA=REDUC;
    TITLE "Univariate verdeling procentuele bijdragevermindering";
    VAR REDRATE_PAT REDRATE_PERS;
    HISTOGRAM REDRATE_PAT REDRATE_PERS;
RUN;
ods pdf close;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
