/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens RSZPPO
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSZPPO_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSZPPO.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ MIMOSIS_WEIGHT);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA RSZPPO_BASIS;
    SET LIB.mim2008_rszppoquart_code;

    /*schrap lijnen die niet moeten weerhouden worden volgens +/- de DOCDWH regels*/
    IF (sal100_20084+primes_20084+preavi_20084)<0 THEN DELETE;

    /*Construeer variabelen vakantiegeld*/
    /*We wijken hier af van de regel gevolgd voor de RSZ en definiren zowel een groep enkel als dubbel vakantiegeld*/

    /*Definieer groepen bepaling enkel vakantiegeld*/
    GROEP_EV = 0;
    IF codtra_20084 EQ 741                          THEN GROEP_EV = 1; 
    IF codtra_20084 IN (601, 602, 603, 604, 642)    THEN GROEP_EV = 2; 
    IF codtra_20084 IN (731, 732)                   THEN GROEP_EV = 4; 
    IF codtra_20084 IN (701, 702)                   THEN GROEP_EV = 5; 
    IF GROEP_EV EQ 0                                THEN GROEP_EV = 3;

    /*Definieer groepen bepaling dubbel vakantiegeld*/
    GROEP_DV = 0;
    IF Cattra_20084 EQ 951 THEN GROEP_DV = 1; 
    IF Cattra_20084 NE 951 THEN GROEP_DV = 2; 

    /*hernoem waarde I r_exclus voor sortering*/
    IF TRIM(r_exclus_20084) EQ "I" THEN r_exclus_20084 = "Z";
    
RUN;  
/*Tel r_exclus gevallen*/
PROC FREQ DATA=RSZPPO_BASIS;
    TITLE "Verdeling r_exclus in basisbestand na hernoeming waarde I en vakantiegeldregimes";
    TABLES r_exclus_20084 GROEP_EV GROEP_DV;
RUN;    
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv, COUNT(DISTINCT CATTRA_20084) AS NUM_CATTRA, COUNT(DISTINCT CODTRA_20084) AS NUM_CODTRA, COUNT(DISTINCT clatr2Apl_20084) AS NUM_clatr2Apl
    FROM RSZPPO_BASIS
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende Cattra codes";
    TABLES NUM_CATTRA;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende Codtra codes";
    TABLES NUM_CODTRA;
RUN;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt met verschillende Clatr2 codes";
    TABLES NUM_clatr2Apl;
RUN;
/*Tel gevallen met bijdragevermindering*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Pers
    FROM RSZPPO_BASIS
    WHERE mntdedocc_20084 > 0
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand met een waarde persoonlijke bijdragevermindering";
    TABLES NUM_Pers;
RUN;
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Pat
    FROM RSZPPO_BASIS
    WHERE mntdedwr_20084 > 0
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand met een waarde patronale bijdragevermindering";
    TABLES NUM_Pat;
RUN;
/*Reduceer gegevens tot n lijn per individu*/
PROC SORT DATA=RSZPPO_BASIS;
    BY
    GECODEERD_INSZ
    r_exclus_20084
    sal100_20084                                                                                 
    saljrs_20084                                                                                 
    salcot_20084                                                                                 
    primes_20084                                                                                 
    vehsoc_20084                                                                                 
    cotpat_20084                                                                                 
    cotper_20084                                                                                 
    mntdedwr_20084                                                                               
    mntdedocc_20084                                                                              
    days_pc1_20084                                                                               
    hrs_pc1_20084                                                                                
    days_pc10_20084                                                                              
    hrs_pc10_20084                                                                               
    days_pc21_20084                                                                              
    hrs_pc21_20084                                                                               
    ;
RUN;
DATA RSZPPO;
    SET RSZPPO_BASIS;
    BY
    GECODEERD_INSZ
    r_exclus_20084
    sal100_20084                                                                                 
    saljrs_20084                                                                                 
    salcot_20084                                                                                 
    primes_20084                                                                                 
    vehsoc_20084                                                                                 
    cotpat_20084                                                                                 
    cotper_20084                                                                                 
    mntdedwr_20084                                                                               
    mntdedocc_20084                                                                              
    days_pc1_20084                                                                               
    hrs_pc1_20084                                                                                
    days_pc10_20084                                                                              
    hrs_pc10_20084                                                                               
    days_pc21_20084                                                                              
    hrs_pc21_20084                                                                               
    ;

    RETAIN
    sal100_agg                                                                                 
    salcot_agg                                                                                 
    primes_agg                                                                                 
    vehsoc_agg                                                                                 
    cotpat_agg                                                                                 
    cotper_agg                                                                                 
    mntdedwr_agg                                                                               
    mntdedocc_agg                                                                              
    days_pc1_agg                                                                               
    hrs_pc1_agg                                                                                
    days_pc10_agg                                                                              
    hrs_pc10_agg                                                                               
    days_pc21_agg                                                                              
    hrs_pc21_agg                                                                               
    0
    ;

    IF FIRST.GECODEERD_INSZ THEN DO;
        /*Initialiseer variabelen die geaggregeerd worden*/
        sal100_agg     = 0;
        salcot_agg     = 0;
        primes_agg     = 0;
        vehsoc_agg     = 0;
        cotpat_agg     = 0;
        cotper_agg     = 0;
        mntdedwr_agg   = 0;
        mntdedocc_agg  = 0;
        days_pc1_agg   = 0;
        hrs_pc1_agg    = 0;
        days_pc10_agg  = 0;
        hrs_pc10_agg   = 0;
        days_pc21_agg  = 0;
        hrs_pc21_agg   = 0;
        /*Zet waarde indien basisgegeven niet missing is*/
        IF sal100_20084     NE . THEN sal100_agg       = sal100_20084   ;
        IF salcot_20084     NE . THEN salcot_agg       = salcot_20084   ;   
        IF primes_20084     NE . THEN primes_agg       = primes_20084   ;
        IF vehsoc_20084     NE . THEN vehsoc_agg       = vehsoc_20084   ;
        IF cotpat_20084     NE . THEN cotpat_agg       = cotpat_20084   ;
        IF cotper_20084     NE . THEN cotper_agg       = cotper_20084   ;
        IF mntdedwr_20084   NE . THEN mntdedwr_agg     = mntdedwr_20084 ;
        IF mntdedocc_20084  NE . THEN mntdedocc_agg    = mntdedocc_20084;
        IF days_pc1_20084   NE . THEN days_pc1_agg     = days_pc1_20084 ;
        IF hrs_pc1_20084    NE . THEN hrs_pc1_agg      = hrs_pc1_20084  ;
        IF days_pc10_20084  NE . THEN days_pc10_agg    = days_pc10_20084;
        IF hrs_pc10_20084   NE . THEN hrs_pc10_agg     = hrs_pc10_20084 ;
        IF days_pc21_20084  NE . THEN days_pc21_agg    = days_pc21_20084;
        IF hrs_pc21_20084   NE . THEN hrs_pc21_agg     = hrs_pc21_20084 ;
    END;
    ELSE DO;
        /*Tel andere waarden er bij op*/
        IF sal100_20084    NE . THEN sal100_agg     = sal100_agg     + sal100_20084   ;
        IF salcot_20084    NE . THEN salcot_agg     = salcot_agg     + salcot_20084   ;   
        IF primes_20084    NE . THEN primes_agg     = primes_agg     + primes_20084   ;
        IF vehsoc_20084    NE . THEN vehsoc_agg     = vehsoc_agg     + vehsoc_20084   ;
        IF cotpat_20084    NE . THEN cotpat_agg     = cotpat_agg     + cotpat_20084   ;
        IF cotper_20084    NE . THEN cotper_agg     = cotper_agg     + cotper_20084   ;
        IF mntdedwr_20084  NE . THEN mntdedwr_agg   = mntdedwr_agg   + mntdedwr_20084 ;
        IF mntdedocc_20084 NE . THEN mntdedocc_agg  = mntdedocc_agg  + mntdedocc_20084;
        IF days_pc1_20084  NE . THEN days_pc1_agg   = days_pc1_agg   + days_pc1_20084 ;
        IF hrs_pc1_20084   NE . THEN hrs_pc1_agg    = hrs_pc1_agg    + hrs_pc1_20084  ;
        IF days_pc10_20084 NE . THEN days_pc10_agg  = days_pc10_agg  + days_pc10_20084;
        IF hrs_pc10_20084  NE . THEN hrs_pc10_agg   = hrs_pc10_agg   + hrs_pc10_20084 ;
        IF days_pc21_20084 NE . THEN days_pc21_agg  = days_pc21_agg  + days_pc21_20084;
        IF hrs_pc21_20084  NE . THEN hrs_pc21_agg   = hrs_pc21_agg   + hrs_pc21_20084 ;
    END;

    DROP
    sal100_20084   
    salcot_20084   
    primes_20084   
    vehsoc_20084   
    cotpat_20084   
    cotper_20084   
    mntdedwr_20084 
    mntdedocc_20084
    days_pc1_20084 
    hrs_pc1_20084  
    days_pc10_20084
    hrs_pc10_20084 
    days_pc21_20084
    hrs_pc21_20084 
    ;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;

RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RSZPPO
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na reductie";
    TABLES NUM_Indiv;
RUN;
/*Maak code vermindering werknemers-bijdrageverminderingen*/
DATA CODE_BASIS;
    SET RSZPPO_BASIS(KEEP=GECODEERD_INSZ mntdedocc_20084 sal100_20084);

    DeductionCode_Pers_1 = 0;
    IF mntdedocc_20084 > 0 THEN DeductionCode_Pers_1 = 1;

RUN;
PROC SORT DATA=CODE_BASIS;
    BY GECODEERD_INSZ DeductionCode_Pers_1;
RUN;
DATA CODE_PERS1;
    SET CODE_BASIS;
    BY GECODEERD_INSZ DeductionCode_Pers_1;
    
    KEEP GECODEERD_INSZ DeductionCode_Pers_1;

    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;
PROC FREQ DATA=CODE_PERS1;
    TITLE "Eerste reductiecode persoonlijke bijdrageverminderingen";
    TABLES DeductionCode_Pers_1;
RUN;    
/*Voeg onderdelen samen tot n bestand*/
PROC SORT DATA=CODE_PERS1;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=LIB.mim2008_rszppoyear_2008_code;
    BY GECODEERD_INSZ;
RUN;
PROC SORT DATA=LIB.mim2008_labmstatrszppo_2008_code;
    BY GECODEERD_INSZ;
RUN;
/*Breng gegevens op niveau totale populatie*/
DATA MIM2008_RSZPPO;
    MERGE TOTPOP(in=InA) RSZPPO(in=InB) CODE_PERS1 LIB.mim2008_rszppoyear_2008_code(in=InC) LIB.mim2008_labmstatrszppo_2008_code;
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InRSZPPO = 0;
    IF InB EQ 1                 THEN InRSZPPO = 1;
    IF InB EQ 0 AND InC EQ 1    THEN InRSZPPO = 2;
    LABEL InRSZPPO = "Individu geselecteerd uit basisdata RSZPPO voor verwerking steekproef";

    /*Geaggregeerde waarden*/
    LABEL sal100_agg            = "Bedrag van de gewone bezoldiging in het kwartaal. (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                                
    LABEL salcot_agg            = "Bedrag van de bijdrageplichtige loonmassa inzake sociale zekerheid in het kwartaal (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                
    LABEL primes_agg            = "Het bedrag van de bezoldigingen in het kwartaal die niet rechtstreeks verbonden zijn met de prestaties gedurende een bepaald kwartaal. (aggregaat op kwartaalbasis)";                                                                                                                                                            
    LABEL vehsoc_agg            = "Voordeel betreffende het individueel en persoonlijk gebruik van een voertuig ter beschikking gesteld door een werkgever (aggregaat op kwartaalbasis)";                                                                                                                                                                           
    LABEL cotpat_agg            = "Patronale bijdragen Sociale Zekerheid (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                                             
    LABEL cotper_agg            = "Persoonlijke bijdragen Sociale Zekerheid (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                                          
    LABEL mntdedwr_agg          = "Bedrag bijdragevermindering werkgever (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                                             
    LABEL mntdedocc_agg         = "Bedrag bijdragevermindering werknemer (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                                             
    LABEL days_pc1_agg          = "Aantal gepresteerde dagen met prestatiecodes 1, 2 en 301: (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                          
    LABEL hrs_pc1_agg           = "Aantal gepresteerde uren met prestatiecodes 1, 2 en 301: (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                          
    LABEL days_pc10_agg         = "Aantal gepresteerde dagen met prestatiecodes 10, 11 en 13: (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                        
    LABEL hrs_pc10_agg          = "Aantal gepresteerde uren met prestatiecodes 10, 11 en 13: (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                         
    LABEL days_pc21_agg         = "Aantal gepresteerde dagen met prestatiecodes 21, 22, 24 en 25: (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                    
    LABEL hrs_pc21_agg          = "Aantal gepresteerde uren met prestatiecodes 21, 22, 24 en 25: (aggregaat op kwartaalbasis)";                                                                                                                                                                                                                                     
    /*geconstrueerde bijdrage-verminderingen*/
    LABEL GROEP_EV              = "Groep bepaling enkel vakantiegeld";
    LABEL GROEP_DV              = "Groep bepaling dubbel vakantiegeld";
    LABEL DeductionCode_Pers_1  = "Verminderingscode persoonlijke bijdragevermindering";
    /*Extra variabelen op jaarbasis*/
    LABEL RSZPPO_Full_2008      = "Aantal dagen voltijds op jaarbasis";
    LABEL RSZPPO_Part_2008      = "Aantal dagen deeltijds op jaarbasis";

    /*Initialiseer missing values voor numerieke waarden*/
    /*Geaggregeerde waarden*/
    IF sal100_agg                 EQ . THEN sal100_agg                  = 0;                                                                                                                                                         
    IF salcot_agg                 EQ . THEN salcot_agg                  = 0;                                                                                                                                                            
    IF primes_agg                 EQ . THEN primes_agg                  = 0;                                                                                                                                                            
    IF vehsoc_agg                 EQ . THEN vehsoc_agg                  = 0;                                                                                                                                                            
    IF cotpat_agg                 EQ . THEN cotpat_agg                  = 0;                                                                                                                                                            
    IF cotper_agg                 EQ . THEN cotper_agg                  = 0;                                                                                                                                                            
    IF mntdedwr_agg               EQ . THEN mntdedwr_agg                = 0;                                                                                                                                                            
    IF mntdedocc_agg              EQ . THEN mntdedocc_agg               = 0;                                                                                                                                                            
    IF days_pc1_agg               EQ . THEN days_pc1_agg                = 0;                                                                                                                                                            
    IF hrs_pc1_agg                EQ . THEN hrs_pc1_agg                 = 0;                                                                                                                                                            
    IF days_pc10_agg              EQ . THEN days_pc10_agg               = 0;                                                                                                                                                            
    IF hrs_pc10_agg               EQ . THEN hrs_pc10_agg                = 0;                                                                                                                                                            
    IF days_pc21_agg              EQ . THEN days_pc21_agg               = 0;                                                                                                                                                            
    IF hrs_pc21_agg               EQ . THEN hrs_pc21_agg                = 0;                                                                                                                                                            
    /*Niet geaggregeerde waarden*/
    IF cattra_20084               EQ . THEN cattra_20084                = 0;
    IF codimp_20084               EQ . THEN codimp_20084                = 0;                                                                                                                                                  
    IF codtra_20084               EQ . THEN codtra_20084                = 0;                                                                                                                                                  
    IF clatraApl_20084            EQ . THEN clatraApl_20084             = 0;                                                                                                                                                  
    IF apltauxpt_20084            EQ . THEN apltauxpt_20084             = 0;                                                                                                                                                  
    IF eqtpsp_paid_20084          EQ . THEN eqtpsp_paid_20084           = 0;                                                                                                                                                  
    IF eqtpsp_similar_20084       EQ . THEN eqtpsp_similar_20084        = 0;                                                                                                                                                  
    IF tauxaa_20084               EQ . THEN tauxaa_20084                = 0;                                                                                                                                                  
    IF maatman_20084              EQ . THEN maatman_20084               = 0;                                                                                                                                                  
    IF MeanWorkingHours_20084     EQ . THEN MeanWorkingHours_20084      = 0;                                                                                                                                                  
    IF RefMeanWorkingHours_20084  EQ . THEN RefMeanWorkingHours_20084   = 0;                                                                                                                                                  
    IF regime_20084               EQ . THEN regime_20084                = 0;                                                                                                                                                  
    IF rembase_20084              EQ . THEN rembase_20084               = 0;                                                                                                                                                  
    IF preavi_20084               EQ . THEN preavi_20084                = 0;                                                                                                                                                  
    IF saljrs_20084               EQ . THEN saljrs_20084                = 0;                                                                                                                                                  
    IF Maribel_20084              EQ . THEN Maribel_20084               = 0;                                                                                                                                                  
    IF STremAmt_20084             EQ . THEN STremAmt_20084              = 0;                                                                                                                                                  
    IF STndays_20084              EQ . THEN STndays_20084               = 0;                                                                                                                                                  
    IF STctrAmt_20084             EQ . THEN STctrAmt_20084              = 0;                                                                                                                                                  
    IF matric_20084               EQ . THEN matric_20084                = 0;                                                                                                                                                  
    /*geconstrueerde bijdrage-verminderingen*/
    IF GROEP_EV                   EQ . THEN GROEP_EV                    = 0;
    IF GROEP_DV                   EQ . THEN GROEP_DV                    = 0;
    IF DeductionCode_Pers_1       EQ . THEN DeductionCode_Pers_1        = 0;
    /*Extra variabelen op jaarbasis*/
    /*vul missing values in of zet waarde op nul voor gevallen die niet meer aanwezig waren in kwartaal 4*/
    IF GeschatDubbelVakantieGeld_2008   EQ . THEN GeschatDubbelVakantieGeld_2008    = 0;
    IF RemunDay_2008                    EQ . THEN RemunDay_2008                     = 0;                                                                                
    IF AssimDay_2008                    EQ . THEN AssimDay_2008                     = 0;                                                                                
    IF RemunHour_2008                   EQ . THEN RemunHour_2008                    = 0;                                                                                
    IF AssimHour_2008                   EQ . THEN AssimHour_2008                    = 0;                                                                                
    IF saljrs_2008                      EQ . THEN saljrs_2008                       = 0;                                                                                
    IF SumSal_2008                      EQ . THEN SumSal_2008                       = 0;                                                                                
    IF RSZPPO_LABMSTAT_PUB_2008         EQ . THEN RSZPPO_LABMSTAT_PUB_2008          = 0;                                                                                
    IF RSZPPO_Full_2008                 EQ . THEN RSZPPO_Full_2008                  = 0;                                                                                
    IF RSZPPO_Part_2008                 EQ . THEN RSZPPO_Part_2008                  = 0;                                                                                

RUN;
/*Rename variables naar unieke RSZPPO naam*/
DATA MIM2008_RSZPPO;

    SET MIM2008_RSZPPO;

    RENAME cattra_20084                   = APL_cattra_20084                  ;
    RENAME codimp_20084                   = APL_codimp_20084                  ;
    RENAME codtra_20084                   = APL_codtra_20084                  ;
    RENAME t_prest_20084                  = APL_t_prest_20084                 ;
    RENAME eqtpsp_paid_20084              = APL_eqtpsp_paid_20084             ;
    RENAME eqtpsp_similar_20084           = APL_eqtpsp_similar_20084          ;
    RENAME tauxaa_20084                   = APL_tauxaa_20084                  ;
    RENAME t_dnrb_20084                   = APL_t_dnrb_20084                  ;
    RENAME r_exclus_20084                 = APL_r_exclus_20084                ;
    RENAME maatman_20084                  = APL_maatman_20084                 ;
    RENAME MeanWorkingHours_20084         = APL_MeanWorkingHours_20084        ;
    RENAME RefMeanWorkingHours_20084      = APL_RefMeanWorkingHours_20084     ;
    RENAME regime_20084                   = APL_regime_20084                  ;
    RENAME rembase_20084                  = APL_rembase_20084                 ;
    RENAME preavi_20084                   = APL_preavi_20084                  ;
    RENAME saljrs_20084                   = APL_saljrs_20084                  ;
    RENAME Maribel_20084                  = APL_Maribel_20084                 ;
    RENAME STremAmt_20084                 = APL_STremAmt_20084                ;
    RENAME STndays_20084                  = APL_STndays_20084                 ;
    RENAME STctrAmt_20084                 = APL_STctrAmt_20084                ;
    RENAME matric_20084                   = APL_matric_20084                  ;
    RENAME GROEP_EV                       = APL_GROEP_EV                      ;
    RENAME GROEP_DV                       = APL_GROEP_DV                      ;
    RENAME sal100_agg                     = APL_sal100_agg                    ;
    RENAME salcot_agg                     = APL_salcot_agg                    ;
    RENAME primes_agg                     = APL_primes_agg                    ;
    RENAME vehsoc_agg                     = APL_vehsoc_agg                    ;
    RENAME cotpat_agg                     = APL_cotpat_agg                    ;
    RENAME cotper_agg                     = APL_cotper_agg                    ;
    RENAME mntdedwr_agg                   = APL_mntdedwr_agg                  ;
    RENAME mntdedocc_agg                  = APL_mntdedocc_agg                 ;
    RENAME days_pc1_agg                   = APL_days_pc1_agg                  ;
    RENAME hrs_pc1_agg                    = APL_hrs_pc1_agg                   ;
    RENAME days_pc10_agg                  = APL_days_pc10_agg                 ;
    RENAME hrs_pc10_agg                   = APL_hrs_pc10_agg                  ;
    RENAME days_pc21_agg                  = APL_days_pc21_agg                 ;
    RENAME hrs_pc21_agg                   = APL_hrs_pc21_agg                  ;
    RENAME DeductionCode_Pers_1           = APL_DeductionCode_Pers_1          ;
    RENAME GeschatDubbelVakantieGeld_2008 = APL_GeschatDubbelVakGeld_2008     ;
    RENAME RemunDay_2008                  = APL_RemunDay_2008                 ;
    RENAME AssimDay_2008                  = APL_AssimDay_2008                 ;
    RENAME RemunHour_2008                 = APL_RemunHour_2008                ;
    RENAME AssimHour_2008                 = APL_AssimHour_2008                ;
    RENAME saljrs_2008                    = APL_saljrs_2008                   ;
    RENAME SumSal_2008                    = APL_SumSal_2008                   ;

RUN;
/*Maak nog extra variabele RATE_FICTIF aan*/
DATA MIM2008_RSZPPO;

    SET MIM2008_RSZPPO;

    /*Maak extra variabele aan voor bepaling ficitief inkomen bij berekening vakantiegeld (principes gedeeltelijk gebaseerd op nota notie inkomensconcept DWH AM&SB*/
    RATE_FICTIF_RSZPPO = 0;
    IF APL_eqtpsp_paid_20084 NE 0 THEN RATE_FICTIF_RSZPPO = (APL_tauxaa_20084/APL_eqtpsp_paid_20084)-1;
    /*gebruik omweg om suggestie Peter Vets in mail 18 juli 2011 op te vangen (we beschikken niet over tauxaa op jaarbasis)*/
    IF RATE_FICTIF_RSZPPO EQ 0 AND APL_RemunDay_2008 NE 0 THEN RATE_FICTIF_RSZPPO = ((APL_RemunDay_2008 + APL_AssimDay_2008)/(APL_RemunDay_2008))-1;
    /*Corrigeer gevallen met een negatieve rate: niet getest of die voorkomen*/
    IF RATE_FICTIF_RSZPPO LT 0 THEN RATE_FICTIF_RSZPPO = 0;
    /*corrigeer rate fictif voor gevallen waar je vermoedelijk een te hoog ficitief loon zou toekennen*/
    /*Vergelijk dagloon maal gelijkgestelde dagen met fictief bedrag*/
    /*We hebben niet alle componenten om een correcte vermindering te doen van SumSal_2008: is dus een benadering*/
    IF (RATE_FICTIF_RSZPPO*(APL_SumSal_2008-APL_primes_agg)) GT (APL_saljrs_2008*APL_AssimDay_2008) THEN DO;
        IF (RATE_FICTIF_RSZPPO*(APL_SumSal_2008-APL_primes_agg)) NE 0 THEN DO;
            RATE_FICTIF_RSZPPO = (APL_saljrs_2008*APL_AssimDay_2008)/(RATE_FICTIF_RSZPPO*(APL_SumSal_2008-APL_primes_agg));
        END;
        ELSE DO;
            RATE_FICTIF_RSZPPO = 0;
        END;
    END;        
    /*Corrigeer tenslotte voor outliers voor gevallen die niet op standaardregel gebaseerd zijn*/
    /*Mean (APL_tauxaa_20084/APL_eqtpsp_paid_20084)-1 = 0.0097753 en Std (APL_tauxaa_20084/APL_eqtpsp_paid_20084)-1 = 0.1070994*/
    /*IF APL_eqtpsp_paid_20084 EQ 0 AND RATE_FICTIF_RSZPPO GT 0.0097753 + 2*0.1070994 THEN RATE_FICTIF_RSZPPO = 0.0097753 + 2*0.1070994;*/
    /*Gebruik maximale redelijke waarde*/
    /*Veronderstelling is dat je maximaal n volledig kwartaal kan omzetten in fictieve arbeidsvergoedingen*/
    IF APL_eqtpsp_paid_20084 EQ 0 AND RATE_FICTIF_RSZPPO GT 65 THEN RATE_FICTIF_RSZPPO = 65;

    LABEL RATE_FICTIF_RSZPPO         = "Fractie die gebruikt zal worden om het fictief inkomen te bepalen bij de eventuele berekening van het vakantiegeld";

RUN;
PROC MEANS DATA=MIM2008_RSZPPO(WHERE=(InRSZPPO =1));
    TITLE "Fractie die gebruikt zal worden om het fictief inkomen te bepalen bij de eventuele berekening van het vakantiegeld";
    VAR RATE_FICTIF_RSZPPO;
RUN;
PROC MEANS DATA=MIM2008_RSZPPO(WHERE=(APL_saljrs_20084>0));
    VAR APL_sal100_agg APL_saljrs_20084;
RUN;
PROC FREQ DATA=MIM2008_RSZPPO;
    TITLE "Aantal individuen geselecteerd uit RSZPPO bestand";
    TABLES InRSZPPO;
RUN;
/*Bereken verhouding verminderingen*/
DATA REDUC;

    SET MIM2008_RSZPPO(WHERE=(InRSZPPO = 1));

    /*Verhouding bijdragen en bijdragenverminderingen*/
    REDRATE_PAT = 0;
    IF (APL_cotpat_agg) NE 0 THEN REDRATE_PAT = 100*(APL_mntdedwr_agg)/(APL_cotpat_agg); 
    REDRATE_PERS = 0;
    IF (APL_cotper_agg) NE 0 THEN REDRATE_PERS = 100*(APL_mntdedocc_agg)/(APL_cotper_agg); 

RUN;
PROC MEANS DATA=REDUC VARDEF=WEIGHT;
    TITLE "Verhouding bijdrageverminderingen versus bijdragen: RSZPPO";
    VAR REDRATE_PAT REDRATE_PERS;
    WEIGHT MIMOSIS_WEIGHT;
RUN;    
PROC UNIVARIATE DATA=REDUC;
    TITLE "Univariate verdeling procentuele bijdragevermindering";
    VAR REDRATE_PAT REDRATE_PERS;
    WEIGHT MIMOSIS_WEIGHT;
RUN;
/*Aanmaak percentielwaarden voor latere plot*/
PROC UNIVARIATE DATA=REDUC NOPRINT;
    VAR REDRATE_PAT REDRATE_PERS;
    WEIGHT MIMOSIS_WEIGHT;
    OUTPUT 
    OUT=PCTLPT
    PCTLPTS = 1 TO 100 BY 1
    PCTLPRE = PPAT PPERS
    ;
RUN;
PROC TRANSPOSE DATA=PCTLPT OUT=PCTLPT_TRANS;
    VAR PPAT1-PPAT100 PPERS1-PPERS100;
RUN;    
PROC PRINT DATA=PCTLPT_TRANS;
    TITLE "Univariate verdeling procentuele bijdragevermindering";
RUN;
/*Output histogram-waarden voor aanmaak latere grafieken*/
PROC UNIVARIATE DATA=REDUC NOPRINT;
    TITLE "Univariate verdeling procentuele bijdragevermindering";
    VAR REDRATE_PAT REDRATE_PERS;
    HISTOGRAM REDRATE_PAT REDRATE_PERS /    ENDPOINTS = 0 TO 100 BY 1
                                            OUTHIST = OutputHisto;
RUN;
PROC PRINT DATA=OutputHisto;
    TITLE "Histogram procentuele bijdragevermindering";
RUN;
/*Kernels bijdrageverminderingen*/
PROC KDE DATA=REDUC;
    UNIVAR REDRATE_PAT /  GRIDL=0 GRIDU=100 NG=100 OUT=KERNEL_OUT1;
    WEIGHT MIMOSIS_WEIGHT;
RUN;
PROC PRINT DATA=KERNEL_OUT1;
    TITLE "Kernel procentuele bijdragevermindering: werkgevers";
RUN;
PROC KDE DATA=REDUC;
    UNIVAR REDRATE_PERS /  GRIDL=0 GRIDU=100 NG=100 OUT=KERNEL_OUT2;
    WEIGHT MIMOSIS_WEIGHT;
RUN;
PROC PRINT DATA=KERNEL_OUT2;
    TITLE "Kernel procentuele bijdragevermindering: werknemers";
RUN;
/*Maak finaal bestand aan*/
DATA LIBW.MIM2008_RSZPPO;

    SET MIM2008_RSZPPO;
    DROP MIMOSIS_WEIGHT;
RUN;    
PROC CONTENTS DATA=LIBW.MIM2008_RSZPPO;
RUN;
ods listing close;
ods pdf File = "C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRSZPPO_Plots.pdf";
PROC UNIVARIATE DATA=REDUC;
    TITLE "Univariate verdeling procentuele bijdragevermindering";
    VAR REDRATE_PAT REDRATE_PERS;
    HISTOGRAM REDRATE_PAT REDRATE_PERS;
RUN;
ods pdf close;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
