/*
Programma maakt input-variabelen mimosis aan 
    op basis van gegevens RVA
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRVA_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateRVA.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ MIMOSIS_WEIGHT);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
DATA RVA;
    SET LIB.mim2008_rva_code;
RUN;  
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RVA
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand";
    TABLES NUM_Indiv;
RUN;
/*zo ja reduceer dan tot 1 lijn*/
PROC SORT DATA=RVA;
    BY GECODEERD_INSZ fiche7_2008 fiche61_2008 bedragen_2008;
RUN;
DATA RVA;
    SET RVA;
    BY GECODEERD_INSZ fiche7_2008 fiche61_2008 bedragen_2008;

    RETAIN DAGEN_AGG BEDRAGEN_AGG URENPWA_AGG 0;

    IF FIRST.GECODEERD_INSZ THEN DO;
        DAGEN_AGG       = 0;
        BEDRAGEN_AGG    = 0;    
        URENPWA_AGG     = 0;                
        IF DAGEN_2008 NE .    THEN DAGEN_AGG    = DAGEN_2008;
        IF BEDRAGEN_2008 NE . THEN BEDRAGEN_AGG = BEDRAGEN_2008;    
        IF URENPWA_2008 NE .  THEN URENPWA_AGG  = URENPWA_2008;                
    END;    
    ELSE DO;
        IF DAGEN_2008 NE .    THEN DAGEN_AGG    = DAGEN_AGG     + DAGEN_2008;
        IF BEDRAGEN_2008 NE . THEN BEDRAGEN_AGG = BEDRAGEN_AGG  + BEDRAGEN_2008;    
        IF URENPWA_2008 NE .  THEN URENPWA_AGG  = URENPWA_AGG   + URENPWA_2008;                
    END;        

    DROP DAGEN_2008 BEDRAGEN_2008 URENPWA_2008;
    
    IF LAST.GECODEERD_INSZ THEN OUTPUT;
RUN;    
/*Test of een individu nog meer dan 1 keer voorkomt in het bestand*/
PROC SQL;
    CREATE TABLE COUNT_Indiv AS
    SELECT COUNT(*) AS NUM_Indiv
    FROM RVA
    GROUP BY GECODEERD_INSZ
    ;
QUIT;
PROC FREQ DATA=COUNT_Indiv;
    TITLE "Frequentie van het aantal keer dat een individu voorkomt in het bestand: na reductie";
    TABLES NUM_Indiv;
RUN;
DATA MIM2008_RVA;
    MERGE TOTPOP(in=InA) RVA(in=InB);
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;

    /*Maak variabele die aangeeft dat een individu voorkomt in een gegeven bestand: handig voor latere verwerking van rechten*/
    InRVA = 0;
    IF InB EQ 1 THEN InRVA = 1;
    LABEL InRVA = "Individu geselecteerd uit basisdata RVA voor verwerking steekproef";

    /*Rename*/
    DAGEN_2008      =   DAGEN_AGG;
    BEDRAGEN_2008   =   BEDRAGEN_AGG;
    URENPWA_2008    =   URENPWA_AGG;

    /*Labels*/
    LABEL DAGEN_2008      = "Aantal dagen waarvoor een werkloosheidsuitkering wordt ontvangen (2008)";                                                                                                                      
    LABEL BEDRAGEN_2008   = "bedrag van de werkloosheidsuitkering ontvangen tijdens het kwartaal (2008)";                                                                                                                    
    LABEL URENPWA_2008    = "Aantal uren gewerkt in het kader van PWA gedurende het kwartaal (2008)";                                                                                                                       

    IF FICHE7_2008    EQ . THEN FICHE7_2008    = 0;               
    IF DAGEN_2008     EQ . THEN DAGEN_2008     = 0;                             
    IF DGNDMND_2008   EQ . THEN DGNDMND_2008   = 0;                             
    IF BEDRAGEN_2008  EQ . THEN BEDRAGEN_2008  = 0;                             
    IF DUUR_2008      EQ . THEN DUUR_2008      = 0;                             
    IF URENPWA_2008   EQ . THEN URENPWA_2008   = 0;                            
    IF FICHE61_2008   EQ . THEN FICHE61_2008   = 0;   
    
    UVW = 0;
    IF FICHE7_2008 IN (1, 2, 3, 4, 5, 7, 8, 9, 10, 11, 13, 14, 15, 26, 27, 28, 29, 30, 31, 32, 40, 41, 42, 43, 44, 46, 47) THEN UVW = 1;
    
    KEEP
    gecodeerd_insz
    FICHE7_2008   
    DAGEN_2008    
    DGNDMND_2008  
    BEDRAGEN_2008 
    REDENLO_2008  
    DUUR_2008     
    URENPWA_2008  
    FICHE61_2008  
    InRVA  
    UVW
    MIMOSIS_WEIGHT
    ;

RUN;
/*Kernels werkloosheidsduur*/
PROC KDE DATA=MIM2008_RVA(WHERE=(UVW=1));
    UNIVAR DUUR_2008 /  GRIDL=0 GRIDU=180 NG=100 OUT=KERNEL_OUT1;
    WEIGHT MIMOSIS_WEIGHT;
RUN;
PROC PRINT DATA=KERNEL_OUT1;
RUN;
DATA LIBW.MIM2008_RVA;
    SET MIM2008_RVA;
    DROP UVW MIMOSIS_WEIGHT;
RUN;    
PROC FREQ DATA=LIBW.MIM2008_RVA;
    TABLES InRVA FICHE7_2008;
RUN;
PROC CONTENTS DATA=LIBW.MIM2008_RVA;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
