/*
Programma maakt data-set met indicators van de bronnen waarin individuen uit de MIMOSIS-steekproef
geobserveerd worden
*/    
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateStatusInfo_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\CreateStatusInfo.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

DM 'Log; CLEAR; Output; Clear; ';

/*Zet bibliotheek-namen*/
LIBNAME LIB     'C:\My\teksten\MIMS2009\DataFS\ORIG\';
LIBNAME LIBW    'C:\My\teksten\MIMS2009\DataFS\MANIP\';

/*Vraag steekproefnummers totale steekproef op*/
PROC SQL;
    CREATE TABLE Indiv_TOTPOP AS
    SELECT DISTINCT GECODEERD_INSZ
    FROM   LIBW.POPCHAR_2009
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in CIMIRe*/
PROC SQL;
    CREATE TABLE Indiv_CIMIRE AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_CIMIRe
    FROM   LIBW.careerinfo
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in NIC*/
PROC SQL;
    CREATE TABLE Indiv_NIC AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_NIC
    FROM   LIB.mim2008_nic_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in POD MI*/
PROC SQL;
    CREATE TABLE Indiv_PODMI AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_PODMI
    FROM   LIB.mim2008_podmi_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in Pensioenkadaster*/
PROC SQL;
    CREATE TABLE Indiv_PensCad AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_PensCad
    FROM   LIB.mim2008_rvp_nationaallegaal_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in RKW_RG*/
PROC SQL;
    CREATE TABLE Indiv_RKW_RG AS
    SELECT DISTINCT GECODEERD_INSZ_RG AS GECODEERD_INSZ, 1 AS IndivIn_RKW_RG
    FROM   LIB.mim2008_rkw_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in RKW_RH*/
PROC SQL;
    CREATE TABLE Indiv_RKW_RH AS
    SELECT DISTINCT GECODEERD_INSZ_RH AS GECODEERD_INSZ, 1 AS IndivIn_RKW_RH
    FROM   LIB.mim2008_rkw_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in RKW_BT*/
PROC SQL;
    CREATE TABLE Indiv_RKW_BT AS
    SELECT DISTINCT GECODEERD_INSZ_BT AS GECODEERD_INSZ, 1 AS IndivIn_RKW_BT
    FROM   LIB.mim2008_rkw_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in RSVZ_KB_RG*/
PROC SQL;
    CREATE TABLE Indiv_RSVZ_KB_RG AS
    SELECT DISTINCT GECODEERD_INSZ_RG AS GECODEERD_INSZ, 1 AS IndivIn_RSVZ_KB_RG
    FROM   LIB.mim2008_rsvz_kb_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in RSVZ_KB_RH*/
PROC SQL;
    CREATE TABLE Indiv_RSVZ_KB_RH AS
    SELECT DISTINCT GECODEERD_INSZ_RH AS GECODEERD_INSZ, 1 AS IndivIn_RSVZ_KB_RH
    FROM   LIB.mim2008_rsvz_kb_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in RSVZ_KB_BT*/
PROC SQL;
    CREATE TABLE Indiv_RSVZ_KB_BT AS
    SELECT DISTINCT GECODEERD_INSZ_BT AS GECODEERD_INSZ, 1 AS IndivIn_RSVZ_KB_BT
    FROM   LIB.mim2008_rsvz_kb_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in RVA*/
PROC SQL;
    CREATE TABLE Indiv_RVA AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_RVA
    FROM   LIB.mim2008_rva_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in FAO*/
PROC SQL;
    CREATE TABLE Indiv_FAO AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_FAO
    FROM   LIB.mim2008_fao_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in FBZ*/
PROC SQL;
    CREATE TABLE Indiv_FBZ AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_FBZ
    FROM   LIB.mim2008_fbz_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in RIZIV*/
PROC SQL;
    CREATE TABLE Indiv_RIZIV AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_RIZIV
    FROM   LIB.mim2008_riziv_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Gegevens FOD SZ*/
DATA FOD_SZ;
    SET
    LIB.mim2008_fodsz_med081_new_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_fodsz_med082_new_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_fodsz_med083_new_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_fodsz_med084_new_code(KEEP=GECODEERD_INSZ)
    ;
RUN;    
PROC SQL;
    CREATE TABLE Indiv_FOD_SZ AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_FOD_SZ
    FROM   FOD_SZ
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Unieke individuen in arbeidsmarktgegevens vanaf 1997*/
PROC SQL;
    CREATE TABLE Indiv_LABM97 AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_LABM97
    FROM   LIB.mim2008_labmstatcombin_1997_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Gegevens RSVZ*/
DATA RSVZ;
    SET
    LIB.mim2008_rsvz_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rsvzinc2005_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rsvzinc2006_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rsvzinc2007_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rsvzinc2008_code(KEEP=GECODEERD_INSZ)
    ;
RUN;    
PROC SQL;
    CREATE TABLE Indiv_RSVZ AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_RSVZ
    FROM   RSVZ
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Gegevens RSZPPO_QUART*/
PROC SQL;
    CREATE TABLE Indiv_RSZPPO_QUART AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_RSZPPO_QUART
    FROM   LIB.mim2008_rszppoquart_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Gegevens RSZPPO_20022008*/
DATA RSZPPO_20022008;
    SET
    LIB.mim2008_rszppoyear_2002_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszppoyear_2003_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszppoyear_2004_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszppoyear_2005_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszppoyear_2006_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszppoyear_2007_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszppoyear_2008_code(KEEP=GECODEERD_INSZ)
    ;
RUN;    
PROC SQL;
    CREATE TABLE Indiv_RSZPPO_20022008 AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_RSZPPO_20022008
    FROM   RSZPPO_20022008
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Gegevens RSZ_QUART*/
PROC SQL;
    CREATE TABLE Indiv_RSZ_QUART AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_RSZ_QUART
    FROM   LIB.mim2008_rszquart_code
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Gegevens RSZ_20022008*/
DATA RSZ_20022008;
    SET
    LIB.mim2008_rszyear_2002_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszyear_2003_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszyear_2004_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszyear_2005_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszyear_2006_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszyear_2007_code(KEEP=GECODEERD_INSZ)
    LIB.mim2008_rszyear_2008_code(KEEP=GECODEERD_INSZ)
    ;
RUN;    
PROC SQL;
    CREATE TABLE Indiv_RSZ_20022008 AS
    SELECT DISTINCT GECODEERD_INSZ, 1 AS IndivIn_RSZ_20022008
    FROM   RSZ_20022008
    ORDER BY GECODEERD_INSZ
    ;
QUIT;
/*Gewichten*/
DATA Weights;
    SET LIBW.popchar_2009(KEEP = GECODEERD_INSZ MIMOSIS_WEIGHT);
RUN;    
PROC SORT DATA=Weights;
    BY GECODEERD_INSZ;
RUN;    
/*Combineer bestanden in 1 file*/
DATA LIBW.StatusInfo;
    MERGE Indiv_TOTPOP(in=InA) Indiv_CIMIRE Indiv_NIC Indiv_PODMI Indiv_PensCad Indiv_RKW_RG Indiv_RKW_RH Indiv_RKW_BT Indiv_RSVZ_KB_RG Indiv_RSVZ_KB_RH Indiv_RSVZ_KB_BT Indiv_RVA Indiv_FAO Indiv_FBZ Indiv_RIZIV Indiv_FOD_SZ Indiv_LABM97 Indiv_RSVZ Indiv_RSZPPO_QUART Indiv_RSZPPO_20022008 Indiv_RSZ_QUART Indiv_RSZ_20022008 Weights;
    BY GECODEERD_INSZ;
    
    IF InA EQ 1;
    
    IF IndivIn_CIMIRE             EQ . THEN IndivIn_CIMIRE = 0;
    IF IndivIn_NIC                EQ . THEN IndivIn_NIC = 0; 
    IF IndivIn_PODMI              EQ . THEN IndivIn_PODMI = 0; 
    IF IndivIn_PensCad            EQ . THEN IndivIn_PensCad = 0; 
    IF IndivIn_RKW_RG             EQ . THEN IndivIn_RKW_RG = 0; 
    IF IndivIn_RKW_RH             EQ . THEN IndivIn_RKW_RH = 0; 
    IF IndivIn_RKW_BT             EQ . THEN IndivIn_RKW_BT = 0; 
    IF IndivIn_RSVZ_KB_RG         EQ . THEN IndivIn_RSVZ_KB_RG = 0;
    IF IndivIn_RSVZ_KB_RH         EQ . THEN IndivIn_RSVZ_KB_RH = 0;
    IF IndivIn_RSVZ_KB_BT         EQ . THEN IndivIn_RSVZ_KB_BT = 0;
    IF IndivIn_RVA                EQ . THEN IndivIn_RVA = 0;
    IF IndivIn_FAO                EQ . THEN IndivIn_FAO = 0; 
    IF IndivIn_FBZ                EQ . THEN IndivIn_FBZ = 0; 
    IF IndivIn_RIZIV              EQ . THEN IndivIn_RIZIV = 0; 
    IF IndivIn_FOD_SZ             EQ . THEN IndivIn_FOD_SZ = 0; 
    IF IndivIn_LABM97             EQ . THEN IndivIn_LABM97 = 0; 
    IF IndivIn_RSVZ               EQ . THEN IndivIn_RSVZ = 0; 
    IF IndivIn_RSZPPO_QUART       EQ . THEN IndivIn_RSZPPO_QUART = 0; 
    IF IndivIn_RSZPPO_20022008    EQ . THEN IndivIn_RSZPPO_20022008 = 0; 
    IF IndivIn_RSZ_QUART          EQ . THEN IndivIn_RSZ_QUART = 0;
    IF IndivIn_RSZ_20022008       EQ . THEN IndivIn_RSZ_20022008 = 0;

    LABEL IndivIn_CIMIRE          = "Individu gekend in bestand CIMIRe";
    LABEL IndivIn_NIC             = "Individu gekend in bestand Nationaal Intermutualisch College in 2008";
    LABEL IndivIn_PODMI           = "Individu gekend bij de POD Maatschappelijke Integratie in 2008";
    LABEL IndivIn_PensCad         = "Individu gekend in het Pensioenkadaster in 2008";
    LABEL IndivIn_RKW_RG          = "Individu gekend als rechtgevende kinderbijslag bij de RKW in 2008";
    LABEL IndivIn_RKW_RH          = "Individu gekend als rechthebbende kinderbijslag bij de RKW in 2008";
    LABEL IndivIn_RKW_BT          = "Individu gekend als bijslagtrekkende kinderbijslag bij de RKW in 2008";
    LABEL IndivIn_RSVZ_KB_RG      = "Individu gekend als rechtgevende kinderbijslag bij de RSVZ in 2008";
    LABEL IndivIn_RSVZ_KB_RH      = "Individu gekend als rechthebbende kinderbijslag bij de RSVZ in 2008";
    LABEL IndivIn_RSVZ_KB_BT      = "Individu gekend als bijslagtrekkende kinderbijslag bij de RSVZ in 2008";
    LABEL IndivIn_RVA             = "Individu gekend bij de RVA in 2008";
    LABEL IndivIn_FAO             = "Individu gekend bij het FAO in 2008";
    LABEL IndivIn_FBZ             = "Individu gekend bij het FBZ in 2008";
    LABEL IndivIn_RIZIV           = "Individu gekend bij het RIZIV in 2008";
    LABEL IndivIn_FOD_SZ          = "Individu gekend in bestanden erkenning handicap van de FOD SZ in 2008";
    LABEL IndivIn_LABM97          = "Individu was gedurende minstens 1 dag op private of publieke arbeidsmarkt in periode 1997-2008";
    LABEL IndivIn_RSVZ            = "Individu gekend bij de RSVZ in 2008";
    LABEL IndivIn_RSZPPO_QUART    = "Individu gekend in bestand RSZPPO van 4de kwartaal 2008";
    LABEL IndivIn_RSZPPO_20022008 = "Individu gekend in bestand RSZPPO voor de periode 2002 tot 2008";
    LABEL IndivIn_RSZ_QUART       = "Individu gekend in bestand RSZ van 4de kwartaal 2008";
    LABEL IndivIn_RSZ_20022008    = "Individu gekend in bestand RSZ voor de periode 2002 tot 2008";
    
RUN;
/*Analyse*/
PROC FREQ DATA=LIBW.StatusInfo(WHERE=(IndivIn_RIZIV=1));
    TABLES IndivIn_CIMIRE IndivIn_NIC IndivIn_PODMI IndivIn_PensCad IndivIn_RKW_RG IndivIn_RKW_RH IndivIn_RKW_BT IndivIn_RSVZ_KB_RG IndivIn_RSVZ_KB_RH IndivIn_RSVZ_KB_BT IndivIn_RVA IndivIn_FAO IndivIn_FBZ IndivIn_RIZIV IndivIn_FOD_SZ IndivIn_LABM97 IndivIn_RSVZ IndivIn_RSZPPO_20022008 IndivIn_RSZ_20022008 IndivIn_RSZPPO_QUART IndivIn_RSZ_QUART;
RUN;    
PROC CONTENTS DATA=LIBW.StatusInfo;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;
