/*Set name of log-file and make it empty before start*/
FILENAME mylog 'C:\My\teksten\MIMS2009\DataFS\ProgManip\NumCareerYear_Ext.log';
FILENAME myout 'C:\My\teksten\MIMS2009\DataFS\ProgManip\NumCareerYear.txt';
DATA _NULL_; 
    FILE mylog;
RUN;
DATA _NULL_; 
    FILE myout;
RUN;
PROC PRINTTO LOG=mylog PRINT=myout;
RUN;

DM 'Log; CLEAR; Output; Clear; ';

/*loopbaanjaren op basis van voorstel Anke van 6 juni 2010: Operationalisering volledige loopbaan*/
LIBNAME    LIBW 'C:\My\teksten\MIMS2009\DataFS\MANIP\';
DATA CareerY;

    SET 
    LIBW.careerinfo(KEEP = GECODEERD_INSZ ASSIMDAYS REMDAYS)
    LIBW.careerinfo_since2002(KEEP = GECODEERD_INSZ ASSIMDAYS REMDAYS)
    ;

    DAYS = ASSIMDAYS + REMDAYS;
RUN;
PROC SORT DATA=CareerY;
    BY GECODEERD_INSZ;
RUN;
DATA CareerY;
    SET CareerY;
    BY GECODEERD_INSZ;

    RETAIN MINPENS_NUMCYEAR 0;
    
    IF FIRST.GECODEERD_INSZ THEN DO;
        MINPENS_NUMCYEAR = 0;
        IF DAYS GE 185 THEN MINPENS_NUMCYEAR = 1;
    END;
    ELSE DO;
        IF DAYS GE 185 THEN MINPENS_NUMCYEAR = MINPENS_NUMCYEAR + 1;
    END;
    
    IF LAST.GECODEERD_INSZ THEN OUTPUT;

    KEEP GECODEERD_INSZ MINPENS_NUMCYEAR;
RUN;    
/*Limiteer gegevens tot gevallen in de steekproef*/
DATA TOTPOP;
    SET LIBW.POPCHAR_2009(KEEP=GECODEERD_INSZ);
RUN;
PROC SORT DATA=TOTPOP;
    BY GECODEERD_INSZ;
RUN;
/*Voeg gegevens samen*/
DATA LIBW.CareerY;

    MERGE CareerY TOTPOP(in=InA);
    BY GECODEERD_INSZ;

    IF InA EQ 1;
    
    IF MINPENS_NUMCYEAR EQ . THEN MINPENS_NUMCYEAR = -1;
    
RUN;
PROC FREQ DATA=LIBW.CareerY;
    TABLES MINPENS_NUMCYEAR;
RUN; 
PROC CONTENTS DATA=LIBW.CareerY;
RUN;
/*einde programma*/
PROC PRINTTO LOG=LOG PRINT=PRINT;
RUN;

 







    
